unit Graph13h;
                {$G+}
  interface

    const xres=320;        {horizontalne rozlisenie}
          yres=200;        {vertikalne rozlisenie}
          aspectratio=1.2; {pomer vysky a sirky bodu}

    type trgbcolor=record
                     r,g,b:byte;
                   end;
         trgbpalette=array[0..255] of trgbcolor;

    var vramseg:word;      {segment aktivnej stranky}

    function InitGraph13h:boolean;
    procedure CloseGraph13h;
    procedure SetActivePage13h(aseg:word);
    procedure ShowScreen13h;
    procedure ClearScreen13h(color:byte);
    procedure GetRGBColor13h(color:byte; var rgbcolor:trgbcolor);
    procedure SetRGBColor13h(color:byte; var rgbcolor:trgbcolor);
    procedure GetRGBPalette13h(var rgbpalette:trgbpalette);
    procedure SetRGBPalette13h(var rgbpalette:trgbpalette);
    function  GetPixel13h(x,y:integer):byte;
    procedure PutPixel13h(x,y:integer; color:byte);
    procedure XorPixel13h(x,y:integer; color:byte);
    procedure Line13h(x1,y1,x2,y2:integer; color:byte);
    procedure Bar13h(x1,y1,x2,y2:integer; color:byte);
    procedure FourAngle13h(x1,y1,x2,y2,x3,y3,x4,y4:integer; color:byte);


  implementation

    type intpoint2d=record
                      x,y:integer;
                    end;
    var p386:boolean;
        oldmode:byte;
        oldpalette:trgbpalette;
        miny,maxy:word;
        lrtable:word;
        spbuffer:word;
        pointa,pointb,pointc,pointd:intpoint2d;
        lefttable,righttable:array[0..199] of word;


    {$L proc32.obj}

    function ChckProcessor:boolean; far; external;

    procedure ShowScreen13h32; far; external;

    procedure ClearScreen13h32(color:byte); far; external;
    {ako ShowScreen13h a ClearScreen13h, ale vyuzivaju 32bit movsd, stosd}


    function InitGraph13h:boolean;
      var ok13h:boolean;
      begin
      asm                 {zapamata si povodny mod a palettu nastavi VGA13h}
        mov    ah,0Fh
        int    10h
        mov    [oldmode],al      {zistenie a ulozenie aktualneho rezimu}

        mov    ax,13h
        int    10h               {nastavenie VGA13h}

        mov    ah,0Fh            {zisti, ci sa podarilo nastavit}
        int    10h
        cmp    al,13h
        mov    [ok13h],0
        jnz    @InitGraph13hExit {ak nie ok13=false, a koniec}
        inc    byte ptr[ok13h]   {inak ok13h:=true a odloz aj paletu}

        xor    bx,bx             {od 0. DAC registra}
        mov    cx,256            {vsetkych 256 DAC registrov}
        mov    ax,Seg(oldpalette)
        mov    es,ax
        mov    dx,offset oldpalette {es:dx ukazuje na tab. rgb hodnot}
        mov    ax,1017h          {sluzba: citaj blok DAC registrov}
        int    10h               {uloz povodnu paletu}
      @InitGraph13hExit:
      end;
        if ok13h then
          begin InitGraph13h:=true; vramseg:=$A000; end
        else InitGraph13h:=false;
      end;


    procedure CloseGraph13h; assembler;
      asm                  {obnovi povodny mod a paletu}
        xor    bx,bx             {od 0. DAC registra}
        mov    cx,256            {vsetkych 256 DAC registrov}
        mov    ax,Seg(oldpalette)
        mov    es,ax
        mov    dx,offset oldpalette {es:dx ukazuje na tab. rgb hodnot}
        mov    ax,1012h          {sluzba: nastav blok DAC registrov}
        int    10h               {nastav povodnu paletu}

        mov    al,[oldmode]
        xor    ah,ah
        int    10h               {nastav povodny graficky mod}
      end;


    procedure SetActivePage13h(aseg:word);
      {nastavi segment aktivnej stranky na aseg}
      begin
        vramseg:=aseg;
      end;


    procedure ShowScreen13h;
      {prenesie vnutornu obrazovku do VRAM}
      begin
        if p386 then ShowScreen13h32
        else
          asm
            push   ds
            mov    ds,[vramseg]
            xor    si,si
            mov    ax,$A000
            mov    es,ax
            xor    di,di
            mov    cx,32000
            rep    movsw
            pop    ds
          end;
      end;


    procedure ClearScreen13h(color:byte);
      {vyplni obrazovku farbou color}
      begin
        if p386 then ClearScreen13h32(0)
        else
          asm
            mov    es,[vramseg]
            xor    di,di
            mov    al,[bp+6]
            mov    ah,al
            mov    cx,32000
            rep    stosw
          end;
      end;


    procedure GetRGBColor13h(color:byte; var rgbcolor:trgbcolor); assembler;
      asm                    {zisti R,G,B zlozky jednej farby}
        mov    bx,[bp+10]        {es:bx <- adresu rgbcolor}
        xor    bh,bh             {bx <- color - cislo farby}
        mov    ax,1015h          {sluzba citaj 1 DAC register}
        int    10h
        les    bx,[bp+6]         {es:bx <- adresu rgbcolor}
        mov    es:[bx],dh        {uloz R}
        mov    es:[bx+1],ch      {     G}
        mov    es:[bx+2],cl      {     B zlozky do rgbcolor}
      end;


    procedure SetRGBColor13h(color:byte; var rgbcolor:trgbcolor); assembler;
      asm                    {nastavi R,G,B zlozky 1 farby}
        les    bx,[bp+6]         {es:bx <- adresu rgbcolor}
        mov    dh,es:[bx]        {dh <- R zlozka}
        mov    ch,es:[bx+1]      {ch <- G zlozka}
        mov    cl,es:[bx+2]      {cl <- B zlozka}
        mov    bx,[bp+10]
        xor    bh,bh             {bx <- color - cislo farby}
        mov    ax,1010h          {sluzba nastav 1 DAC register}
        int    10h
      end;


    procedure GetRGBPalette13h(var rgbpalette:trgbpalette); assembler;
      asm                   {nacita aktualnu paletu do premennej rgbpalette}
        xor    bx,bx             {od 0. DAC registra}
        mov    cx,256            {vsetkych 256 DAC registrov}
        les    dx,[bp+6]         {es:dx ukazuje na premennu rgbpalette}
        mov    ax,1017h          {sluzba: citaj blok DAC registrov}
        int    10h               {citaj paletu}
      end;


    procedure SetRGBPalette13h(var rgbpalette:trgbpalette); assembler;
      asm                  {nastavi palettu z premennej rgbpalette}
        xor    bx,bx             {od 0. DAC registra}
        mov    cx,256            {vsetkych 256 DAC registrov}
        les    dx,[bp+6]         {es:dx ukazuje na premennu rgbpalette}
        mov    ax,1012h          {sluzba: nastav blok DAC registrov}
        int    10h               {nastav paletu}
      end;


    function  GetPixel13h(x,y:integer):byte; assembler;
      asm                    {vrati farbu bodu na pozicii x,y}
        mov    bx,[bp+6]         {vezmi y}
        mov    ah,bl
        xor    al,al             {ax <- 256*y}
        shl    bx,6              {bx <- 64*y}
        add    bx,ax             {bx <- 320*y}
        add    bx,[bp+8]         {bx <- 320*y+x}
        mov    es,[vramseg]      {es <- segment VRAM}
        mov    al,es:[bx]        {citaj farbu z es:bx}
      end;


    procedure PutPixel13h(x,y:integer; color:byte); assembler;
      asm                   {kresli bod farby color na pozicii x,y}
        mov    bx,[bp+8]         {vezmi y}
        mov    ah,bl
        xor    al,al             {ax <- 256*y}
        shl    bx,6              {bx <- 64*y}
        add    bx,ax             {bx <- 320*y}
        add    bx,[bp+10]        {bx <- 320*y+x}
        mov    es,[vramseg]      {es <- segment VRAM}
        mov    al,[bp+6]
        mov    es:[bx],al        {zapis farbu na es:bx}
      end;


    procedure XorPixel13h(x,y:integer; color:byte); assembler;
      asm                   {kresli bod farby color na pozicii x,y}
        mov    bx,[bp+8]         {vezmi y}
        mov    ah,bl
        xor    al,al             {ax <- 256*y}
        shl    bx,6              {bx <- 64*y}
        add    bx,ax             {bx <- 320*y}
        add    bx,[bp+10]        {bx <- 320*y+x}
        mov    es,[vramseg]      {es <- segment VRAM}
        mov    al,[bp+6]
        xor    es:[bx],al        {zapis farbu na es:bx}
      end;


    procedure Line13h(x1,y1,x2,y2:integer; color:byte); assembler;
      asm                 {nakresli ciaru z x1,y1 do x2,y2 farby color}
                          {x1,x2 in 0..319, y1,y2 in 0..199 - nekontroluje}
        mov    es,[vramseg]
        mov    al,[bp+6]         {do al farbu}
        mov    bx,[bp+8]         {bx <- y2}
        mov    si,[bp+10]        {si <- x2}
        mov    di,[bp+12]        {di <- y1}
        mov    cx,[bp+14]        {cx <- x1}
        push   bp

        sub    bx,di             {bx:=deltay=y2-y1}
        jns    @DyOK             {ak deltay je zaporne}
        add    bx,di             {obnov bx}
        xchg   bx,di             {a vymen body, aby horny}
        xchg   cx,si             {(s mensim y) bol v cx,di}
        sub    bx,di             {teraz uz spravne deltay do bx}

{! dalsi blok pri trasovani pada ak dx<0, asi ked bp=65535 problem s hranicou
 segmentu, aj ked by pascal nemal teraz pouzivat bp}
      @DyOK:
        cld                      {ak x2>=x1 tak ciara}
        mov    bp,1              {doprava => df:=0, bp:=1}
        sub    si,cx             {si:=deltax}
        jns    @DxOK
        std                      {ak x2<x1 tak ciara}
        neg    bp                {dolava => df:=1, bp:=-1}
        neg    si                {si:=spravne deltax}

      @DxOK:
        shl    di,6
        mov    dx,di
        shl    di,2
        add    di,dx
        add    di,cx             {vypocitaj adresu 1.bodu}
        cmp    bx,si             {ak deltay>deltax, tak vertikalna ciara}
        ja     @Vertical         {inac horizontalna}

      @Horizontal:
        mov    cx,si             {count:=deltax}
        shl    bx,1              {bx:=2*deltay}
        mov    dx,bx
        sub    dx,si             {dx:=predikcia1=2*deltay-deltax}
        shl    si,1              {si:=2deltax}
        stosb                    {nakresli 1.bod, posun}
        and    dx,dx             {a nastav priznaky}
        jcxz   @LineExit

      @HorLoop:
        js     @HStep            {ak pred.<0, tak horiz. krok}
      @DStep:
        add    di,320            {inac diag. => posun o bod dole}
        sub    dx,si             {predikcia:=predikcia-2*deltax}
      @HStep:
        add    dx,bx             {predikcia:=predikcia+2*deltay}
        stosb                    {kresli bod a posun l/r podla df}
        loop   @HorLoop          {vsetkych count bodov}
        jmp    @LineExit

      @Vertical:
        cld                      {smer bude urcovany podla bp}
        mov    cx,bx             {do count deltay}
        shl    si,1              {si:=2*deltax}
        mov    dx,si
        sub    dx,bx             {dx:=predikcia1=2deltax-deltay}
        shl    bx,1              {bx:=2*deltay}
        stosb                    {nakresli 1.bod a posun doprava}
        add    di,319            {posun dole}
        and    dx,dx             {a nastav priznaky}
        jcxz   @LineExit

      @VertLoop:
        js     @VStep            {ak predikcia<0, tak vert. krok}
      @DStep2:
        add    di,bp             {inac diag. =>posun l/r podla bp}
        sub    dx,bx             {predikcia:=predikcia-2deltay}
      @VStep:
        stosb                    {kresli bod a posun doprava}
        add    di,319            {posun dole}
        add    dx,si             {predikcia:=predikcia+2deltax}
        loop   @VertLoop         {(az tu aby sa neznicili flagy)}
                                 {vsetkych count bodov}
      @LineExit:
        pop    bp
      end;


    procedure Bar13h(x1,y1,x2,y2:integer; color:byte); assembler;
      asm      {kresli obdlznik s rohmi x1,y1 a x2,y2 vyplneny farbou color}
               {x1<x2, y1<y2, x1,x2 in 0..319, y1,y2 in 0..199}
               {spravnost vstupu sa nekontroluje}
        mov    dx,[bp+8]         {vezmi y2}
        mov    di,[bp+12]        {y1}
        sub    dx,di             {dx <- deltay}
        js     @BarExit          {ak deltay<0, koniec}

        mov    bx,[bp+10]        {x2}
        sub    bx,[bp+14]        {bx <- deltax}
        js     @BarExit          {ak deltax<0, koniec}

        inc    dx                {pocet vykreslenych bodov je o 1 vacsi}
        inc    bx                {ako delta(x,y)}
        shl    di,6
        mov    ax,di
        shl    di,2
        add    di,ax             {di <- 320*y1}
        add    di,[bp+14]        {di <- 320*y1+x1}
        mov    si,320
        sub    si,bx             {si <- #bajtov na posun na dalsi riadok}
        mov    es,[vramseg]      {es <- segment VRAM}
        mov    ax,[bp+6]
        mov    ah,al             {ah, al <- color}
        cld

      @NextLine:
        mov    cx,bx
        shr    cx,1
        jnc    @DeltaxEven
        stosb
      @DeltaxEven:
        rep    stosw
        add    di,si
        dec    dx
        jnz    @NextLine

      @BarExit:
      end;


    procedure LineToTable; assembler;
      asm     {ulozi x suradnice bodov ciary do Left/RightTable (ncf)}
              {ak ciara smeruje hore nic neulozi a vrati sa cf}
              {in: ax=x2, bx=x1, si=y2, di=y1}
              {out: ncf/cf - done/smeruje hore}
              {meni: ax,bx,cx,dx,si,di,bp,es,f}

        mov    cx,si
        sub    cx,di             {cx:=deltay}
        jle    @LineExit         {ak deltay0,ciara smeruje hore koniec s cf}

      @MinUpdate:
        cmp    di,[miny]         {ak y1 je mensie ako doteraz minimalne y}
        jge    @MaxUpdate
        mov    [miny],di         {aktualizuj ho}
      @MaxUpdate:
        cmp    si,[maxy]         {ak y2 je vacsie ako max}
        jle    @PrepParams
        mov    [maxy],si         {aktualizuj ho}


      @PrepParams:
        sub    ax,bx             {ax:=deltax}
        cwd                      {priprav na delenie}
        idiv   cx                {a vydel deltax/deltay}
        mov    bp,ax             {cela cast prirastku do bp}
        xor    ax,ax             {zvysok del 2}
        sar    dx,1              {(aby vysledok vosiel do 2^15-1)}
        rcr    ax,1
        idiv   cx                {a vydel deltay}
        shl    ax,1              {a naspat vynasob 2}
        sbb    bp,0              {a uprav celu cast prirastku}
        push   ax                {odloz desatinnu cast prirastku}
        inc    cx                {rataju sa obidva koncove body}


        mov    ax,bx             {do ax cela cast x1}
        mov    bx,8000h          {do bx desatinna ()}
        mov    dx,bp             {dx cela cast prirastku}
        pop    bp                {bp desatinna}
        shl    di,1              {kazda polozka v tabulke ma 2B -> di:=2*y1}
        add    di,[lrtable]      {a prirataj zaciatok tabulky}
        push   ds                {es:=ds}
        pop    es
        cld

      @StoreLoop:
        stosw                    {uloz celu cast x}
        add    bx,bp             {prirataj celu a}
        adc    ax,dx             {desatinnu cast prirastku}
        loop   @StoreLoop        {pre celu ciaru}

        clc                      {koniec s ncf}
      @LineExit:
        ret
      end;


    procedure FourAngle13h(x1,y1,x2,y2,x3,y3,x4,y4:integer; color:byte); assembler;
      {nakresli 4-uholnik s vrcholmi (x1,y1)..(x4,y4) vyplneny farbou color}
      {neorezava, vrcholy musia byt zadane v kladnom smere}
      asm
        mov    word ptr[miny],200 {inicializuj minimum}
        mov    word ptr[maxy],0  {a maximum}

        push   bp
        mov    [spbuffer],sp

        mov    ax,[bp+20]
        mov    si,[bp+22]
        mov    bx,[bp+16]
        mov    di,[bp+18]
        mov    dx,[bp+8]
        mov    sp,[bp+10]
        mov    cx,[bp+12]
        mov    bp,[bp+14]        {x1,x2,x3,x4 = si,di,bp,sp}
                                 {y1,y2,y3,y4 = ax,bx,cx,dx}
      @CompareAB:
        cmp    ax,bx             {porovnaj y1 s y2}
        jle    @CompareAC        {ak je 1.bod vyssie ako 2. OK inac:}
        xchg   ax,bx             { ax < bx < cx < dx <Ŀ}
        xchg   bx,cx             {}
        xchg   cx,dx
        xchg   si,di             { si < di < bp < sp <Ŀ}
        xchg   di,bp             {}
        xchg   bp,sp
        jmp    @CompareAB        {a porovnaj nove udaje}

      @CompareAC:
        cmp    ax,cx             {porovnaj y1 s y3}
        jle    @CompareAD        {ak je 1.bod vyssie OK inac:}
        xchg   ax,cx             {eax <> ecx, ecx <> edx}
        xchg   bx,dx
        xchg   si,bp             {esi <> edi, ebp <> esp}
        xchg   di,sp
        jmp    @CompareAB        {a porovnaj nove udaje}

      @CompareAD:
        cmp    ax,dx             {porovnaj y1 s y4}
        jle    @StorePoints      {ak je 1.bod vyssie OK inac:}
        xchg   ax,dx             {> ax > bx > cx > dx }
        xchg   cx,dx             {}
        xchg   bx,cx
        xchg   si,sp             {> si > di > bp > sp }
        xchg   bp,sp             {}
        xchg   di,bp


      @StorePoints:
        mov    [pointa.x],si     {uloz body}
        mov    [pointa.y],ax     {v ax,si je teraz x,y bodu,}
        mov    [pointb.x],di     {ktory je najvyssie,}
        mov    [pointb.y],bx     {ostatne body su}
        mov    [pointc.x],bp     {v povodnom poradi}
        mov    [pointc.y],cx     {(v kladnom smere)}
        mov    [pointd.x],sp
        mov    [pointd.y],dx

        mov    sp,[spbuffer]     {obnov esp}

      @LeftBranch:
        mov    word ptr[lrtable],offset lefttable
        mov    ax,[pointb.x]     {ciaru z A do B}
        mov    bx,[pointa.x]     {A je najvyssie}
        mov    si,[pointb.y]
        mov    di,[pointa.y]
        call   LineToTable

        mov    ax,[pointc.x]     {skus dalsiu}
        mov    bx,[pointb.x]     {ciaru z B do C}
        mov    si,[pointc.y]
        mov    di,[pointb.y]
        call   LineToTable
        jc     @RightBranch      {ak vedie hore => je uz prava}
                                 {odskoc na pravu vetvu}
        mov    ax,[pointd.x]
        mov    bx,[pointc.x]     {inac uloz ciaru z C do D}
        mov    si,[pointd.y]
        mov    di,[pointc.y]
        call   LineToTable

      @RightBranch:
        mov    word ptr[lrtable],offset righttable
        mov    ax,[pointd.x]     {prava hranica polygonu}
        mov    bx,[pointa.x]     {uloz ciaru z A do D}
        mov    si,[pointd.y]
        mov    di,[pointa.y]
        call   LineToTable

        mov    ax,[pointc.x]     {skus ulozit}
        mov    bx,[pointd.x]     {ciaru z D do C}
        mov    si,[pointc.y]
        mov    di,[pointd.y]
        call   LineToTable
        jc     @Fill             {ak je posledna bude sa vyplnat}

        mov    ax,[pointb.x]     {inac uloz este z C do B}
        mov    bx,[pointc.x]
        mov    si,[pointb.y]
        mov    di,[pointc.y]
        call   LineToTable

      @Fill:
        pop    bp
        mov    dx,[maxy]
        mov    di,[miny]
        sub    dx,di             {porovanj min a max y suradnice}
        js     @FourAngleExit    {ak je max<min nic sa nekresli}

      @Fill2:
        inc    dx                {v dx je teraz vyska polygonu}
        shl    di,1              {zdvojnasob y1}
        mov    bx,offset righttable {a najdi prve x}
        add    bx,di             {v pravej a}
        mov    si,offset lefttable {lavej}
        add    si,di             {tabulke}
        shl    di,5              {di:=64*y1}
        mov    ax,di             {ax:=64*y1}
        shl    di,2              {di:=256*y1}
        add    di,ax             {di:=320*y1}
        mov    es,[vramseg]      {zaciatok VRAM}
        cld                      {do di adresa 1.riadku polygonu}

      @LoadRange:
        lodsw                    {nacitaj lave x}
        mov    cx,[bx]           {a prave x}
        add    bx,2

      @DrawHorLine:
        push   di                {odloz adresu pre posun dole}
        add    di,ax             {prirataj x, mas adresu}
        sub    cx,ax             {1.bodu horizontalnej ciary}
        js     @EndOfHorLine     {ak je lavy bod vpravo od praveho nekresli}
        inc    cx                {zisti dlzku ciary}
        mov    al,[bp+6]         {do al,ah}
        mov    ah,al             {uloz Color}

      @StoreBytes:
        shr    cx,1              {ak cx obsahuje jednicky}
        jnc    @StoreWords
        stosb                    {uloz bajt}
      @StoreWords:
        jz     @EndOfHorLine     {ak nie je nakreslena cela ciara}
        rep    stosw             {ukladaj slova deltax/2 krat}

      @EndOfHorLine:
        pop    di                {obnov adresu zaciatku riadku}
        add    di,320            {a posun o 1 dole}
        dec    dx                {kym nie je cely polygon}
        jnz    @LoadRange        {dalsiu horizontalnu ciaru}
      @FourAngleExit:
      end;

begin
  p386:=ChckProcessor;
end.
