{$A+,B-,D-,E+,F-,G+,I+,L-,N+,O-,P-,Q-,R-,S-,T-,V+,X+}
{$M 16384,0,655360}
program Gravitoid;

  uses Crt, Dos, Graph13h, Krysa, Vector;

  const roomcolor=48;   {farba prazdnej miestnosti}
        roomsfilename='rooms.dat'; {meno suboru s datami miestnosti}
        spritesfilename='sprites.csp'; {meno suboru so spritmi}
        eyedist=240;    {vzdialenost oka od priemetne (z-suradnica priemetne)}
        brickedge=32;   {dlzka hrany tehly}
        roomedge=6*brickedge; {dlzka hrany miestnosti}
        stepangle=0.1;   {zmena uhla pri otacani}
        transparentcolor=1; {cislo transparentnej farby pre sprity}
        bonusradius=9;  {polomer bonusgulicky}
        rcdist=460;    {vzdialenost stredu miestnosti na zaciatku}
        maxroomnb=33;  {pocet miestnosti (preddefinovanych)}

  {$I palette.inc}
  {$I smallfnt.inc}

  type pbyte=^byte;

  type tcubeplanes=(leftp,rightp,upp,downp,nearp,farp);
       tsetofcubeplanes=set of tcubeplanes;

  const roomcenter:tvector=(x:0; y:0; z:rcdist);
          {suradnice stredu miestnosti}
        minusroomcenter:tvector=(x:0; y:0; z:-rcdist);
          {opacny vektor k vektoru roomcenter}
        lightvector:tvector=(x:-4; y:2; z:2);
          {normalizovany vektor smeru svetla}

  type tcubevertices=array[0..7] of tvector;

  const roomvertices:tcubevertices=(
               (x:-3*brickedge; y:-3*brickedge; z:rcdist-3*brickedge),
               (x: 3*brickedge; y:-3*brickedge; z:rcdist-3*brickedge),
               (x: 3*brickedge; y:-3*brickedge; z:rcdist+3*brickedge),
               (x:-3*brickedge; y:-3*brickedge; z:rcdist+3*brickedge),
               (x:-3*brickedge; y: 3*brickedge; z:rcdist-3*brickedge),
               (x: 3*brickedge; y: 3*brickedge; z:rcdist-3*brickedge),
               (x: 3*brickedge; y: 3*brickedge; z:rcdist+3*brickedge),
               (x:-3*brickedge; y: 3*brickedge; z:rcdist+3*brickedge));
         {suradnice vrcholov miestnosti}

  type tintvector=record
                    x,y,z:integer;
                  end;

  const wincenter:tintvector=(x:160; y:93; z:0);
          {sem sa zobrazi bod (0,0,0)}

  var rotmatrix,transfmatrix:tmatrix;
        {matica rotacie okolo nejakej osi a celkova transformacna matica}
      transfroomvertices:tcubevertices;
        {suradice transformovanych vrcholov miestnosti}
      projroomvertices:array[0..7] of tintvector;
        {suradice premietnutych vrcholov miestnosti}
      planesnormals:array[tcubeplanes] of tvector;
        {normala na kazdu stenu kocky}
      planesshades:array[tcubeplanes] of byte;
        {odtien farby pre kazdu stenu tehly}
      transfpoints:array[0..7*7*7-1] of tvector;
        {suradnice transformovanych bodov}
      projpoints:array[0..7*7*7-1] of tintvector;
        {suradnice premietnutych bodov}
      bricks:array[0..5,0..5,0..5] of byte;
        {info o kazdej tehle}
      brickscolors:array[0..5,0..5,0..5] of byte;
        {farba kazdej tehly}
      bricksdone:array[0..5,0..5,0..5] of boolean;
        {info, ci uz tehla bola pri zobrazovani spracovana}
      holes:array[tcubeplanes,0..5,0..5] of byte;
        {info o dierach v kazdej stene}
      bricksnb:integer;
        {pocet tehal v tejto miestnosti, ktore treba znicit}

      ball,transfball,v,transfv,v1x,v1y,v1z:tvector;
        {suradnice a transformovane suradnice stredu lopty, a vektora
         rychlosti}
      ballradius,ballradiusbak:byte;
        {polomer lopty (1..16), a jeho backup pri docasnej zmene polomeru}
      transfballradius:single;
        {transformovany polomer lopty}
      ro,robak:single;
        {pruznost gule <0;1> a jeho backup}
      projball:tintvector;
        {suradnice stredu premietnutej lopty}
      ballbrick,bb:tintvector;
        {indexy tehly, v ktorej je prave lopta; a odkial sa zacnu kreslit
         tehly - index najvzdialenejsej tehly do ktorej lopta zasahuje}
      brickmin,brickmax:tvector;
        {hranice tejto tehly}
      ballin:boolean;
        {ci je lopta vnutri miestnosti alebo von}
      ballnear:boolean;
        {ak je von, ci je pred miestnostou alebo za nou}
      balloutscreen:boolean;
        {ak lopta usla mimo obrazovku}
      transfbrickcenter:tvector;
        {stred kocky, v ktorej je bonus}
      projbrickcenter:tintvector;
        {premietnuty stred}
      transfbonusradius:single;
        {transformovany polomer bonusu}

      g:single;
        {gravitacne zrychlenie}
      gravity:tsetofcubeplanes;
        {mnozina stien, na ktore posobi gravitacia}
      mode:byte;
        {mod gravitacie 1 alebo 2 (na prave 1/na 0 az 6 stien)}

      roomnb,allroomsnb:byte;
        {cislo miestnosti, a pocet vsetkych miestnosti v rooms.dat}
      roomname:string;
        {meno miestnosti}
      roomnamecolor:byte;
        {farba mena miestnosti}

      interiorscreen,background:pointer;
        {na intriorscreen^ je aktivna vnutorna obrazovka,
         na background^ je vnutorna obrazovka s pozadim}
      interscrkey,backgroundkey:pbyte;
        {kluce pre GetMem0}

      xturn,yturn,zturn:single;
        {uhly o kolko chce hrac otocit miestnost okolo osi x,y,z}

      time,currenttime,oldcurrenttime,deltatime:longint;
        {celkovy cas hry hraca, dekoduje sa z hesla,
         aktualny cas v stotinach sekundy,
         cas v 1/100 sekundy pr poslednom zistovani
         cas v 1/100, ktory uplynul od polsedneho zistovania}
      _eye,_ufo,_bricks:word;
        {countre pre oko, a ufo}
      eyespr,eyeview:byte;
        {momentalne cislo spritu oka, a nahodne cislo pre smer pohladu}
      ufo1x,ufo1y,ufo2x,ufo2y,ufodx,ufody:single;
        {suradnice ufa odkial kam a rozdiel pre 1 krok}

      paused,playing:boolean;
        {ci je hra prave zapauzovana, a ci sa vobec hra}
      mcurbak:tintvector2d;
        {odlozena pozicia kurzora pri pauze}

      _4,_5,_6,_7,_8,_9,_10,_12,_14,_15,_16,_18,_19,_20,_21,_23,_28,
      _30:longint;
      {casovace pre bonusy}
      _24b,_25b,_26b:boolean;
      {flagy pre bonusy}

      effect:array [1..18] of record
                                ch:char;
                                x,y,dy:integer;
                              end;
      {pismenka na intro a outro efekty}
      introdx:integer;
      {deltax pohybu pre pismenka v intre}
      outro:boolean;
      {ci prave bezi outro}

      music:boolean;
       {ci ma hrat teraz hudba}
      _music:longint;
      {casovac pre hudbu (ako dlho sa este bude hrat tato nota (v 1/18.2s)}
      mel:string;
        {melodia}
      mel_:byte;
        {ukazovatel na nasledujucu notu}


{ PODPORNE NIZKOUROVNOVE PROCEDURY }

  function Sgn(x:single):integer;
    begin
      if x>0 then Sgn:=1
      else if x=0 then Sgn:=0
      else Sgn:=-1;
    end;


  function ArcSin(x:single):single;
    begin
      ArcSin:=ArcTan(x/Sqrt(1-Sqr(x)));
    end;


  procedure ReleaseAll;
    begin
      if mpresent then while mstate<>[] do;
      while KeyPressed do ReadKey;
    end;

{ PROCEDURY PRE PRACU S MATICAMI A VEKTORMI }

  {v unite Vector}

{ ZVUKY }

  var brickcrashed,soundswitch:boolean;
      crashedwalls:tsetofcubeplanes;

  procedure WallCrashSound;
    {zvuk pri naraze lopty do steny}
    begin
      if soundswitch then
        if ([leftp,rightp]*crashedwalls<>[]) and (Abs(v.x)>0.04) or
           ([upp,downp]*crashedwalls<>[]) and (Abs(v.y)>0.04) or
           ([nearp,farp]*crashedwalls<>[]) and (Abs(v.z)>0.04) then
          begin Sound(400); Delay(3); NoSound; end;
    end;

  procedure BrickCrashSound;
    {zvuk pri naraze lopty do tehly}
    begin
      if soundswitch then
        Sound(5000); Delay(4); NoSound;
    end;

  procedure BonusCrashSound;
    {zvuk pri naraze lopty do bonusu}
    var i:integer;
    begin
      if soundswitch then
        begin
          for i:=1 to 8 do
            begin Sound(i*500+2000); Delay(1); end;
          NoSound;
        end;
    end;



{ TRANSFORMACNE PROCEDURY }

  procedure CreateTransformationMatrix(var a,b:tmatrix);
    {vytvori celu transformacnu maticu, b je matica otoc. okolo niektorej osi}
    var c:tmatrix;
    begin
      CreateTranslationMatrix(a,minusroomcenter);
      MultiplyMatrices(a,b);
      CreateTranslationMatrix(c,roomcenter);
      MultiplyMatrices(a,c);
    end;



  procedure ProjectPoint(var projectedp:tintvector; var originalp:tvector);
    {premietne bod originalp a ulozi ho do projectedp}
    begin
      projectedp.x:=Trunc(originalp.x/originalp.z*eyedist*aspectratio+wincenter.x);
      projectedp.y:=Trunc(originalp.y/originalp.z*eyedist+wincenter.y);
     { projectedp.z:=Trunc(eyedist+wincenter.z);}
    end;


  procedure ProjectRoom;
    {transformuje a premietne vrcholy miestnosti a vsetky vrcholy tehal}
    var i,j,k,pointindex:integer;
        point0,di16,dj16,dk16,di76,dj76,dk76:tvector;
    begin
      for i:=0 to 7 do
        begin
          MultiplyVectorMatrix(transfroomvertices[i],transfroomvertices[i],
                               transfmatrix);
          ProjectPoint(projroomvertices[i],transfroomvertices[i]);
        end;

      VSub(di16,transfroomvertices[3],transfroomvertices[0]);
      VSub(dj16,transfroomvertices[4],transfroomvertices[0]);
      VSub(dk16,transfroomvertices[1],transfroomvertices[0]);
      VRMul(di16,di16,1/6);
      VRMul(dj16,dj16,1/6);
      VRMul(dk16,dk16,1/6);
      VRMul(di76,di16,7);
      VRMul(dj76,dj16,7);
      VRMul(dk76,dk16,7);
      point0:=transfroomvertices[0];

      for i:=0 to 6 do
        begin
          for j:=0 to 6 do
            begin
              for k:=0 to 6 do
                begin
                  pointindex:=49*i+7*j+k;
                  transfpoints[pointindex]:=point0;
                  ProjectPoint(projpoints[pointindex],transfpoints[pointindex]);
                  VInc(point0,dk16);
                end;
              VDec(point0,dk76);
              VInc(point0,dj16);
            end;
          VDec(point0,dj76);
          VInc(point0,di16);
        end;
    end;


  procedure ProjectBall;
    {transformuje a premietne lopticku v transfball}
    begin
      {transformuj jednotkove vektory priestoru miestnosti}
      if ballin then
        begin
          MultiplyVectorMatrix(v1x,v1x,rotmatrix);
          MultiplyVectorMatrix(v1y,v1y,rotmatrix);
          MultiplyVectorMatrix(v1z,v1z,rotmatrix);
        end;

      {transformuj loptu z priestoru miestnosti do normalneho a premietni}
      TransformFromBase(transfball,ball,v1x,v1y,v1z);
      VAdd(transfball,transfball,roomcenter);
      ProjectPoint(projball,transfball);

      {transformuj vektor rychlosti a polomer}
      TransformFromBase(transfv,v,v1x,v1y,v1z);
      transfballradius:=ballradius*eyedist/transfball.z;

      {zisti ci je lopta mimo miestnosti}
      if (ballbrick.x>=0) and (ballbrick.x<=5) and
         (ballbrick.y>=0) and (ballbrick.y<=5) and
         (ballbrick.z>=0) and (ballbrick.z<=5) then ballin:=true
      else ballin:=false;

      {ak je lopta prilis daleko alebo mimo obrazu nastav priznak konca hry}
      if (transfball.z<eyedist+ballradius) or
         (projball.x<-2*transfballradius) or
         (projball.x>320+2*transfballradius) or
         (projball.y<-2*transfballradius) or
         (projball.y>200+2*transfballradius) then balloutscreen:=true;

    end;


  procedure ComputePlanesNormals;
    {vypocita suradnice jednotkovej normaly na kazdu stenu kocky}
    var u,v:tvector;
    begin
      VSub(u,transfroomvertices[3],transfroomvertices[0]);
      VSub(v,transfroomvertices[7],transfroomvertices[0]);
      VCrossProduct(planesnormals[leftp],u,v);

      VSub(u,transfroomvertices[5],transfroomvertices[1]);
      VSub(v,transfroomvertices[6],transfroomvertices[1]);
      VCrossProduct(planesnormals[rightp],u,v);

      VSub(u,transfroomvertices[1],transfroomvertices[0]);
      VSub(v,transfroomvertices[2],transfroomvertices[0]);
      VCrossProduct(planesnormals[upp],u,v);

      VSub(u,transfroomvertices[7],transfroomvertices[4]);
      VSub(v,transfroomvertices[6],transfroomvertices[4]);
      VCrossProduct(planesnormals[downp],u,v);

      VSub(u,transfroomvertices[4],transfroomvertices[0]);
      VSub(v,transfroomvertices[5],transfroomvertices[0]);
      VCrossProduct(planesnormals[nearp],u,v);

      VSub(u,transfroomvertices[2],transfroomvertices[3]);
      VSub(v,transfroomvertices[6],transfroomvertices[3]);
      VCrossProduct(planesnormals[farp],u,v);
    end;


  procedure ComputePlanesShades;
    {vypocita odtien farby pre kazdu plochu kocky}
    var plni:tcubeplanes;
        planeshade:integer;
    begin
      for plni:=leftp to farp do
        begin
      planeshade:=-Trunc(VCosAngle(planesnormals[plni],lightvector)*8);
      if planeshade>=0 then planesshades[plni]:=planeshade
      else planesshades[plni]:=0;
        end;
    end;


    function ComputeDCoeficient(plane:tcubeplanes; vertindex:integer):single;
      {vypocita a vrati d koeficient rovnice roviny plochy plane}
      begin
        ComputeDCoeficient:=
          -VDotProduct(planesnormals[plane],transfpoints[vertindex]);
      end;



{ PROCEDURY PRE KRESLENIE SPRITOV }

  const ballsprpos:array[1..32] of word=(
          0,5,13,26,46,75,121,188,272,366,480,616,788,987,1215,1474,1766,
          2093,2457,2879,3343,3872,4448,5073,5749,6478,7262,8130,9058,10048,
          11102,12222);

        miscsprpos:array[0..25] of word=(
          0,196,392,588,784,1044,1304,1992,2680,3368,4056,4744,5432,6192,
          6880,7568,8256,8944,9632,10320,11008,12065,12828,14960,15414,15964);

        bonussprpos:array[1..16] of word=(
          0,5,13,26,46,75,121,188,272,366,480,616,788,987,1215,1474);

        fontsprpos:array[#32..#90] of word=(
          0,224,0,0,0,0,0,0,0,0,0,0,0,0,0,0,592,884,1086,1378,1670,1962,2254,
          2546,2838,3130,112,0,0,0,0,336,0,3422,3714,4006,4298,4590,4882,5174,
          5466,5758,5870,6162,6454,6746,7038,7330,7622,7914,8206,8498,8790,
          9082,9374,9666,9958,10250,10542);

  type spritemaps=array[0..65520] of byte;
       pspritemaps=^spritemaps;

  var ballsprites:pspritemaps;
      ballsprkey:pbyte;
      miscsprites:pspritemaps;
      miscsprkey:pbyte;
      bonussprites:pspritemaps;
      bonussprkey:pbyte;
      fontsprites:pspritemaps;
      fontsprkey:pbyte;


  {$I sprites.inc}



{ PROCEDURY PRE POHYB LOPTICKY }

  function CrashedBrick(i,j,k:integer):boolean;
    {osetri naraz do tehly bricks[i,j,k]}
    var btype,btypef:byte;
        ii,jj,kk:integer;
        bonuscreated,bd,ballteleported:boolean;

    procedure CreateRandomBonus(i,j,k:integer);
      {na pozicii bricks[i,j,k] vytvori nahodny bonus, ak je prazdna}
      begin
        if not bonuscreated and (bricks[i,j,k]<$80) then
          begin
            bricks[i,j,k]:=$80;
            brickscolors[i,j,k]:=(Random(28)+4)*8;
            bonuscreated:=true;
          end;
      end;

    procedure Destroy24;
      {znici vsetky tehly rovnakej farby ako prave narazena}
      var col:byte;
          ii,jj,kk:integer;
      begin
        col:=brickscolors[i,j,k];
        for ii:=0 to 5 do
          for jj:=0 to 5 do
            for kk:=0 to 5 do
              if ((bricks[ii,jj,kk] and $C0)=$C0) and
                 (brickscolors[ii,jj,kk]=col) then
                 begin
                   if (bricks[ii,jj,kk] and $20)=$20 then
                     Dec(bricks[ii,jj,kk],$40)
                   else Dec(bricks[ii,jj,kk],$80);
                   Dec(bricksnb);
                 end;
        _24b:=false;
      end;

    procedure DestroyBrick(i,j,k:integer);
      {znici tehlu na bricks[i,j,k], ak tam je}
      begin
        if bricks[i,j,k]>=$C0 then
          begin
            if (bricks[i,j,k] and $20)=$20 then Dec(bricks[i,j,k],$40)
            else Dec(bricks[i,j,k],$80);
            Dec(bricksnb);
            bd:=true;
          end;
      end;


    procedure Destroy25;
      {znici vsetky tehly susediace stenou s prave narazenou}

      procedure DestroyPlaneEnv(i,j,k:integer);
        {rekurzivne znici vsetky tehly okolo susediace stenou}
        begin
          if (bricks[i,j,k] and $C0)=$C0 then
            begin
              DestroyBrick(i,j,k);
              if i>0 then DestroyPlaneEnv(i-1,j,k);
              if i<5 then DestroyPlaneEnv(i+1,j,k);
              if j>0 then DestroyPlaneEnv(i,j-1,k);
              if j<5 then DestroyPlaneEnv(i,j+1,k);
              if k>0 then DestroyPlaneEnv(i,j,k-1);
              if k<5 then DestroyPlaneEnv(i,j,k+1);
            end;
        end;

      begin
        if (bricks[i,j,k] and $C0)=$C0 then DestroyBrick(i,j,k);
        if i>0 then DestroyPlaneEnv(i-1,j,k);
        if i<5 then DestroyPlaneEnv(i+1,j,k);
        if j>0 then DestroyPlaneEnv(i,j-1,k);
        if j<5 then DestroyPlaneEnv(i,j+1,k);
        if k>0 then DestroyPlaneEnv(i,j,k-1);
        if k<5 then DestroyPlaneEnv(i,j,k+1);
        _25b:=false;
      end;

    procedure Destroy26;
      {znici vsetky tehly okolo prave narazenej}
      var ii,jj,kk:integer;
      begin
        for ii:=-1 to 1 do
          for jj:=-1 to 1 do
            for kk:=-1 to 1 do
              if ((i+ii) in [0..5]) and ((j+jj) in [0..5]) and
                 ((k+kk) in [0..5]) then
                if (bricks[i+ii,j+jj,k+kk] and $C0)=$C0 then
                  DestroyBrick(i+ii,j+jj,k+kk);
        _26b:=false;
      end;

    procedure TeleportBall(i,j,k:integer);
      {presunie loptu na poziciu tehly bricks[i,j,k] ak je prazdna}
      begin
        if not ballteleported and (bricks[i,j,k]<$80) then
          begin
            ball.x:=(k+0.5)*brickedge-roomedge/2;
            ball.y:=(j+0.5)*brickedge-roomedge/2;
            ball.z:=(i+0.5)*brickedge-roomedge/2;
            ballteleported:=true;
          end;
      end;

    begin
      btype:=bricks[i,j,k];
      btypef:=btype and $0F;

      if (btype and $C0)=$C0 then
        {ak tehla}
        if btypef in [$2..$A] then
          begin
            Dec(bricks[i,j,k]);
            BrickCrashSound; brickcrashed:=true;
            CrashedBrick:=true;
            if _25b then Destroy25;
            if _24b then Destroy24;
            if _26b then Destroy26;
          end
        else if (btypef=$C) and (_bricks mod 20>=10) then
               CrashedBrick:=false
             else
               begin
                 if (btype and $20)=$20 then Dec(bricks[i,j,k],$40)
                 else Dec(bricks[i,j,k],$80);
                 Dec(bricksnb);
                 BrickCrashSound; brickcrashed:=true;
                 if _23=0 then CrashedBrick:=true
                 else CrashedBrick:=false;
                 if _25b then Destroy25;
                 if _24b then Destroy24;
                 if _26b then Destroy26;
               end

      else if (btype and $C0)=$80 then
        {ak bonus}
             begin
               if Sqr(ball.x-(k*32-96+16))+Sqr(ball.y-(j*32-96+16))+
                  Sqr(ball.z-(i*32-96+16))<Sqr(bonusradius+ballradius) then
                 {ak lopta narazila do bonusu}
                 begin
                   case brickscolors[i,j,k] shr 3 of
                     4: _4:=113;

                     5: _5:=113;

                     6: _6:=200;

                     7: _7:=170;

                     8: begin
                          if (_8=0) and (_21=0) then ballradiusbak:=ballradius
                          else _21:=0;
                          _8:=294;
                        end;

                     9: _9:=170;

                    10: _10:=170;

                    11: begin
                          for ii:=0 to 5 do
                            for jj:=0 to 5 do
                              for kk:=0 to 5 do
                                if (bricks[ii,jj,kk] and $C0)=$80 then
                                  Dec(bricks[ii,jj,kk],$80);
                          Inc(bricks[i,j,k],$80);
                        end;

                    12: _12:=106;

                    13: for ii:=0 to 5 do
                          for jj:=0 to 5 do
                            for kk:=0 to 5 do
                              if bricks[ii,jj,kk]<$80 then
                                begin
                                  bricks[ii,jj,kk]:=$C1;
                                  brickscolors[ii,jj,kk]:=13*8;
                                  Inc(bricksnb);
                                end;

                    14: begin
                          if (_14=0) and (_20=0) then robak:=ro
                          else _20:=0;
                          ro:=1;
                          _14:=408;
                          gravity:=[];
                        end;

                    15: begin
                          if _16>=0 then _16:=0;
                          _15:=256;
                        end;

                    16: begin
                          if _15>0 then _15:=0;
                          _16:=256;
                        end;

                    17: begin
                          ii:=1; bonuscreated:=false;
                          repeat
                            jj:=1;
                            repeat
                              kk:=1;
                              repeat
                                CreateRandomBonus(3-ii,3-jj,3-kk);
                                CreateRandomBonus(3-ii,3-jj,2+kk);
                                CreateRandomBonus(3-ii,2+jj,3-kk);
                                CreateRandomBonus(3-ii,2+jj,2+kk);
                                CreateRandomBonus(2+ii,3-jj,3-kk);
                                CreateRandomBonus(2+ii,3-jj,2+kk);
                                CreateRandomBonus(2+ii,2+jj,3-kk);
                                CreateRandomBonus(2+ii,2+jj,2+kk);
                                Inc(kk);
                              until (kk>3) or bonuscreated;
                              Inc(jj);
                            until (jj>3) or bonuscreated;
                            Inc(ii);
                          until (ii>3) or bonuscreated;
                        end;

                    18: _18:=799;

                    19: _19:=212;

                    20: begin
                          if (_20=0) and (_14=0) then robak:=ro
                          else _14:=0;
                          ro:=0.00001;
                          _20:=408;
                        end;

                    21: begin
                          if (_21=0) and (_8=0) then ballradiusbak:=ballradius
                          else _8:=0;
                          _21:=294;
                        end;

                    22: begin
                          VLoad(v,0,0,0); gravity:=[];
                        end;

                    23: _23:=188;

                    24: _24b:=true;

                    25: _25b:=true;

                    26: _26b:=true;

                    27: begin
                          ii:=1; bd:=false;
                          repeat
                            jj:=1;
                            repeat
                              kk:=1;
                              repeat
                                DestroyBrick(3-ii,3-jj,3-kk);
                                DestroyBrick(3-ii,3-jj,2+kk);
                                DestroyBrick(3-ii,2+jj,3-kk);
                                DestroyBrick(3-ii,2+jj,2+kk);
                                DestroyBrick(2+ii,3-jj,3-kk);
                                DestroyBrick(2+ii,3-jj,2+kk);
                                DestroyBrick(2+ii,2+jj,3-kk);
                                DestroyBrick(2+ii,2+jj,2+kk);
                                Inc(kk);
                              until (kk>3) or bd;
                              Inc(jj);
                            until (jj>3) or bd;
                            Inc(ii);
                          until (ii>3) or bd;
                        end;

                    28: _28:=232;

                    29: if mode=1 then
                          begin
                            if leftp in gravity then gravity:=[rightp]
                            else if rightp in gravity then gravity:=[leftp]
                            else if upp in gravity then gravity:=[downp]
                            else if downp in gravity then gravity:=[upp]
                            else if nearp in gravity then gravity:=[farp]
                            else if farp in gravity then gravity:=[nearp];
                          end
                        else gravity:=[leftp..farp]-gravity;

                    30: _30:=61;

                    31: begin
                          ii:=1; ballteleported:=false;
                          repeat
                            jj:=1;
                            repeat
                              kk:=1;
                              repeat
                                TeleportBall(3-ii,3-jj,3-kk);
                                TeleportBall(3-ii,3-jj,2+kk);
                                TeleportBall(3-ii,2+jj,3-kk);
                                TeleportBall(3-ii,2+jj,2+kk);
                                TeleportBall(2+ii,3-jj,3-kk);
                                TeleportBall(2+ii,3-jj,2+kk);
                                TeleportBall(2+ii,2+jj,3-kk);
                                TeleportBall(2+ii,2+jj,2+kk);
                                Inc(kk);
                              until (kk>3) or ballteleported;
                              Inc(jj);
                            until (jj>3) or ballteleported;
                            Inc(ii);
                          until (ii>3) or ballteleported;
                        end;

                   end;
                   Dec(bricks[i,j,k],$80);
                   BonusCrashSound;
                   brickcrashed:=true;
                 end;
               CrashedBrick:=false;
             end
      else CrashedBrick:=false;
    end;



  procedure MoveBall;
    {posunie loptu o vektor v, pripadne ju odrazi}
    var vtmp,ball2:tvector;
        fi,sigma,p,fitmp,sigmatmp,ptmp:single;
        crash,crashsigma,crashfihor,crashfivert:boolean;
        crashedplanes:tsetofcubeplanes;
    begin
      ball2:=ball;

      {ak lopta stoji zmen rychlost a koniec}
      if VLength(v)=0 then
        begin
          if leftp in gravity then v.x:=v.x-g/2000;
          if rightp in gravity then v.x:=v.x+g/2000;
          if upp in gravity then v.y:=v.y-g/2000;
          if downp in gravity then v.y:=v.y+g/2000;
          if nearp in gravity then v.z:=v.z-g/2000;
          if farp in gravity then v.z:=v.z+g/2000;
          Exit;
        end;

      {pohne sa lopta}
      if _16>0 then
        begin VRMul(vtmp,v,1/2); VInc(ball,vtmp); end
      else
        begin
          VInc(ball,v);
          if _15>0 then VInc(ball,v);
        end;

      {zistia sa indexy tehly, v ktorej je stred lopty}
      ballbrick.x:=Trunc((ball.x+roomedge/2)/brickedge);
      ballbrick.y:=Trunc((ball.y+roomedge/2)/brickedge);
      ballbrick.z:=Trunc((ball.z+roomedge/2)/brickedge);

      {ak je lopta cela mimo miestnosti nie je co robit dalej}
      if (ball.x<-roomedge/2-ballradius) or (ball.x>roomedge/2+ballradius) or
         (ball.y<-roomedge/2-ballradius) or (ball.y>roomedge/2+ballradius) or
         (ball.z<-roomedge/2-ballradius) or (ball.z>roomedge/2+ballradius)
        then Exit;

      {zistia sa hranicne suradnice tehly, v ktorej je stred lopty}
      brickmin.x:=ballbrick.x*brickedge-roomedge/2;
      brickmin.y:=ballbrick.y*brickedge-roomedge/2;
      brickmin.z:=ballbrick.z*brickedge-roomedge/2;
      brickmax.x:=brickmin.x+brickedge;
      brickmax.y:=brickmin.y+brickedge;
      brickmax.z:=brickmin.z+brickedge;

      {zisti sa do ktorych stien lopta narazila}
      crashedplanes:=[];
      if ball.x-brickmin.x<ballradius then crashedplanes:=[leftp];
      if brickmax.x-ball.x<ballradius then crashedplanes:=crashedplanes+[rightp];
      if ball.y-brickmin.y<ballradius then crashedplanes:=crashedplanes+[upp];
      if brickmax.y-ball.y<ballradius then crashedplanes:=crashedplanes+[downp];
      if ball.z-brickmin.z<ballradius then crashedplanes:=crashedplanes+[nearp];
      if brickmax.z-ball.z<ballradius then crashedplanes:=crashedplanes+[farp];

      crash:=false; crashsigma:=false; crashfihor:=false; crashfivert:=false;
      brickcrashed:=false;
      crashedwalls:=[];

      {skontroluje sa kocka v ktorej je lopta}
      if (ballbrick.x in [0..5]) and (ballbrick.y in [0..5]) and
          (ballbrick.z in [0..5]) then
        CrashedBrick(ballbrick.z,ballbrick.y,ballbrick.x);

      {osetria sa narazy do stien}
      if (leftp in crashedplanes) and (ballbrick.y in [0..5]) and  {left}
          (ballbrick.z in [0..5]) then
        if (ballbrick.x>0) and
            CrashedBrick(ballbrick.z,ballbrick.y,ballbrick.x-1) or
           (ballbrick.x=0) and
            ((holes[leftp,ballbrick.y,5-ballbrick.z]=0) and (_12=0) or
             (_19>0)) then
          begin
            v.x:=-v.x;
            crash:=true;
            crashedplanes:=crashedplanes-[leftp];
            if not brickcrashed then crashedwalls:=crashedwalls+[leftp];
          end;

      if (rightp in crashedplanes) and (ballbrick.y in [0..5]) and  {right}
          (ballbrick.z in [0..5]) then
        if (ballbrick.x<5) and
            CrashedBrick(ballbrick.z,ballbrick.y,ballbrick.x+1) or
           (ballbrick.x=5) and
            ((holes[rightp,ballbrick.y,ballbrick.z]=0) and (_12=0) or
             (_19>0)) then
          begin
            v.x:=-v.x;
            crash:=true;
            crashedplanes:=crashedplanes-[rightp];
            if not brickcrashed then crashedwalls:=crashedwalls+[rightp];
          end;

      if (upp in crashedplanes) and (ballbrick.x in [0..5]) and  {up}
          (ballbrick.z in [0..5]) then
        if (ballbrick.y>0) and
            CrashedBrick(ballbrick.z,ballbrick.y-1,ballbrick.x) or
           (ballbrick.y=0) and
            ((holes[upp,5-ballbrick.z,ballbrick.x]=0) and (_12=0) or
             (_19>0)) then
          begin
            v.y:=-v.y;
            crash:=true;
            crashedplanes:=crashedplanes-[upp];
            if not brickcrashed then crashedwalls:=crashedwalls+[upp];
          end;

      if (downp in crashedplanes) and (ballbrick.x in [0..5]) and  {down}
          (ballbrick.z in [0..5]) then
        if (ballbrick.y<5) and
            CrashedBrick(ballbrick.z,ballbrick.y+1,ballbrick.x) or
           (ballbrick.y=5) and
            ((holes[downp,ballbrick.z,ballbrick.x]=0) and (_12=0) or
             (_19>0))  then
          begin
            v.y:=-v.y;
            crash:=true;
            crashedplanes:=crashedplanes-[downp];
            if not brickcrashed then crashedwalls:=crashedwalls+[downp];
          end;

      if (nearp in crashedplanes) and (ballbrick.x in [0..5]) and  {near}
          (ballbrick.y in [0..5]) then
        if (ballbrick.z>0) and
            CrashedBrick(ballbrick.z-1,ballbrick.y,ballbrick.x) or
           (ballbrick.z=0) and
            ((holes[nearp,ballbrick.y,ballbrick.x]=0) and (_12=0) or
             (_19>0)) then
          begin
            v.z:=-v.z;
            crash:=true;
            crashedplanes:=crashedplanes-[nearp];
            if not brickcrashed then crashedwalls:=crashedwalls+[nearp];
          end;

      if (farp in crashedplanes) and (ballbrick.x in [0..5]) and  {far}
          (ballbrick.y in [0..5]) then
        if (ballbrick.z<5) and
            CrashedBrick(ballbrick.z+1,ballbrick.y,ballbrick.x) or
           (ballbrick.z=5) and
            ((holes[farp,ballbrick.y,5-ballbrick.x]=0) and (_12=0) or
             (_19>0)) then
          begin
            v.z:=-v.z;
            crash:=true;
            crashedplanes:=crashedplanes-[farp];
            if not brickcrashed then crashedwalls:=crashedwalls+[farp];
          end;

      {vektor rychlosti sa rozbije na polarne suradnice}
      VSplitToAngles(v,fi,sigma,p);

      {osetria sa narazy do hran}
      if ([nearp,upp]<=crashedplanes) and (ballbrick.x in [0..5]) and  {01}
          (Sqrt(Sqr(brickmin.y-ball.y)+Sqr(brickmin.z-ball.z))<ballradius) and
          ((v.y<0) or (v.z<0)) then
        if (ballbrick.y>0) and (ballbrick.z>0) and
            CrashedBrick(ballbrick.z-1,ballbrick.y-1,ballbrick.x) or
           (ballbrick.y>0) and (ballbrick.z=0) and
            ((holes[nearp,ballbrick.y-1,ballbrick.x]=0) and (_12=0) or
             (_19>0)) or
           (ballbrick.y=0) and (ballbrick.z>0) and
            ((holes[upp,5-ballbrick.z+1,ballbrick.x]=0) and (_12=0) or
             (_19>0)) then
          begin
            vtmp.x:=0; vtmp.y:=brickmin.y-ball.y; vtmp.z:=brickmin.z-ball.z;
            VSplitToAngles(vtmp,fitmp,sigmatmp,ptmp);
            sigma:=sigmatmp-(sigma-sigmatmp)-Pi;
            fi:=fitmp-(fi-fitmp)-Pi;
            crashsigma:=true; crashfihor:=true;
            if not brickcrashed then crashedwalls:=crashedwalls+[upp,nearp];
          end;

      if ([rightp,upp]<=crashedplanes) and (ballbrick.z in [0..5]) and  {12}
          (Sqrt(Sqr(brickmax.x-ball.x)+Sqr(brickmin.y-ball.y))<ballradius) and
          ((v.x>0) or (v.y<0)) then
        if (ballbrick.x<5) and (ballbrick.y>0) and
            CrashedBrick(ballbrick.z,ballbrick.y-1,ballbrick.x+1) or
           (ballbrick.x<5) and (ballbrick.y=0) and
            ((holes[upp,5-ballbrick.z,ballbrick.x+1]=0) and (_12=0) or
              (_19>0)) or
           (ballbrick.x=5) and (ballbrick.y>0) and
            ((holes[rightp,ballbrick.y-1,ballbrick.z]=0) and (_12=0) or
             (_19>0)) then
          begin
            vtmp.x:=brickmax.x-ball.x; vtmp.y:=brickmin.y-ball.y; vtmp.z:=0;
            VSplitToAngles(vtmp,fitmp,sigmatmp,ptmp);
            if not crashsigma then sigma:=sigmatmp-(sigma-sigmatmp)-Pi;
            fi:=fitmp-(fi-fitmp)-Pi;
            crashsigma:=true; crashfihor:=true;
            if not brickcrashed then crashedwalls:=crashedwalls+[rightp,upp];
          end;

      if ([farp,upp]<=crashedplanes) and (ballbrick.x in [0..5]) and  {23}
          (Sqrt(Sqr(brickmin.y-ball.y)+Sqr(brickmax.z-ball.z))<ballradius) and
          ((v.z>0) or (v.y<0)) then
        if (ballbrick.y>0) and (ballbrick.z<5) and
            CrashedBrick(ballbrick.z+1,ballbrick.y-1,ballbrick.x) or
           (ballbrick.y>0) and (ballbrick.z=5) and
            ((holes[farp,ballbrick.y-1,5-ballbrick.x]=0) and (_12=0) or
             (_19>0)) or
           (ballbrick.y=0) and (ballbrick.z<5) and
            ((holes[upp,5-ballbrick.z-1,ballbrick.x]=0) and (_12=0) or
             (_19>0)) then
          begin
            vtmp.x:=0; vtmp.y:=brickmin.y-ball.y; vtmp.z:=brickmax.z-ball.z;
            VSplitToAngles(vtmp,fitmp,sigmatmp,ptmp);
            if not crashsigma then sigma:=sigmatmp-(sigma-sigmatmp)-Pi;
            fi:=fitmp-(fi-fitmp)-Pi;
            crashsigma:=true; crashfihor:=true;
            if not brickcrashed then crashedwalls:=crashedwalls+[upp,farp];
          end;

      if ([leftp,upp]<=crashedplanes) and (ballbrick.z in [0..5]) and  {30}
          (Sqrt(Sqr(brickmin.x-ball.x)+Sqr(brickmin.y-ball.y))<ballradius) and
          ((v.x<0) or (v.y<0)) then
        if (ballbrick.x>0) and (ballbrick.y>0) and
            CrashedBrick(ballbrick.z,ballbrick.y-1,ballbrick.x-1) or
           (ballbrick.x>0) and (ballbrick.y=0) and
            ((holes[upp,5-ballbrick.z,ballbrick.x-1]=0) and (_12=0) or
             (_19>0)) or
           (ballbrick.x=0) and (ballbrick.y>0) and
            ((holes[leftp,ballbrick.y-1,5-ballbrick.z]=0) and (_12=0) or
             (_19>0)) then
          begin
            vtmp.x:=brickmin.x-ball.x; vtmp.y:=brickmin.y-ball.y; vtmp.z:=0;
            VSplitToAngles(vtmp,fitmp,sigmatmp,ptmp);
            if not crashsigma then sigma:=sigmatmp-(sigma-sigmatmp)-Pi;
            fi:=fitmp-(fi-fitmp)-Pi;
            crashsigma:=true; crashfihor:=true;
            if not brickcrashed then crashedwalls:=crashedwalls+[leftp,upp];
          end;

      if ([nearp,downp]<=crashedplanes) and (ballbrick.x in [0..5]) and  {45}
          (Sqrt(Sqr(brickmax.y-ball.y)+Sqr(brickmin.z-ball.z))<ballradius) and
          ((v.y>0) or (v.z<0)) then
        if (ballbrick.y<5) and (ballbrick.z>0) and
            CrashedBrick(ballbrick.z-1,ballbrick.y+1,ballbrick.x) or
           (ballbrick.y<5) and (ballbrick.z=0) and
            ((holes[nearp,ballbrick.y+1,ballbrick.x]=0) and (_12=0) or
             (_19>0)) or
           (ballbrick.y=5) and (ballbrick.z>0) and
            ((holes[downp,ballbrick.z-1,ballbrick.x]=0) and (_12=0) or
             (_19>0)) then
          begin
            vtmp.x:=0; vtmp.y:=brickmax.y-ball.y; vtmp.z:=brickmin.z-ball.z;
            VSplitToAngles(vtmp,fitmp,sigmatmp,ptmp);
            if not crashsigma then sigma:=sigmatmp-(sigma-sigmatmp)-Pi;
            fi:=fitmp-(fi-fitmp)-Pi;
            crashsigma:=true; crashfihor:=true;
            if not brickcrashed then crashedwalls:=crashedwalls+[nearp,downp];
          end;

      if ([rightp,downp]<=crashedplanes) and (ballbrick.z in [0..5]) and  {56}
          (Sqrt(Sqr(brickmax.x-ball.x)+Sqr(brickmax.y-ball.y))<ballradius) and
          ((v.x>0) or (v.y>0)) then
        if (ballbrick.x<5) and (ballbrick.y<5) and
            CrashedBrick(ballbrick.z,ballbrick.y+1,ballbrick.x+1) or
           (ballbrick.x<5) and (ballbrick.y=5) and
            ((holes[downp,ballbrick.z,ballbrick.x+1]=0) and (_12=0) or
             (_19>0)) or
           (ballbrick.x=5) and (ballbrick.y<5) and
            ((holes[rightp,ballbrick.y+1,ballbrick.z]=0) and (_12=0) or
             (_19>0)) then
          begin
            vtmp.x:=brickmax.x-ball.x; vtmp.y:=brickmax.y-ball.y; vtmp.z:=0;
            VSplitToAngles(vtmp,fitmp,sigmatmp,ptmp);
            if not crashsigma then sigma:=sigmatmp-(sigma-sigmatmp)-Pi;
            fi:=fitmp-(fi-fitmp)-Pi;
            crashsigma:=true; crashfihor:=true;
            if not brickcrashed then crashedwalls:=crashedwalls+[rightp,downp];
          end;

      if ([farp,downp]<=crashedplanes) and (ballbrick.x in [0..5]) and  {67}
          (Sqrt(Sqr(brickmax.y-ball.y)+Sqr(brickmax.z-ball.z))<ballradius) and
          ((v.z>0) or (v.y>0)) then
        if (ballbrick.y<5) and (ballbrick.z<5) and
            CrashedBrick(ballbrick.z+1,ballbrick.y+1,ballbrick.x) or
           (ballbrick.y<5) and (ballbrick.z=5) and
            ((holes[farp,ballbrick.y+1,5-ballbrick.x]=0) and (_12=0) or
             (_19>0)) or
           (ballbrick.y=5) and (ballbrick.z<5) and
            ((holes[downp,ballbrick.z+1,ballbrick.x]=0) and (_12=0) or
             (_19>0)) then
          begin
            vtmp.x:=0; vtmp.y:=brickmax.y-ball.y; vtmp.z:=brickmax.z-ball.z;
            VSplitToAngles(vtmp,fitmp,sigmatmp,ptmp);
            if not crashsigma then sigma:=sigmatmp-(sigma-sigmatmp)-Pi;
            fi:=fitmp-(fi-fitmp)-Pi;
            crashsigma:=true; crashfihor:=true;
            if not brickcrashed then crashedwalls:=crashedwalls+[farp,downp];
          end;

      if ([leftp,downp]<=crashedplanes) and (ballbrick.z in [0..5]) and  {74}
          (Sqrt(Sqr(brickmin.x-ball.x)+Sqr(brickmax.y-ball.y))<ballradius) and
          ((v.x<0) or (v.y>0)) then
        if (ballbrick.x>0) and (ballbrick.y<5) and
            CrashedBrick(ballbrick.z,ballbrick.y+1,ballbrick.x-1) or
           (ballbrick.x>0) and (ballbrick.y=5) and
            ((holes[downp,ballbrick.z,ballbrick.x-1]=0) and (_12=0) or
             (_19>0)) or
           (ballbrick.x=0) and (ballbrick.y<5) and
            ((holes[leftp,ballbrick.y+1,5-ballbrick.z]=0) and (_12=0) or
             (_19>0)) then
          begin
            vtmp.x:=brickmin.x-ball.x; vtmp.y:=brickmax.y-ball.y; vtmp.z:=0;
            VSplitToAngles(vtmp,fitmp,sigmatmp,ptmp);
            if not crashsigma then sigma:=sigmatmp-(sigma-sigmatmp)-Pi;
            fi:=fitmp-(fi-fitmp)-Pi;
            crashsigma:=true; crashfihor:=true;
            if not brickcrashed then crashedwalls:=crashedwalls+[leftp,downp];
          end;

      if not crashfihor and ([leftp,nearp]<=crashedplanes) and     {04}
         (ballbrick.y in [0..5]) and
         (Sqrt(Sqr(brickmin.x-ball.x)+Sqr(brickmin.z-ball.z))<ballradius) and
         ((v.x<0) or (v.z<0)) then
        if (ballbrick.x>0) and (ballbrick.z>0) and
            CrashedBrick(ballbrick.z-1,ballbrick.y,ballbrick.x-1) or
           (ballbrick.x>0) and (ballbrick.z=0) and
            ((holes[nearp,ballbrick.y,ballbrick.x-1]=0) and (_12=0) or
             (_19>0)) or
           (ballbrick.x=0) and (ballbrick.z>0) and
            ((holes[leftp,ballbrick.y,5-ballbrick.z+1]=0) and (_12=0) or
             (_19>0)) then
          begin
            vtmp.x:=brickmin.x-ball.x; vtmp.y:=0; vtmp.z:=brickmin.z-ball.z;
            VSplitToAngles(vtmp,fitmp,sigmatmp,ptmp);
            fi:=fitmp-(fi-fitmp)-Pi;
            crashfivert:=true;
            if not brickcrashed then crashedwalls:=crashedwalls+[leftp,nearp];
          end;

      if not crashfihor and ([rightp,nearp]<=crashedplanes) and     {15}
         (ballbrick.y in [0..5]) and
         (Sqrt(Sqr(brickmax.x-ball.x)+Sqr(brickmin.z-ball.z))<ballradius) and
         ((v.x>0) or (v.z<0)) then
        if (ballbrick.x<5) and (ballbrick.z>0) and
            CrashedBrick(ballbrick.z-1,ballbrick.y,ballbrick.x+1) or
           (ballbrick.x<5) and (ballbrick.z=0) and
            ((holes[nearp,ballbrick.y,ballbrick.x+1]=0) and (_12=0) or
             (_19>0)) or
           (ballbrick.x=5) and (ballbrick.z>0) and
            ((holes[rightp,ballbrick.y,ballbrick.z-1]=0) and (_12=0) or
             (_19>0)) then
          begin
            vtmp.x:=brickmax.x-ball.x; vtmp.y:=0; vtmp.z:=brickmin.z-ball.z;
            VSplitToAngles(vtmp,fitmp,sigmatmp,ptmp);
            fi:=fitmp-(fi-fitmp)-Pi;
            crashfivert:=true;
            if not brickcrashed then crashedwalls:=crashedwalls+[rightp,nearp];
          end;

      if not crashfihor and ([rightp,farp]<=crashedplanes) and     {26}
         (ballbrick.y in [0..5]) and
         (Sqrt(Sqr(brickmax.x-ball.x)+Sqr(brickmax.z-ball.z))<ballradius) and
         ((v.x>0) or (v.z>0)) then
        if (ballbrick.x<5) and (ballbrick.z<5) and
            CrashedBrick(ballbrick.z+1,ballbrick.y,ballbrick.x+1) or
           (ballbrick.x<5) and (ballbrick.z=5) and
            ((holes[farp,ballbrick.y,5-ballbrick.x-1]=0) and (_12=0) or
             (_19>0)) or
           (ballbrick.x=5) and (ballbrick.z<5) and
            ((holes[rightp,ballbrick.y,ballbrick.z+1]=0) and (_12=0) or
             (_19>0)) then
          begin
            vtmp.x:=brickmax.x-ball.x; vtmp.y:=0; vtmp.z:=brickmax.z-ball.z;
            VSplitToAngles(vtmp,fitmp,sigmatmp,ptmp);
            fi:=fitmp-(fi-fitmp)-Pi;
            crashfivert:=true;
            if not brickcrashed then crashedwalls:=crashedwalls+[rightp,farp];
          end;

      if not crashfihor and ([leftp,farp]<=crashedplanes) and     {37}
         (ballbrick.y in [0..5]) and
         (Sqrt(Sqr(brickmin.x-ball.x)+Sqr(brickmax.z-ball.z))<ballradius) and
         ((v.x<0) or (v.z>0)) then
        if (ballbrick.x>0) and (ballbrick.z<5) and
            CrashedBrick(ballbrick.z+1,ballbrick.y,ballbrick.x-1) or
           (ballbrick.x>0) and (ballbrick.z=5) and
            ((holes[farp,ballbrick.y,5-ballbrick.x+1]=0) and (_12=0) or
             (_19>0)) or
           (ballbrick.x=0) and (ballbrick.z<5) and
            ((holes[leftp,ballbrick.y,5-ballbrick.z-1]=0) and (_12=0) or
             (_19>0)) then
          begin
            vtmp.x:=brickmin.x-ball.x; vtmp.y:=0; vtmp.z:=brickmax.z-ball.z;
            VSplitToAngles(vtmp,fitmp,sigmatmp,ptmp);
            fi:=fitmp-(fi-fitmp)-Pi;
            crashfivert:=true;
            if not brickcrashed then crashedwalls:=crashedwalls+[leftp,farp];
          end;

      if not crash and not crashsigma and not crashfihor and not crashfivert
        then begin

          {osetria sa narazy do vrcholov}
          if ([leftp,nearp,upp]<=crashedplanes) and         {0}
              (Sqrt(Sqr(brickmin.x-ball.x)+Sqr(brickmin.y-ball.y)+
                    Sqr(brickmin.z-ball.z))<ballradius) then
            if (ballbrick.x>0) and (ballbrick.y>0) and (ballbrick.z>0) and
                CrashedBrick(ballbrick.z-1,ballbrick.y-1,ballbrick.x-1) or
               (ballbrick.x>0) and (ballbrick.y>0) and (ballbrick.z=0) and
                ((holes[nearp,ballbrick.y-1,ballbrick.x-1]=0) and (_12=0) or
                 (_19>0)) or
               (ballbrick.x>0) and (ballbrick.y=0) and (ballbrick.z>0) and
                ((holes[upp,5-ballbrick.z+1,ballbrick.x-1]=0) and (_12=0) or
                 (_19>0)) or
               (ballbrick.x=0) and (ballbrick.y>0) and (ballbrick.z>0) and
                ((holes[leftp,ballbrick.y-1,5-ballbrick.z+1]=0) and (_12=0) or
                 (_19>0)) then
              begin
                vtmp.x:=brickmin.x-ball.x; vtmp.y:=brickmin.y-ball.y;
                vtmp.z:=brickmin.z-ball.z;
                VSplitToAngles(vtmp,fitmp,sigmatmp,ptmp);
                fi:=fitmp-(fi-fitmp)-Pi;
                sigma:=sigmatmp-(sigma-sigmatmp)-Pi;
                crash:=true;
                if not brickcrashed then
                  crashedwalls:=crashedwalls+[leftp,upp,nearp];
              end;

          if ([rightp,nearp,upp]<=crashedplanes) and         {1}
              (Sqrt(Sqr(brickmax.x-ball.x)+Sqr(brickmin.y-ball.y)+
                    Sqr(brickmin.z-ball.z))<ballradius) then
            if (ballbrick.x<5) and (ballbrick.y>0) and (ballbrick.z>0) and
                CrashedBrick(ballbrick.z-1,ballbrick.y-1,ballbrick.x+1) or
               (ballbrick.x<5) and (ballbrick.y>0) and (ballbrick.z=0) and
                ((holes[nearp,ballbrick.y-1,ballbrick.x+1]=0) and (_12=0) or
                 (_19>0)) or
               (ballbrick.x<5) and (ballbrick.y=0) and (ballbrick.z>0) and
                ((holes[upp,5-ballbrick.z+1,ballbrick.x+1]=0) and (_12=0) or
                 (_19>0)) or
               (ballbrick.x=5) and (ballbrick.y>0) and (ballbrick.z>0) and
                ((holes[rightp,ballbrick.y-1,ballbrick.z-1]=0) and (_12=0) or
                 (_19>0)) then
              begin
                vtmp.x:=brickmax.x-ball.x; vtmp.y:=brickmin.y-ball.y;
                vtmp.z:=brickmin.z-ball.z;
                VSplitToAngles(vtmp,fitmp,sigmatmp,ptmp);
                fi:=fitmp-(fi-fitmp)-Pi;
                sigma:=sigmatmp-(sigma-sigmatmp)-Pi;
                crash:=true;
                if not brickcrashed then
                  crashedwalls:=crashedwalls+[rightp,upp,nearp];
              end;

          if ([rightp,farp,upp]<=crashedplanes) and         {2}
              (Sqrt(Sqr(brickmax.x-ball.x)+Sqr(brickmin.y-ball.y)+
                    Sqr(brickmax.z-ball.z))<ballradius) then
            if (ballbrick.x<5) and (ballbrick.y>0) and (ballbrick.z<5) and
                CrashedBrick(ballbrick.z+1,ballbrick.y-1,ballbrick.x+1) or
               (ballbrick.x<5) and (ballbrick.y>0) and (ballbrick.z=5) and
                ((holes[farp,ballbrick.y-1,5-ballbrick.x-1]=0) and (_12=0) or
                 (_19>0)) or
               (ballbrick.x<5) and (ballbrick.y=0) and (ballbrick.z<5) and
                ((holes[upp,5-ballbrick.z-1,ballbrick.x+1]=0) and (_12=0) or
                 (_19>0)) or
               (ballbrick.x=5) and (ballbrick.y>0) and (ballbrick.z<5) and
                ((holes[rightp,ballbrick.y-1,ballbrick.z+1]=0) and (_12=0) or
                 (_19>0)) then
              begin
                vtmp.x:=brickmax.x-ball.x; vtmp.y:=brickmin.y-ball.y;
                vtmp.z:=brickmax.z-ball.z;
                VSplitToAngles(vtmp,fitmp,sigmatmp,ptmp);
                fi:=fitmp-(fi-fitmp)-Pi;
                sigma:=sigmatmp-(sigma-sigmatmp)-Pi;
                crash:=true;
                if not brickcrashed then
                  crashedwalls:=crashedwalls+[rightp,upp,farp];
              end;

          if ([leftp,farp,upp]<=crashedplanes) and         {3}
              (Sqrt(Sqr(brickmin.x-ball.x)+Sqr(brickmin.y-ball.y)+
                    Sqr(brickmax.z-ball.z))<ballradius) then
            if (ballbrick.x>0) and (ballbrick.y>0) and (ballbrick.z<5) and
                CrashedBrick(ballbrick.z+1,ballbrick.y-1,ballbrick.x-1) or
               (ballbrick.x>0) and (ballbrick.y>0) and (ballbrick.z=5) and
                ((holes[farp,ballbrick.y-1,5-ballbrick.x+1]=0) and (_12=0) or
                 (_19>0)) or
               (ballbrick.x>0) and (ballbrick.y=0) and (ballbrick.z<5) and
                ((holes[upp,5-ballbrick.z-1,ballbrick.x-1]=0) and (_12=0) or
                 (_19>0)) or
               (ballbrick.x=0) and (ballbrick.y>0) and (ballbrick.z<5) and
                ((holes[leftp,ballbrick.y-1,5-ballbrick.z-1]=0) and (_12=0) or
                 (_19>0)) then
              begin
                vtmp.x:=brickmin.x-ball.x; vtmp.y:=brickmin.y-ball.y;
                vtmp.z:=brickmax.z-ball.z;
                VSplitToAngles(vtmp,fitmp,sigmatmp,ptmp);
                fi:=fitmp-(fi-fitmp)-Pi;
                sigma:=sigmatmp-(sigma-sigmatmp)-Pi;
                crash:=true;
                if not brickcrashed then
                  crashedwalls:=crashedwalls+[leftp,upp,farp];
              end;

          if ([leftp,nearp,downp]<=crashedplanes) and         {4}
              (Sqrt(Sqr(brickmin.x-ball.x)+Sqr(brickmax.y-ball.y)+
                    Sqr(brickmin.z-ball.z))<ballradius) then
            if (ballbrick.x>0) and (ballbrick.y<5) and (ballbrick.z>0) and
                CrashedBrick(ballbrick.z-1,ballbrick.y+1,ballbrick.x-1) or
               (ballbrick.x>0) and (ballbrick.y<5) and (ballbrick.z=0) and
                ((holes[nearp,ballbrick.y+1,ballbrick.x-1]=0) and (_12=0) or
                 (_19>0)) or
               (ballbrick.x>0) and (ballbrick.y=5) and (ballbrick.z>0) and
                ((holes[downp,ballbrick.z-1,ballbrick.x-1]=0) and (_12=0) or
                 (_19>0)) or
               (ballbrick.x=0) and (ballbrick.y<5) and (ballbrick.z>0) and
                ((holes[leftp,ballbrick.y+1,5-ballbrick.z+1]=0) and (_12=0) or
                 (_19>0)) then
              begin
                vtmp.x:=brickmin.x-ball.x; vtmp.y:=brickmax.y-ball.y;
                vtmp.z:=brickmin.z-ball.z;
                VSplitToAngles(vtmp,fitmp,sigmatmp,ptmp);
                fi:=fitmp-(fi-fitmp)-Pi;
                sigma:=sigmatmp-(sigma-sigmatmp)-Pi;
                crash:=true;
                if not brickcrashed then
                  crashedwalls:=crashedwalls+[leftp,downp,nearp];
              end;

          if ([rightp,nearp,downp]<=crashedplanes) and         {5}
              (Sqrt(Sqr(brickmax.x-ball.x)+Sqr(brickmax.y-ball.y)+
                    Sqr(brickmin.z-ball.z))<ballradius) then
            if (ballbrick.x<5) and (ballbrick.y<5) and (ballbrick.z>0) and
                CrashedBrick(ballbrick.z-1,ballbrick.y+1,ballbrick.x+1) or
               (ballbrick.x<5) and (ballbrick.y<5) and (ballbrick.z=0) and
                ((holes[nearp,ballbrick.y+1,ballbrick.x+1]=0) and (_12=0) or
                 (_19>0)) or
               (ballbrick.x<5) and (ballbrick.y=5) and (ballbrick.z>0) and
                ((holes[downp,ballbrick.z-1,ballbrick.x+1]=0) and (_12=0) or
                 (_19>0)) or
               (ballbrick.x=5) and (ballbrick.y<5) and (ballbrick.z>0) and
                ((holes[rightp,ballbrick.y+1,ballbrick.z-1]=0) and (_12=0) or
                 (_19>0)) then
              begin
                vtmp.x:=brickmax.x-ball.x; vtmp.y:=brickmax.y-ball.y;
                vtmp.z:=brickmin.z-ball.z;
                VSplitToAngles(vtmp,fitmp,sigmatmp,ptmp);
                fi:=fitmp-(fi-fitmp)-Pi;
                sigma:=sigmatmp-(sigma-sigmatmp)-Pi;
                crash:=true;
                if not brickcrashed then
                  crashedwalls:=crashedwalls+[rightp,downp,nearp];
              end;

          if ([rightp,farp,downp]<=crashedplanes) and         {6}
              (Sqrt(Sqr(brickmax.x-ball.x)+Sqr(brickmax.y-ball.y)+
                    Sqr(brickmax.z-ball.z))<ballradius) then
            if (ballbrick.x<5) and (ballbrick.y<5) and (ballbrick.z<5) and
                CrashedBrick(ballbrick.z+1,ballbrick.y+1,ballbrick.x+1) or
               (ballbrick.x<5) and (ballbrick.y<5) and (ballbrick.z=5) and
                ((holes[farp,ballbrick.y+1,5-ballbrick.x-1]=0) and (_12=0) or
                 (_19>0)) or
               (ballbrick.x<5) and (ballbrick.y=5) and (ballbrick.z<5) and
                ((holes[downp,ballbrick.z+1,ballbrick.x+1]=0) and (_12=0) or
                 (_19>0)) or
               (ballbrick.x=5) and (ballbrick.y<5) and (ballbrick.z<5) and
                ((holes[rightp,ballbrick.y+1,ballbrick.z+1]=0) and (_12=0) or
                 (_19>0)) then
              begin
                vtmp.x:=brickmax.x-ball.x; vtmp.y:=brickmax.y-ball.y;
                vtmp.z:=brickmax.z-ball.z;
                VSplitToAngles(vtmp,fitmp,sigmatmp,ptmp);
                fi:=fitmp-(fi-fitmp)-Pi;
                sigma:=sigmatmp-(sigma-sigmatmp)-Pi;
                crash:=true;
                if not brickcrashed then
                  crashedwalls:=crashedwalls+[rightp,downp,farp];
              end;

          if ([leftp,farp,downp]<=crashedplanes) and         {7}
              (Sqrt(Sqr(brickmin.x-ball.x)+Sqr(brickmax.y-ball.y)+
                    Sqr(brickmax.z-ball.z))<ballradius) then
            if (ballbrick.x>0) and (ballbrick.y<5) and (ballbrick.z<5) and
                CrashedBrick(ballbrick.z+1,ballbrick.y+1,ballbrick.x-1) or
               (ballbrick.x>0) and (ballbrick.y<5) and (ballbrick.z=5) and
                ((holes[farp,ballbrick.y+1,5-ballbrick.x+1]=0) and (_12=0) or
                 (_19>0)) or
               (ballbrick.x>0) and (ballbrick.y=5) and (ballbrick.z<5) and
                ((holes[downp,ballbrick.z+1,ballbrick.x-1]=0) and (_12=0) or
                 (_19>0)) or
               (ballbrick.x=0) and (ballbrick.y<5) and (ballbrick.z<5) and
                ((holes[leftp,ballbrick.y+1,5-ballbrick.z-1]=0) and (_12=0) or
                 (_19>0)) then
              begin
                vtmp.x:=brickmin.x-ball.x; vtmp.y:=brickmax.y-ball.y;
                vtmp.z:=brickmax.z-ball.z;
                VSplitToAngles(vtmp,fitmp,sigmatmp,ptmp);
                fi:=fitmp-(fi-fitmp)-Pi;
                sigma:=sigmatmp-(sigma-sigmatmp)-Pi;
                crash:=true;
                if not brickcrashed then
                  crashedwalls:=crashedwalls+[leftp,downp,farp];
              end;
        end;


      VComputeFromAngles(v,fi,sigma,p);

      {ked je lopta dnu zaposobi gravitacia a zmeni rychlost}
      if ballin then
        begin
          if leftp in gravity then v.x:=v.x-g/2000;
          if rightp in gravity then v.x:=v.x+g/2000;
          if upp in gravity then v.y:=v.y-g/2000;
          if downp in gravity then v.y:=v.y+g/2000;
          if nearp in gravity then v.z:=v.z-g/2000;
          if farp in gravity then v.z:=v.z+g/2000;
        end;

      if crash or crashsigma or crashfihor or crashfivert then
        begin
          ball:=ball2;

          {zaposobi pruznost a zmeni sa velkost rychlosti}
          VRMul(v,v,ro);
          if not brickcrashed then WallCrashSound;
        end;

    end;



{ KRESLIACE PROCEDURY }

    function VisiblePlane(plane:tcubeplanes;vertindex:integer):boolean;
      {zisti ci je plocha plane aktualnej tehly privratena,
       transfpoints[vertindex] je jeden vrchol plochy}
      begin
        {podla uhla s viewvectorom (transfpoints[vertindex]) sa urci,
         ci je plocha privratena}
        if VDotProduct(planesnormals[plane],transfpoints[vertindex])<0
          then VisiblePlane:=true
          else VisiblePlane:=false;
      end;



  procedure DrawLeftPlane;
    {nakresli left plochu miestnosti aj s dierami}
    var i,j,idx1,idx2,idx3,idx4:integer;
        col:byte;

    begin
      for i:=0 to 5 do
        for j:=0 to 5 do
          if (holes[leftp,i,j]=0) or (_19>0) then
            begin
              idx1:=(6-j)*49+i*7;
              idx2:=(6-j)*49+(i+1)*7;
              idx3:=(6-j-1)*49+(i+1)*7;
              idx4:=(6-j-1)*49+i*7;
              if (j=0) or (holes[leftp,i,j-1]=1) and (_19=0) then
                begin
                  if j=0 then col:=7 else col:=3;
                  Line13h(projpoints[idx1].x,projpoints[idx1].y,
                          projpoints[idx2].x,projpoints[idx2].y,
                          roomcolor+col);
                end;
              if (j=5) or (holes[leftp,i,j+1]=1) and (_19=0) then
                begin
                  if j=5 then col:=7 else col:=3;
                  Line13h(projpoints[idx3].x,projpoints[idx3].y,
                          projpoints[idx4].x,projpoints[idx4].y,
                          roomcolor+col);
                end;
              if (i=0) or (holes[leftp,i-1,j]=1) and (_19=0) then
                begin
                  if i=0 then col:=7 else col:=3;
                  Line13h(projpoints[idx1].x,projpoints[idx1].y,
                          projpoints[idx4].x,projpoints[idx4].y,
                          roomcolor+col);
                end;
              if (i=5) or (holes[leftp,i+1,j]=1) and (_19=0) then
                begin
                  if i=5 then col:=7 else col:=3;
                  Line13h(projpoints[idx2].x,projpoints[idx2].y,
                          projpoints[idx3].x,projpoints[idx3].y,
                          roomcolor+col);
                end;
            end;
    end;



  procedure DrawRightPlane;
    {nakresli right plochu miestnosti aj s dierami}
    var i,j,idx1,idx2,idx3,idx4:integer;
        col:byte;

    begin
      for i:=0 to 5 do
        for j:=0 to 5 do
          if (holes[rightp,i,j]=0) or (_19>0) then
            begin
              idx1:=j*49+i*7+6;
              idx2:=j*49+(i+1)*7+6;
              idx3:=(j+1)*49+(i+1)*7+6;
              idx4:=(j+1)*49+i*7+6;
              if (j=0) or (holes[rightp,i,j-1]=1) and (_19=0) then
                begin
                  if j=0 then col:=7 else col:=3;
                  Line13h(projpoints[idx1].x,projpoints[idx1].y,
                          projpoints[idx2].x,projpoints[idx2].y,
                          roomcolor+col);
                end;
              if (j=5) or (holes[rightp,i,j+1]=1) and (_19=0) then
                begin
                  if j=5 then col:=7 else col:=3;
                  Line13h(projpoints[idx3].x,projpoints[idx3].y,
                          projpoints[idx4].x,projpoints[idx4].y,
                          roomcolor+col);
                end;
              if (i=0) or (holes[rightp,i-1,j]=1) and (_19=0) then
                begin
                  if i=0 then col:=7 else col:=3;
                  Line13h(projpoints[idx1].x,projpoints[idx1].y,
                          projpoints[idx4].x,projpoints[idx4].y,
                          roomcolor+col);
                end;
              if (i=5) or (holes[rightp,i+1,j]=1) and (_19=0) then
                begin
                  if i=5 then col:=7 else col:=3;
                  Line13h(projpoints[idx2].x,projpoints[idx2].y,
                          projpoints[idx3].x,projpoints[idx3].y,
                          roomcolor+col);
                end;
            end;
    end;



  procedure DrawUpPlane;
    {nakresli up plochu miestnosti aj s dierami}
    var i,j,idx1,idx2,idx3,idx4:integer;
        col:byte;

    begin
      for i:=0 to 5 do
        for j:=0 to 5 do
          if (holes[upp,i,j]=0) or (_19>0) then
            begin
              idx1:=(6-i)*49+j;
              idx2:=(6-i-1)*49+j;
              idx3:=(6-i-1)*49+j+1;
              idx4:=(6-i)*49+j+1;
              if (j=0) or (holes[upp,i,j-1]=1) and (_19=0) then
                begin
                  if j=0 then col:=7 else col:=3;
                  Line13h(projpoints[idx1].x,projpoints[idx1].y,
                          projpoints[idx2].x,projpoints[idx2].y,
                          roomcolor+col);
                end;
              if (j=5) or (holes[upp,i,j+1]=1) and (_19=0) then
                begin
                  if j=5 then col:=7 else col:=3;
                  Line13h(projpoints[idx3].x,projpoints[idx3].y,
                          projpoints[idx4].x,projpoints[idx4].y,
                          roomcolor+col);
                end;
              if (i=0) or (holes[upp,i-1,j]=1) and (_19=0) then
                begin
                  if i=0 then col:=7 else col:=3;
                  Line13h(projpoints[idx1].x,projpoints[idx1].y,
                          projpoints[idx4].x,projpoints[idx4].y,
                          roomcolor+col);
                end;
              if (i=5) or (holes[upp,i+1,j]=1) and (_19=0) then
                begin
                  if i=5 then col:=7 else col:=3;
                  Line13h(projpoints[idx2].x,projpoints[idx2].y,
                          projpoints[idx3].x,projpoints[idx3].y,
                          roomcolor+col);
                end;
            end;
    end;



  procedure DrawDownPlane;
    {nakresli down plochu miestnosti aj s dierami}
    var i,j,idx1,idx2,idx3,idx4:integer;
        col:byte;

    begin
      for i:=0 to 5 do
        for j:=0 to 5 do
          if (holes[downp,i,j]=0) or (_19>0) then
            begin
              idx1:=i*49+6*7+j;
              idx2:=(i+1)*49+6*7+j;
              idx3:=(i+1)*49+6*7+j+1;
              idx4:=i*49+6*7+j+1;
              if (j=0) or (holes[downp,i,j-1]=1) and (_19=0) then
                begin
                  if j=0 then col:=7 else col:=3;
                  Line13h(projpoints[idx1].x,projpoints[idx1].y,
                          projpoints[idx2].x,projpoints[idx2].y,
                          roomcolor+col);
                end;
              if (j=5) or (holes[downp,i,j+1]=1) and (_19=0) then
                begin
                  if j=5 then col:=7 else col:=3;
                  Line13h(projpoints[idx3].x,projpoints[idx3].y,
                          projpoints[idx4].x,projpoints[idx4].y,
                          roomcolor+col);
                end;
              if (i=0) or (holes[downp,i-1,j]=1) and (_19=0) then
                begin
                  if i=0 then col:=7 else col:=3;
                  Line13h(projpoints[idx1].x,projpoints[idx1].y,
                          projpoints[idx4].x,projpoints[idx4].y,
                          roomcolor+col);
                end;
              if (i=5) or (holes[downp,i+1,j]=1) and (_19=0) then
                begin
                  if i=5 then col:=7 else col:=3;
                  Line13h(projpoints[idx2].x,projpoints[idx2].y,
                          projpoints[idx3].x,projpoints[idx3].y,
                          roomcolor+col);
                end;
            end;
    end;



  procedure DrawNearPlane;
    {nakresli near plochu miestnosti aj s dierami}
    var i,j,idx1,idx2,idx3,idx4:integer;
        col:byte;

    begin
      for i:=0 to 5 do
        for j:=0 to 5 do
          if (holes[nearp,i,j]=0) or (_19>0) then
            begin
              idx1:=i*7+j;
              idx2:=(i+1)*7+j;
              idx3:=(i+1)*7+j+1;
              idx4:=i*7+j+1;
              if (j=0) or (holes[nearp,i,j-1]=1) and (_19=0) then
                begin
                  if j=0 then col:=7 else col:=3;
                  Line13h(projpoints[idx1].x,projpoints[idx1].y,
                          projpoints[idx2].x,projpoints[idx2].y,
                          roomcolor+col);
                end;
              if (j=5) or (holes[nearp,i,j+1]=1) and (_19=0) then
                begin
                  if j=5 then col:=7 else col:=3;
                  Line13h(projpoints[idx3].x,projpoints[idx3].y,
                          projpoints[idx4].x,projpoints[idx4].y,
                          roomcolor+col);
                end;
              if (i=0) or (holes[nearp,i-1,j]=1) and (_19=0) then
                begin
                  if i=0 then col:=7 else col:=3;
                  Line13h(projpoints[idx1].x,projpoints[idx1].y,
                          projpoints[idx4].x,projpoints[idx4].y,
                          roomcolor+col);
                end;
              if (i=5) or (holes[nearp,i+1,j]=1) and (_19=0) then
                begin
                  if i=5 then col:=7 else col:=3;
                  Line13h(projpoints[idx2].x,projpoints[idx2].y,
                          projpoints[idx3].x,projpoints[idx3].y,
                          roomcolor+col);
                end;
            end;
    end;



  procedure DrawFarPlane;
    {nakresli down plochu miestnosti aj s dierami}
    var i,j,idx1,idx2,idx3,idx4:integer;
        col:byte;

    begin
      for i:=0 to 5 do
        for j:=0 to 5 do
          if (holes[farp,i,j]=0) or (_19>0) then
            begin
              idx1:=6*49+i*7+6-j;
              idx2:=6*49+(i+1)*7+6-j;
              idx3:=6*49+(i+1)*7+6-j-1;
              idx4:=6*49+i*7+6-j-1;
              if (j=0) or (holes[farp,i,j-1]=1) and (_19=0) then
                begin
                  if j=0 then col:=7 else col:=3;
                  Line13h(projpoints[idx1].x,projpoints[idx1].y,
                          projpoints[idx2].x,projpoints[idx2].y,
                          roomcolor+col);
                end;
              if (j=5) or (holes[farp,i,j+1]=1) and (_19=0) then
                begin
                  if j=5 then col:=7 else col:=3;
                  Line13h(projpoints[idx3].x,projpoints[idx3].y,
                          projpoints[idx4].x,projpoints[idx4].y,
                          roomcolor+col);
                end;
              if (i=0) or (holes[farp,i-1,j]=1) and (_19=0) then
                begin
                  if i=0 then col:=7 else col:=3;
                  Line13h(projpoints[idx1].x,projpoints[idx1].y,
                          projpoints[idx4].x,projpoints[idx4].y,
                          roomcolor+col);
                end;
              if (i=5) or (holes[farp,i+1,j]=1) and (_19=0) then
                begin
                  if i=5 then col:=7 else col:=3;
                  Line13h(projpoints[idx2].x,projpoints[idx2].y,
                          projpoints[idx3].x,projpoints[idx3].y,
                          roomcolor+col);
                end;
            end;
    end;



  procedure DrawRoomPlanes(visswitch:boolean);
    {ak visswitch nakresli viditelne steny miestnosti, inak neviditelne}
    begin
      if VisiblePlane(leftp,0)=visswitch then DrawLeftPlane;
      if VisiblePlane(rightp,7*49-1)=visswitch then DrawRightPlane;
      if VisiblePlane(upp,0)=visswitch then DrawUpPlane;
      if VisiblePlane(downp,7*49-1)=visswitch then DrawDownPlane;
      if VisiblePlane(nearp,0)=visswitch then DrawNearPlane;
      if VisiblePlane(farp,7*49-1)=visswitch then DrawFarPlane;
    end;


  procedure DrawBricks(bi,bj,bk,rmni,rmnj,rmnk,rmxi,rmxj,rmxk:integer);
    {nakresli tehly za neviditelnymi stenami tehly[bi,bj,bk] v priestore
     [rmni..rmxi,rmnj..rmxj,rmnk..rmxk], potom ju
     a potom tehly pred vididitelnymi stenami}
    var visibleplanes,invisibleplanes:tsetofcubeplanes;
        cubeverts:array[0..7] of 0..7*7*7-1;


    procedure DrawBrick;
      {fyzicky vykresli viditelne plochy aktualnej tehly [bi,bj,bk]}
      var btype:byte;
      begin
        if leftp in visibleplanes then
          begin
            btype:=bricks[bi,bj,bk-1];
            if (bk=0) or (btype<$C0) or ((btype and $0F)=$B) or
               ((btype and $0F)=$C) and (_bricks mod 20>=10) then
           FourAngle13h(projpoints[cubeverts[0]].x,projpoints[cubeverts[0]].y,
                        projpoints[cubeverts[3]].x,projpoints[cubeverts[3]].y,
                        projpoints[cubeverts[7]].x,projpoints[cubeverts[7]].y,
                        projpoints[cubeverts[4]].x,projpoints[cubeverts[4]].y,
                        brickscolors[bi,bj,bk]+planesshades[leftp]);
          end;

        if rightp in visibleplanes then
          begin
            btype:=bricks[bi,bj,bk+1];
            if (bk=5) or (btype<$C0) or ((btype and $0F)=$B) or
               ((btype and $0F)=$C) and (_bricks mod 20>=10) then
           FourAngle13h(projpoints[cubeverts[1]].x,projpoints[cubeverts[1]].y,
                        projpoints[cubeverts[5]].x,projpoints[cubeverts[5]].y,
                        projpoints[cubeverts[6]].x,projpoints[cubeverts[6]].y,
                        projpoints[cubeverts[2]].x,projpoints[cubeverts[2]].y,
                        brickscolors[bi,bj,bk]+planesshades[rightp]);
          end;

        if upp in visibleplanes then
          begin
            btype:=bricks[bi,bj-1,bk];
            if (bj=0) or (btype<$C0) or ((btype and $0F)=$B) or
               ((btype and $0F)=$C) and (_bricks mod 20>=10) then
           FourAngle13h(projpoints[cubeverts[0]].x,projpoints[cubeverts[0]].y,
                        projpoints[cubeverts[1]].x,projpoints[cubeverts[1]].y,
                        projpoints[cubeverts[2]].x,projpoints[cubeverts[2]].y,
                        projpoints[cubeverts[3]].x,projpoints[cubeverts[3]].y,
                        brickscolors[bi,bj,bk]+planesshades[upp]);
           end;

        if downp in visibleplanes then
          begin
            btype:=bricks[bi,bj+1,bk];
            if (bj=5) or (btype<$C0) or ((btype and $0F)=$B) or
               ((btype and $0F)=$C) and (_bricks mod 20>=10) then
           FourAngle13h(projpoints[cubeverts[4]].x,projpoints[cubeverts[4]].y,
                        projpoints[cubeverts[7]].x,projpoints[cubeverts[7]].y,
                        projpoints[cubeverts[6]].x,projpoints[cubeverts[6]].y,
                        projpoints[cubeverts[5]].x,projpoints[cubeverts[5]].y,
                        brickscolors[bi,bj,bk]+planesshades[downp]);
           end;

        if nearp in visibleplanes then
          begin
            btype:=bricks[bi-1,bj,bk];
            if (bi=0) or (btype<$C0) or ((btype and $0F)=$B) or
               ((btype and $0F)=$C) and (_bricks mod 20>=10) then
           FourAngle13h(projpoints[cubeverts[0]].x,projpoints[cubeverts[0]].y,
                        projpoints[cubeverts[4]].x,projpoints[cubeverts[4]].y,
                        projpoints[cubeverts[5]].x,projpoints[cubeverts[5]].y,
                        projpoints[cubeverts[1]].x,projpoints[cubeverts[1]].y,
                        brickscolors[bi,bj,bk]+planesshades[nearp]);
          end;

        if farp in visibleplanes then
          begin
            btype:=bricks[bi+1,bj,bk];
            if (bi=5) or (btype<$C0) or ((btype and $0F)=$B) or
               ((btype and $0F)=$C) and (_bricks mod 20>=10) then
           FourAngle13h(projpoints[cubeverts[3]].x,projpoints[cubeverts[3]].y,
                        projpoints[cubeverts[2]].x,projpoints[cubeverts[2]].y,
                        projpoints[cubeverts[6]].x,projpoints[cubeverts[6]].y,
                        projpoints[cubeverts[7]].x,projpoints[cubeverts[7]].y,
                        brickscolors[bi,bj,bk]+planesshades[farp]);
          end;
      end;


    procedure TransfBonus;
      {nakresli bonus}
      var v1ind,v2ind:integer;
      begin
        v1ind:=bi*49+bj*7+bk; v2ind:=(bi+1)*49+(bj+1)*7+bk+1;
        transfbrickcenter.x:=(transfpoints[v1ind].x+transfpoints[v2ind].x)/2;
        transfbrickcenter.y:=(transfpoints[v1ind].y+transfpoints[v2ind].y)/2;
        transfbrickcenter.z:=(transfpoints[v1ind].z+transfpoints[v2ind].z)/2;
        transfbonusradius:=bonusradius*eyedist/transfbrickcenter.z;
        ProjectPoint(projbrickcenter,transfbrickcenter);
        DrawBonus(brickscolors[bi,bj,bk]);
      end;


    procedure DrawBrickBonus;
      {nakresli podla bricks[bi,bj,bk] a brickscolors[bi,bj,bk] co treba}
      var btypef:byte;
      begin
        if (bricks[bi,bj,bk] and $80)=$80 then
          if (bricks[bi,bj,bk] and $40)=$40 then
            begin
              btypef:=bricks[bi,bj,bk] and $0F;
              if btypef in [$1..$A,$D,$E,$F] then DrawBrick
              else if (btypef=$B) and (_30>0) then DrawBrick
              else if (btypef=$C) and (_bricks mod 20<10) then DrawBrick;
            end
          else TransfBonus;
      end;


    begin
      bricksdone[bi,bj,bk]:=true;

        {vypocitaju sa cisla bodov rohov aktualnej tehly}
      cubeverts[0]:=49*bi+7*bj+bk;
      cubeverts[1]:=49*bi+7*bj+bk+1;
      cubeverts[2]:=49*(bi+1)+7*bj+bk+1;
      cubeverts[3]:=49*(bi+1)+7*bj+bk;
      cubeverts[4]:=49*bi+7*(bj+1)+bk;
      cubeverts[5]:=49*bi+7*(bj+1)+bk+1;
      cubeverts[6]:=49*(bi+1)+7*(bj+1)+bk+1;
      cubeverts[7]:=49*(bi+1)+7*(bj+1)+bk;

        {teraz sa zisti, ktore plochy su viditelne a ktore nie}
      visibleplanes:=[]; invisibleplanes:=[];
      if not (leftp in invisibleplanes) and VisiblePlane(leftp,cubeverts[0]) then
        begin
          visibleplanes:=visibleplanes+[leftp];
          invisibleplanes:=invisibleplanes+[rightp];
        end
      else invisibleplanes:=invisibleplanes+[leftp];
      if not (rightp in invisibleplanes) and VisiblePlane(rightp,cubeverts[6]) then
        begin
          visibleplanes:=visibleplanes+[rightp];
          invisibleplanes:=invisibleplanes+[leftp];
        end
      else invisibleplanes:=invisibleplanes+[rightp];
      if not (upp in invisibleplanes) and VisiblePlane(upp,cubeverts[0]) then
        begin
          visibleplanes:=visibleplanes+[upp];
          invisibleplanes:=invisibleplanes+[downp];
        end
      else invisibleplanes:=invisibleplanes+[upp];
      if not (downp in invisibleplanes) and VisiblePlane(downp,cubeverts[6]) then
        begin
          visibleplanes:=visibleplanes+[downp];
          invisibleplanes:=invisibleplanes+[upp];
        end
      else invisibleplanes:=invisibleplanes+[downp];
      if not (nearp in invisibleplanes) and VisiblePlane(nearp,cubeverts[0]) then
        begin
          visibleplanes:=visibleplanes+[nearp];
          invisibleplanes:=invisibleplanes+[farp];
        end
      else invisibleplanes:=invisibleplanes+[nearp];
      if not (farp in invisibleplanes) and VisiblePlane(farp,cubeverts[6]) then
        begin
          visibleplanes:=visibleplanes+[farp];
          invisibleplanes:=invisibleplanes+[nearp];
        end
      else invisibleplanes:=invisibleplanes+[farp];

        {vykreslia sa vsetky tehly za neviditelnymi plochami}
      if (leftp in invisibleplanes) and (bk>rmnk) and not bricksdone[bi,bj,bk-1]
        then DrawBricks(bi,bj,bk-1,rmni,rmnj,rmnk,rmxi,rmxj,bk-1);
      if (rightp in invisibleplanes) and (bk<rmxk) and not bricksdone[bi,bj,bk+1]
        then DrawBricks(bi,bj,bk+1,rmni,rmnj,bk+1,rmxi,rmxj,rmxk);
      if (upp in invisibleplanes) and (bj>rmnj) and not bricksdone[bi,bj-1,bk]
        then DrawBricks(bi,bj-1,bk,rmni,rmnj,rmnk,rmxi,bj-1,rmxk);
      if (downp in invisibleplanes) and (bj<rmxj) and not bricksdone[bi,bj+1,bk]
        then DrawBricks(bi,bj+1,bk,rmni,bj+1,rmnk,rmxi,rmxj,rmxk);
      if (nearp in invisibleplanes) and (bi>rmni) and not bricksdone[bi-1,bj,bk]
        then DrawBricks(bi-1,bj,bk,rmni,rmnj,rmnk,bi-1,rmxj,rmxk);
      if (farp in invisibleplanes) and (bi<rmxi) and not bricksdone[bi+1,bj,bk]
        then DrawBricks(bi+1,bj,bk,bi+1,rmnj,rmnk,rmxi,rmxj,rmxk);

        {nakresli sa tehla alebo bonus}
      if _4=0 then DrawBrickBonus;
        {alebo lopta}
      if _5=0 then
        if ballin and (bb.z=bi) and (bb.y=bj) and (bb.x=bk) then
        DrawBallSprite;

        {a vykreslia sa vsetky tehly pred viditelnymi plochami}
      if (leftp in visibleplanes) and (bk>rmnk) and not bricksdone[bi,bj,bk-1]
        then DrawBricks(bi,bj,bk-1,rmni,rmnj,rmnk,rmxi,rmxj,rmxk);
      if (rightp in visibleplanes) and (bk<rmxk) and not bricksdone[bi,bj,bk+1]
        then DrawBricks(bi,bj,bk+1,rmni,rmnj,rmnk,rmxi,rmxj,rmxk);
      if (upp in visibleplanes) and (bj>rmnj) and not bricksdone[bi,bj-1,bk]
        then DrawBricks(bi,bj-1,bk,rmni,rmnj,rmnk,rmxi,rmxj,rmxk);
      if (downp in visibleplanes) and (bj<rmxj) and not bricksdone[bi,bj+1,bk]
        then DrawBricks(bi,bj+1,bk,rmni,rmnj,rmnk,rmxi,rmxj,rmxk);
      if (nearp in visibleplanes) and (bi>rmni) and not bricksdone[bi-1,bj,bk]
        then DrawBricks(bi-1,bj,bk,rmni,rmnj,rmnk,rmxi,rmxj,rmxk);
      if (farp in visibleplanes) and (bi<rmxi) and not bricksdone[bi+1,bj,bk]
        then DrawBricks(bi+1,bj,bk,rmni,rmnj,rmnk,rmxi,rmxj,rmxk);
    end;



  procedure DrawRoom;
    {nakresli celu miestnost}
    var cvert0,cvert6:integer;
        farestvis,farestinvis:byte;
        crashedplanes,visplanes:tsetofcubeplanes;
        sqrbr:single;

    procedure FindFarestCube(testplanes:tsetofcubeplanes; dk,dj,di:integer);
      {ak je kocka za stenami testplanes od kocky ballbrick vzdialenejsia ako
       doteraz najdena najvzdialenejsia (v bb), zmen bb na nu}
       var vis,invis:byte;
           j:tcubeplanes;
       begin
         vis:=0; invis:=0;
         for j:=leftp to farp do
           if j in testplanes then
             if j in visplanes then Inc(vis)
             else Inc(invis);
         if (invis>farestinvis) or (invis=farestinvis) and (vis<farestvis) then
           begin
             bb.x:=ballbrick.x+dk; bb.y:=ballbrick.y+dj; bb.z:=ballbrick.z+di;
             farestvis:=vis; farestinvis:=invis;
           end;
       end;

    begin
      ComputePlanesNormals;
      ComputePlanesShades;

      {osetri ak je lopta mimo miestnosti (kedy sa ma kreslit)}
      if ballin then
        begin
          cvert0:=49*ballbrick.z+7*ballbrick.y+ballbrick.x;
          cvert6:=49*(ballbrick.z+1)+7*(ballbrick.y+1)+ballbrick.x+1;
          visplanes:=[];
          if VisiblePlane(leftp,cvert0) then visplanes:=[leftp];
          if VisiblePlane(rightp,cvert6) then visplanes:=visplanes+[rightp];
          if VisiblePlane(upp,cvert0) then visplanes:=visplanes+[upp];
          if VisiblePlane(downp,cvert6) then visplanes:=visplanes+[downp];
          if VisiblePlane(nearp,cvert0) then visplanes:=visplanes+[nearp];
          if VisiblePlane(farp,cvert6) then visplanes:=visplanes+[farp];

          crashedplanes:=[];
          if (ball.x-brickmin.x<ballradius) and (ballbrick.x>0) then
            crashedplanes:=[leftp];
          if (brickmax.x-ball.x<ballradius) and (ballbrick.x<5) then
            crashedplanes:=crashedplanes+[rightp];
          if (ball.y-brickmin.y<ballradius) and (ballbrick.y>0) then
            crashedplanes:=crashedplanes+[upp];
          if (brickmax.y-ball.y<ballradius) and (ballbrick.y<5) then
            crashedplanes:=crashedplanes+[downp];
          if (ball.z-brickmin.z<ballradius) and (ballbrick.z>0) then
            crashedplanes:=crashedplanes+[nearp];
          if (brickmax.z-ball.z<ballradius) and (ballbrick.z<5) then
            crashedplanes:=crashedplanes+[farp];

          farestvis:=0; farestinvis:=0;
          bb:=ballbrick;
          if leftp in crashedplanes then FindFarestCube([leftp],-1,0,0);
          if rightp in crashedplanes then FindFarestCube([rightp],1,0,0);
          if upp in crashedplanes then FindFarestCube([upp],0,-1,0);
          if downp in crashedplanes then FindFarestCube([downp],0,1,0);
          if nearp in crashedplanes then FindFarestCube([nearp],0,0,-1);
          if farp in crashedplanes then FindFarestCube([farp],0,0,1);

          sqrbr:=Sqr(ballradius);
          if ([nearp,upp]<=crashedplanes) and
             (Sqr(brickmin.y-ball.y)+Sqr(brickmin.z-ball.z)<sqrbr) then
            FindFarestCube([nearp,upp],0,-1,-1);
          if ([rightp,upp]<=crashedplanes) and
             (Sqr(brickmax.x-ball.x)+Sqr(brickmin.y-ball.y)<sqrbr) then
            FindFarestCube([rightp,upp],1,-1,0);
          if ([farp,upp]<=crashedplanes) and
             (Sqr(brickmin.y-ball.y)+Sqr(brickmax.z-ball.z)<sqrbr) then
            FindFarestCube([farp,upp],0,-1,1);
          if ([leftp,upp]<=crashedplanes) and
             (Sqr(brickmin.x-ball.x)+Sqr(brickmin.y-ball.y)<sqrbr) then
            FindFarestCube([leftp,upp],-1,-1,0);
          if ([nearp,downp]<=crashedplanes) and
             (Sqr(brickmax.y-ball.y)+Sqr(brickmin.z-ball.z)<sqrbr) then
            FindFarestCube([nearp,downp],0,1,-1);
          if ([rightp,downp]<=crashedplanes) and
             (Sqr(brickmax.x-ball.x)+Sqr(brickmax.y-ball.y)<sqrbr) then
            FindFarestCube([rightp,downp],1,1,0);
          if ([farp,downp]<=crashedplanes) and
             (Sqr(brickmax.y-ball.y)+Sqr(brickmax.z-ball.z)<sqrbr) then
            FindFarestCube([farp,downp],0,1,1);
          if ([leftp,downp]<=crashedplanes) and
             (Sqr(brickmin.x-ball.x)+Sqr(brickmax.y-ball.y)<sqrbr) then
            FindFarestCube([leftp,downp],-1,1,0);
          if ([leftp,nearp]<=crashedplanes) and
             (Sqr(brickmin.x-ball.x)+Sqr(brickmin.z-ball.z)<sqrbr) then
            FindFarestCube([leftp,nearp],-1,0,-1);
          if ([rightp,nearp]<=crashedplanes) and
             (Sqr(brickmax.x-ball.x)+Sqr(brickmin.z-ball.z)<sqrbr) then
            FindFarestCube([rightp,nearp],1,0,-1);
          if ([rightp,farp]<=crashedplanes) and
             (Sqr(brickmax.x-ball.x)+Sqr(brickmax.z-ball.z)<sqrbr) then
            FindFarestCube([rightp,farp],1,0,1);
          if ([leftp,farp]<=crashedplanes) and
             (Sqr(brickmin.x-ball.x)+Sqr(brickmax.z-ball.z)<sqrbr) then
            FindFarestCube([leftp,farp],-1,0,1);

          if ([leftp,nearp,upp]<=crashedplanes) and
             (Sqr(brickmin.x-ball.x)+Sqr(brickmin.y-ball.y)+
              Sqr(brickmin.z-ball.z)<sqrbr) then
            FindFarestCube([leftp,nearp,upp],-1,-1,-1);
          if ([rightp,nearp,upp]<=crashedplanes) and
             (Sqr(brickmax.x-ball.x)+Sqr(brickmin.y-ball.y)+
              Sqr(brickmin.z-ball.z)<sqrbr) then
            FindFarestCube([rightp,nearp,upp],1,-1,-1);
          if ([rightp,farp,upp]<=crashedplanes) and
             (Sqr(brickmax.x-ball.x)+Sqr(brickmin.y-ball.y)+
              Sqr(brickmax.z-ball.z)<sqrbr) then
            FindFarestCube([rightp,farp,upp],1,-1,1);
          if ([leftp,farp,upp]<=crashedplanes) and
             (Sqr(brickmin.x-ball.x)+Sqr(brickmin.y-ball.y)+
              Sqr(brickmax.z-ball.z)<sqrbr) then
            FindFarestCube([leftp,farp,upp],-1,-1,1);
          if ([leftp,nearp,downp]<=crashedplanes) and
             (Sqr(brickmin.x-ball.x)+Sqr(brickmax.y-ball.y)+
              Sqr(brickmin.z-ball.z)<sqrbr) then
            FindFarestCube([leftp,nearp,downp],-1,1,-1);
          if ([rightp,nearp,downp]<=crashedplanes) and
             (Sqr(brickmax.x-ball.x)+Sqr(brickmax.y-ball.y)+
              Sqr(brickmin.z-ball.z)<sqrbr) then
            FindFarestCube([rightp,nearp,downp],1,1,-1);
          if ([rightp,farp,downp]<=crashedplanes) and
             (Sqr(brickmax.x-ball.x)+Sqr(brickmax.y-ball.y)+
              Sqr(brickmax.z-ball.z)<sqrbr) then
            FindFarestCube([rightp,farp,downp],1,1,1);
          if ([leftp,farp,downp]<=crashedplanes) and
             (Sqr(brickmin.x-ball.x)+Sqr(brickmax.y-ball.y)+
              Sqr(brickmax.z-ball.z)<sqrbr) then
            FindFarestCube([leftp,farp,downp],-1,1,1);
        end
      else
        begin
          with bb do
            begin x:=2; y:=2; z:=2; end;

          ballnear:=false;

          if VisiblePlane(leftp,0) and
             (VDotProduct(planesnormals[leftp],transfball)+
             ComputeDCoeficient(leftp,0)>0) then ballnear:=true;

          if not ballnear and VisiblePlane(rightp,7*49-1) and
             (VDotProduct(planesnormals[rightp],transfball)+
             ComputeDCoeficient(rightp,7*49-1)>0) then ballnear:=true;

          if not ballnear and VisiblePlane(upp,0) and
             (VDotProduct(planesnormals[upp],transfball)+
             ComputeDCoeficient(upp,0)>0) then ballnear:=true;

          if not ballnear and VisiblePlane(downp,7*49-1) and
             (VDotProduct(planesnormals[downp],transfball)+
             ComputeDCoeficient(downp,7*49-1)>0) then ballnear:=true;

          if not ballnear and VisiblePlane(nearp,0) and
             (VDotProduct(planesnormals[nearp],transfball)+
             ComputeDCoeficient(nearp,0)>0) then ballnear:=true;

          if not ballnear and VisiblePlane(farp,7*49-1) and
             (VDotProduct(planesnormals[farp],transfball)+
             ComputeDCoeficient(farp,7*49-1)>0) then ballnear:=true;
        end;

      FillChar(bricksdone,SizeOf(bricksdone),0);
      if not ballin and not ballnear and not balloutscreen then DrawBallSprite;
      if _12=0 then DrawRoomPlanes(false);
      DrawBricks(bb.z,bb.y,bb.x,0,0,0,5,5,5);
      if _12=0 then DrawRoomPlanes(true);
      if not ballin and ballnear and not balloutscreen then DrawBallSprite;
    end;




{ PROCEDURY PRE IKONY A OVLADANIE }

  var icolblue,icolred,icolred2:byte;


  procedure DrawRoomIcons;
    const roomicondist=2600;
    var iconprojroomvertices:array[0..7] of tintvector;
        {suradice premietnutych vrcholov miestnosti pre ikony}
        col:byte;

    function VisiblePlane2(plane:tcubeplanes;vertindex:integer):boolean;
      {zisti ci je plocha plane aktualnej tehly privratena,
       transfpoints[vertindex] je jeden vrchol plochy}
       var vertex:tvector;
      begin
        {podla uhla s viewvectorom (transfpoints[vertindex]) sa urci,
         ci je plocha privratena}
        vertex:=transfpoints[vertindex];
        vertex.z:=vertex.z+roomicondist;
        if VDotProduct(planesnormals[plane],vertex)<0
          then VisiblePlane2:=true
          else VisiblePlane2:=false;
      end;

  procedure IconProjectPoint(var projectedp:tintvector; var originalp:tvector);
      {premietne bod originalp a ulozi ho do projectedp - pre ikony}
      begin
        projectedp.x:=Trunc(originalp.x/(originalp.z+roomicondist)*eyedist
                            *aspectratio);
        projectedp.y:=Trunc(originalp.y/(originalp.z+roomicondist)*eyedist);
      end;


    procedure IconProjectRoom;
      {premietne transformovane vrcholy miestnosti do iconprojroomvertices -
       - pre ikony}
      var i:integer;
      begin
        for i:=0 to 7 do
          IconProjectPoint(iconprojroomvertices[i],transfroomvertices[i]);
      end;


    procedure DrawRoomIcon(x,y:integer; plane:tcubeplanes;
                           planeswitch,visswitch:boolean);
      {nakresli ikonu miestnosti so stredom na x,y}

      procedure DrawGravPlane(v1,v2,v3,v4:integer; col:byte);
        {kresli plochu na ikone gravitacie}
        begin
        FourAngle13h(iconprojroomvertices[v1].x+x,iconprojroomvertices[v1].y+y,
                     iconprojroomvertices[v2].x+x,iconprojroomvertices[v2].y+y,
                     iconprojroomvertices[v3].x+x,iconprojroomvertices[v3].y+y,
                     iconprojroomvertices[v4].x+x,iconprojroomvertices[v4].y+y,
                     col);
        FourAngle13h(iconprojroomvertices[v4].x+x,iconprojroomvertices[v4].y+y,
                     iconprojroomvertices[v3].x+x,iconprojroomvertices[v3].y+y,
                     iconprojroomvertices[v2].x+x,iconprojroomvertices[v2].y+y,
                     iconprojroomvertices[v1].x+x,iconprojroomvertices[v1].y+y,
                     col);
        end;

      procedure DrawPlane(plane2:tcubeplanes; v,v1,v2,v3,v4:integer);
        {nakresli hrany steny miestnosti-ikony s vrcholmi v1,v2,v3,v4
         farbou col}
        var vis:boolean;
        begin
          vis:=VisiblePlane2(plane2,v);
          if vis<>visswitch then Exit;
          if vis then col:=roomcolor+3
          else col:=roomcolor;
          if planeswitch and (plane in gravity) then Inc(col,4);
          Line13h(iconprojroomvertices[v1].x+x,iconprojroomvertices[v1].y+y,
                  iconprojroomvertices[v2].x+x,iconprojroomvertices[v2].y+y,
                  col);
          Line13h(iconprojroomvertices[v2].x+x,iconprojroomvertices[v2].y+y,
                  iconprojroomvertices[v3].x+x,iconprojroomvertices[v3].y+y,
                  col);
          Line13h(iconprojroomvertices[v3].x+x,iconprojroomvertices[v3].y+y,
                  iconprojroomvertices[v4].x+x,iconprojroomvertices[v4].y+y,
                  col);
          Line13h(iconprojroomvertices[v4].x+x,iconprojroomvertices[v4].y+y,
                  iconprojroomvertices[v1].x+x,iconprojroomvertices[v1].y+y,
                  col);
          if planeswitch and (plane=plane2) then
            DrawGravPlane(v1,v2,v3,v4,col);
        end;

      begin
        DrawPlane(leftp,0,0,3,7,4);
        DrawPlane(rightp,7*49-1,1,5,6,2);
        DrawPlane(upp,0,0,1,2,3);
        DrawPlane(downp,7*49-1,7,6,5,4);
        DrawPlane(nearp,0,0,4,5,1);
        DrawPlane(farp,7*49-1,2,6,7,3);
      end;


    begin
      IconProjectRoom;

      DrawRoomIcon(16,180,leftp,false,false);
      DrawRoomIcon(16,180,leftp,false,true);

      DrawRoomIcon(16+32,180,leftp,false,false);
      DrawRoomIcon(16+32,180,leftp,false,true);

      DrawRoomIcon(16+64,180,leftp,false,false);
      DrawRoomIcon(16+64,180,leftp,false,true);

      DrawRoomIcon(144,180,leftp,true,false);
      DrawRoomIcon(144,180,leftp,true,true);

      DrawRoomIcon(144+32,180,rightp,true,false);
      DrawRoomIcon(144+32,180,rightp,true,true);

      DrawRoomIcon(144+64,180,upp,true,false);
      DrawRoomIcon(144+64,180,upp,true,true);

      DrawRoomIcon(144+96,180,downp,true,false);
      DrawRoomIcon(144+96,180,downp,true,true);

      DrawRoomIcon(144+128,180,nearp,true,false);
      DrawRoomIcon(144+128,180,nearp,true,true);

      DrawRoomIcon(144+160,180,farp,true,false);
      DrawRoomIcon(144+160,180,farp,true,true);

      DrawMiscSprite(23,140,eyespr);
      DrawMiscSprite(270,120,20);
      col:=0;
      if icolblue=1 then col:=16;
      if (icolred=1) or (icolred2=1) then col:=32;
      DrawMiscSprite2(9,170,0,col);
      col:=0;
      if icolblue=2 then col:=16;
      if (icolred=2) or (icolred2=2) then col:=32;
      DrawMiscSprite2(8,181,1,col);
      col:=0;
      if icolblue=3 then col:=16;
      if (icolred=3) or (icolred2=3) then col:=32;
      DrawMiscSprite2(38,172,2,col);
      col:=0;
      if icolblue=4 then col:=16;
      if (icolred=4) or (icolred2=4) then col:=32;
      DrawMiscSprite2(49,172,3,col);
      col:=0;
      if icolblue=5 then col:=16;
      if (icolred=5) or (icolred2=5) then col:=32;
      DrawMiscSprite2(69,170,4,col);
      col:=0;
      if icolblue=6 then col:=16;
      if (icolred=6) or (icolred2=6) then col:=32;
      DrawMiscSprite2(75,176,5,col);
    end;


  procedure InvertGravity(grv:tcubeplanes);
    {v mode 1 nastavi gravitaciu na grv, v mode 2 grv invertuje}
    begin
      if mode=1 then gravity:=[grv]
      else if grv in gravity then
             gravity:=gravity-[grv]
           else gravity:=gravity+[grv];
    end;


  procedure DrawUfo;
    {ak treba kresli ufo}
    begin
      if _ufo>0 then
        if (_ufo and 8)=0 then DrawMiscSprite3(Round(ufo1x),Round(ufo1y),24)
        else DrawMiscSprite3(Round(ufo1x),Round(ufo1y),25);
    end;


  {$I int1c.inc}



{ VSEOBECNE PROCEDURY }

  function LoadRoom(number:byte):boolean;
    {nacita zo suboru roomsfile miestnost number do bricks, brickscolors
    a holes a inicializuje loptu a gravitaciu, vrati true=ok/false=ko}
    var roomsfile:file;
        roomsfilepos,csize:longint;
        i,j,k:integer;
        comprbuf:pspritemaps;
        p1:pbyte;
    begin
      Assign(roomsfile,roomsfilename); Reset(roomsfile,1);
      BlockRead(roomsfile,allroomsnb,1); allroomsnb:=allroomsnb xor 145;
      i:=1;

      while not EoF(roomsfile) and (i<number) do
        begin
          BlockRead(roomsfile,csize,4); BlockRead(roomsfile,csize,4);
          roomsfilepos:=FilePos(roomsfile);
          Inc(roomsfilepos,csize+2);
          Seek(roomsfile,roomsfilepos);
          Inc(i);
        end;

      if not EoF(roomsfile) then
        begin
          GetMem0(pointer(comprbuf),704,p1);
          LoadBlock(roomsfile,comprbuf);

          Move(comprbuf^,roomname[1],40);
          roomname[0]:=#40;
          while roomname[Length(roomname)]=' ' do Dec(roomname[0]);
          Move(comprbuf^[40],roomnamecolor,1);
          Move(comprbuf^[41],ballbrick.x,2);
          Move(comprbuf^[43],ballbrick.y,2);
          Move(comprbuf^[45],ballbrick.z,2);
          Move(comprbuf^[47],ballradius,1);
          Move(comprbuf^[48],ro,4);
          Move(comprbuf^[52],g,4);
          Move(comprbuf^[56],bricks,216);
          Move(comprbuf^[272],brickscolors,216);
          Move(comprbuf^[488],holes,216);

          ball.x:=(ballbrick.x+0.5)*brickedge-roomedge/2;
          ball.y:=(ballbrick.y+0.5)*brickedge-roomedge/2;
          ball.z:=(ballbrick.z+0.5)*brickedge-roomedge/2;

          bricksnb:=0;
          for i:=0 to 5 do
            for j:=0 to 5 do
              for k:=0 to 5 do
                if bricks[i,j,k]>=$C0 then Inc(bricksnb);

          FreeMem0(pointer(comprbuf),704,p1);
          LoadRoom:=true;
        end
      else LoadRoom:=false;
      Close(roomsfile);
    end;



  procedure CreateBackground;
    const stars=400;
    var i,j,n:integer;
    begin
      GetMem0(background,65535,backgroundkey);
      FillChar(background^,64000,0);
      SetActivePage13h(Seg(background^));

      for i:=0 to 13 do
        begin
          n:=Round(stars/(i+1));
          for j:=1 to n do
            PutPixel13h(Random(320),Random(200),240+i);
        end;
      n:=Round(stars/15+stars/16);
      for i:=1 to n do
        PutPixel13h(Random(320),Random(200),Random(20)+8);

      if Random(2)=1 then
        DrawMiscSprite(Random(264),Random(162),22);
      if Random(2)=1 then
        DrawMiscSprite(Random(287),Random(177),21);
      if Random(2)=1 then
        DrawMiscSprite(Random(290),Random(185),23);

      SetActivePage13h(Seg(interiorscreen^));
    end;



  procedure DrawRoomNb;
    var s:string;
    begin
      Str(roomnb:2,s);
      WriteTextXY(10,15,s,248);
    end;



  procedure DrawTimeXY(x,y:integer; col:byte; t:longint);
    var s,s2:string;
        sec,min:integer;
    begin
      t:=t div 100;
      sec:=t mod 60; t:=t div 60;
      min:=t mod 60; t:=t div 60;
      Str(sec,s); if Length(s)=1 then s:='0'+s;
      Str(min,s2); if Length(s2)=1 then s2:='0'+s2;
      s:=s2+':'+s;
      Str(t,s2);
      s:=s2+':'+s;
      WriteTextXY(x-TextWidth(s),y,s,col);
    end;


  procedure DrawCenteredTime(y:integer; col:byte; t:longint);
    var s,s2:string;
        sec,min:integer;
    begin
      t:=t div 100;
      sec:=t mod 60; t:=t div 60;
      min:=t mod 60; t:=t div 60;
      Str(sec,s); if Length(s)=1 then s:='0'+s;
      Str(min,s2); if Length(s2)=1 then s2:='0'+s2;
      s:=s2+':'+s;
      Str(t,s2);
      s:=s2+':'+s;
      WriteCenteredText(y,s,col);
    end;



  procedure WriteSmallCharXY(x,y:integer; ch:char; col:byte);
    {vypise znak malym fontom na poziciu x,y}
    var i,j:integer;
        mask,bitmap:byte;
    begin
      for i:=0 to 10 do
        begin
          mask:=128;
          bitmap:=smallfont[Ord(ch),i];
          for j:=0 to 7 do
            begin
              if (bitmap and mask)<>0 then PutPixel13h(x+j,y+i,col);
              mask:=mask shr 1;
            end;
        end;
    end;


  procedure WriteSmallTextXY(x,y:integer; s:string; col:byte);
    {vypise text s na poziciu x,y}
    var i:integer;
    begin
      for i:=1 to Length(s) do
        begin
          WriteSmallCharXY(x,y,s[i],col);
          Inc(x,8);
        end;
    end;


  procedure WriteSmallCenteredText(y:integer; s:string; col:byte);
    {pise maly centrovany text s farbou col na y}
    begin
      WriteSmallTextXY((320-8*Length(s)) div 2,y,s,col);
    end;


  procedure WriteTitle;
    {vypise nazov miestnosti do horneho riadku}
    begin
      WriteSmallCenteredText(0,roomname,roomnamecolor*8+7);
    end;


  procedure WriteKeys;
    {pripise pod ikony ekvivalentne klavesy}
    var i:integer;
    begin
      WriteSmallCharXY(14,161,#26,248);
      WriteSmallCharXY(14,189,#27,248);
      WriteSmallCharXY(41,160,#24,248);
      WriteSmallCharXY(53,188,#25,248);
      WriteSmallTextXY(64,159,'Hm',248);
      WriteSmallTextXY(84,188,'PD',248);
      for i:=1 to 6 do WriteSmallCharXY(110+i*32,190,Chr(i+Ord('0')),248);
    end;



  procedure DrawScreen;
    begin
      Move(background^,interiorscreen^,64000);
      DrawUfo;
      DrawRoom;
      DrawRoomIcons;
      WriteKeys;
      WriteTitle;
      DrawRoomNb;
      DrawTimeXY(309,15,248,time);
      if paused then WriteCenteredText(80,'PAUSED',248)
      else if mpresent then DrawMouseCursor2(vramseg);
    end;



  function GetLongintTime:longint;
    {vrati aktulany cas premeneny na stotiny sekundy}
    var h,m,s,s100:word;
    begin
      GetTime(h,m,s,s100);
      GetLongintTime:=longint(h)*360000+longint(m)*6000+s*100+s100;
    end;



  procedure FreeMemory;
    begin
      FreeMem0(interiorscreen,65535,interscrkey);
      FreeMem0(background,65535,backgroundkey);
      FreeMem0(fontsprites,10834,fontsprkey);
      FreeMem0(bonussprites,1766,bonussprkey);
      FreeMem0(miscsprites,16442,miscsprkey);
      FreeMem0(ballsprites,13442,ballsprkey);
    end;



  procedure FreeMemory2;
    begin
      FreeMem0(fontsprites,10834,fontsprkey);
      FreeMem0(bonussprites,1766,bonussprkey);
      FreeMem0(miscsprites,16442,miscsprkey);
      FreeMem0(ballsprites,13442,ballsprkey);
    end;



  procedure InitTest;
    {otestuje pritomnost potrebnych suborov a velkost volnej pamate}
    var s:pathstr;
        ma:longint;
    begin
      WriteLn;
      s:=FSearch('sprites.csp','');
      if s='' then
        begin
          WriteLn('File ''sprites.csp'' not found in current directory');
          Halt;
        end;
      s:=FSearch('rooms.dat','');
      if s='' then
        begin
          WriteLn('File ''rooms.dat'' not found in current directory');
          Halt;
        end;

      ma:=MemAvail-(13442+16442+1766+10834+2*65535+2*65520+704);
      if ma<0 then
        begin
          WriteLn('Not enough memory, ',-ma div 1024+1,
                  'KB missing (380KB free required)');
          Halt;
        end;
    end;


{ PROCEDURY OKOLO MENU }

  var highlighted,highcol:byte;
      password,pswd:string[10];


  procedure InitIntro;
    {inicializuje skakajuce pismenka na zaciatku}
    var i:integer;
    begin
      effect[1].ch:='G'; effect[2].ch:='R'; effect[3].ch:='A';
      effect[4].ch:='V'; effect[5].ch:='I'; effect[6].ch:='T';
      effect[7].ch:='O'; effect[8].ch:='I'; effect[9].ch:='D';
      with effect[1] do
        begin x:=-220; y:=5; dy:=0; end;
      for i:=2 to 9 do
        with effect[i] do
          begin
            x:=effect[i-1].x+TextWidth(effect[i-1].ch)+5; y:=5; dy:=0;
          end;
      introdx:=3;
      outro:=false;
    end;


  procedure InitOutro;
    {inicializuje skakajuce pismenka na konci}
    var i:integer;
    begin
      effect[1].ch:='C'; effect[2].ch:='O'; effect[3].ch:='N';
      effect[4].ch:='G'; effect[5].ch:='R'; effect[6].ch:='A';
      effect[7].ch:='T'; effect[8].ch:='U'; effect[9].ch:='L';
      effect[10].ch:='A'; effect[11].ch:='T'; effect[12].ch:='I';
      effect[13].ch:='O'; effect[14].ch:='N'; effect[15].ch:=' ';
      effect[16].ch:='!'; effect[17].ch:='!'; effect[18].ch:='!';
      with effect[1] do
        begin
          x:=(320-TextWidth('CONGRATULATION !!!')) div 2; y:=-50; dy:=0;
        end;
      for i:=2 to 18 do
        with effect[i] do
          begin
            x:=effect[i-1].x+TextWidth(effect[i-1].ch); y:=-50; dy:=0;
          end;
      outro:=true;
    end;


  procedure DrawMenu;
    {nakresli menu}
    var col:byte;
        i:integer;
    begin
      Move(background^,interiorscreen^,64000);
      DrawUfo;
      if highlighted=0 then col:=highcol else col:=248;
      for i:=1 to 9 do
        with effect[i] do
          WriteCharXY23(x,y,ch,col);
      if highlighted=1 then col:=highcol else col:=248;
      WriteCenteredText(60,'PLAY GAME',col);
      if highlighted=2 then col:=highcol else col:=248;
      WriteCenteredText(85,'ENTER PASSWORD',col);
      if highlighted=3 then col:=highcol else col:=248;
      WriteCenteredText(110,'HIGH SCORES',col);
      if highlighted=4 then col:=highcol else col:=248;
      WriteCenteredText(135,'OPTIONS',col);
      if highlighted=5 then col:=highcol else col:=248;
      WriteCenteredText(160,'QUIT',col);
      if highlighted=6 then col:=highcol+7 else col:=251;
      WriteSmallCenteredText(188,'(c) Jaroslav Semank 1998',col);
      ShowScreen13h;
    end;



  {$I scoretab.inc}

  procedure HighScores;
    {tabulka}
    var i:integer;
    begin
      ReadScoreTable;
      repeat
        Move(background^,interiorscreen^,64000);
        DrawUfo;
        WriteCenteredText(20,'HIGH SCORES',248);
        for i:=1 to 5 do
          begin
            WriteTextXY(5,65+(i-1)*25,names[i],248-i+1);
            if times[i]<>maxlongint then
              DrawTimeXY(314,65+(i-1)*25,248-i+1,times[i]);
          end;
        ShowScreen13h;
      until KeyPressed or mpresent and (mstate<>[]);
      ReleaseAll;
    end;



  procedure PlayGame;
    {hra}
    var gravplaneswitch:tcubeplanes;
        s,name:string;
        key:char;
        i,j,nlen:integer;
        time0,time1:longint;

    procedure CreatePassword;
      {vytvori heslo z time a roomnb do password}
      var i:integer;
      begin
        pswd[0]:=#10;
        asm
          mov   ax,word ptr[time]
          mov   bx,word ptr[time+2]
          mov   dl,[roomnb]

          mov   dh,11
          xor   dh,ah
          xor   dh,al
          xor   dh,bh
          xor   dh,bl
          xor   dh,dl
          and   dh,31
          mov   [offset pswd+1],dh

          mov   dh,27
          add   dh,ah
          add   dh,al
          add   dh,bh
          add   dh,bl
          add   dh,dl
          and   dh,31
          mov   [offset pswd+2],dh

          mov   si,offset pswd+3;
          mov   cx,8

        @Loop:
          xor   dh,dh
          shl   al,1
          rcl   dh,1
          shl   ah,1
          rcl   dh,1
          shl   bl,1
          rcl   dh,1
          shl   bh,1
          rcl   dh,1
          shl   dx,1
          mov   [si],dh
          inc   si
          loop  @Loop
        end;

        for i:=1 to 10 do
          if pswd[i]<#24 then Inc(pswd[i],Ord('C'))
          else Inc(pswd[i],Ord('2')-24);

        password[0]:=#10;
        password[1]:=pswd[7]; password[2]:=pswd[10]; password[3]:=pswd[4];
        password[4]:=pswd[1]; password[5]:=pswd[8]; password[6]:=pswd[5];
        password[7]:=pswd[3]; password[8]:=pswd[9]; password[9]:=pswd[2];
        password[10]:=pswd[6];
      end;

    begin
      repeat
        if not LoadRoom(roomnb) then
          begin
            repeat
              Move(background^,interiorscreen^,64000);
              DrawUfo;
              Str(roomnb,s);
              WriteCenteredText(60,'ROOM '+s,248);
              WriteCenteredText(90,'DOES NOT EXIST',248);
              ShowScreen13h;
            until KeyPressed or mpresent and (mstate<>[]);
            ReleaseAll;
            Exit;
          end;

        paused:=false; playing:=true;
        ballin:=true; balloutscreen:=false;
        transfroomvertices:=roomvertices;
        roomcenter.z:=rcdist;
        minusroomcenter.z:=-rcdist;
        VLoad(v1x,1,0,0); VLoad(v1y,0,1,0); VLoad(v1z,0,0,1);

        CreateXRotationMatrix(rotmatrix,0.1);
        CreateTransformationMatrix(transfmatrix,rotmatrix);
        ProjectRoom;
        ProjectBall;
        CreateYRotationMatrix(rotmatrix,0.1);
        CreateTransformationMatrix(transfmatrix,rotmatrix);
        ProjectRoom;
        ProjectBall;
        CreateZRotationMatrix(rotmatrix,0.1);
        CreateTransformationMatrix(transfmatrix,rotmatrix);
        ProjectRoom;
        ProjectBall;
        xturn:=0; yturn:=0; zturn:=0;

        gravity:=[];
        VLoad(v,0,0,0);
        currenttime:=GetLongintTime;
        _eye:=0; eyespr:=6; eyeview:=0; _bricks:=0; dbrickswitch:=$CD;
        _4:=0; _5:=0; _6:=0; _7:=0; _8:=0; _9:=0; _10:=0; _12:=0; _14:=0;
        _15:=0; _16:=0; _18:=0; _19:=0; _20:=0; _21:=0; _23:=0; _28:=0;
        _24b:=false; _25b:=false; _26b:=false;
        if mpresent then
          begin
            SetGraphCursorType2(cgArrow2);
            SetVerticalRange(0,199);
            SetCursorPosition(160,100);
          end;

        repeat
          rotmatrix:=onematrix; key:=#0;
          icolred2:=0;
          while KeyPressed do
            begin
              key:=ReadKey;
              case key of
                '1': if _28=0 then gravplaneswitch:=leftp
                     else gravplaneswitch:=rightp;
                '2': if _28=0 then gravplaneswitch:=rightp
                     else gravplaneswitch:=leftp;
                '3': if _28=0 then gravplaneswitch:=upp
                     else gravplaneswitch:=downp;
                '4': if _28=0 then gravplaneswitch:=downp
                     else gravplaneswitch:=upp;
                '5': if _28=0 then gravplaneswitch:=nearp
                     else gravplaneswitch:=farp;
                '6': if _28=0 then gravplaneswitch:=farp
                     else gravplaneswitch:=nearp;

                'p','P':begin
                          paused:=true;
                          TestMouseState;
                          mcurbak:=mcur;
                          repeat
                            DrawScreen;
                            ShowScreen13h;
                          until KeyPressed or mpresent and (mstate<>[]);
                          paused:=false;
                          ReleaseAll;
                          SetCursorPosition(mcurbak.x,mcurbak.y);
                          currenttime:=GetLongintTime;
                        end;
              end;

              if key=#0 then
                begin
                  key:=ReadKey;
                  case key of
                    #80: if _28=0 then
                           begin xturn:=xturn+stepangle; icolred2:=4; end
                         else
                           begin xturn:=xturn-stepangle; icolred2:=3; end;

                    #72: if _28=0 then
                           begin xturn:=xturn-stepangle; icolred2:=3; end
                         else
                           begin xturn:=xturn+stepangle; icolred2:=4; end;

                    #77: if _28=0 then
                           begin yturn:=yturn+stepangle; icolred2:=1; end
                         else
                           begin yturn:=yturn-stepangle; icolred2:=2; end;

                    #75: if _28=0 then
                           begin yturn:=yturn-stepangle; icolred2:=2; end
                         else
                           begin yturn:=yturn+stepangle; icolred2:=1; end;

                    #81: if _28=0 then
                           begin zturn:=zturn+stepangle; icolred2:=6; end
                         else
                           begin zturn:=zturn-stepangle; icolred2:=5; end;

                    #71: if _28=0 then
                           begin zturn:=zturn-stepangle; icolred2:=5; end
                         else
                           begin zturn:=zturn+stepangle; icolred2:=6; end;

                    #82: yturn:=yturn+Pi;
                  end;
                  key:=#0;
                end;

            if key in ['1','2','3','4','5','6'] then
              InvertGravity(gravplaneswitch);
          end;

          if (Abs(xturn)>=Abs(yturn)) and (Abs(xturn)>=Abs(zturn)) then
            begin
              CreateXRotationMatrix(rotmatrix,xturn);
              xturn:=0;
            end
          else if (Abs(yturn)>=Abs(xturn)) and (Abs(yturn)>=Abs(zturn)) then
                 begin
                   CreateYRotationMatrix(rotmatrix,yturn);
                   yturn:=0;
                 end
          else if (Abs(zturn)>=Abs(xturn)) and (Abs(zturn)>=Abs(yturn)) then
                 begin
                   CreateZRotationMatrix(rotmatrix,zturn);
                   zturn:=0;
                 end;
          CreateTransformationMatrix(transfmatrix,rotmatrix);
          ProjectRoom;

          oldcurrenttime:=currenttime;
          currenttime:=GetLongintTime;
          deltatime:=currenttime-oldcurrenttime;
          if deltatime<0 then Inc(deltatime,24*3600*100);
          if _18=0 then Inc(time,deltatime);
          for i:=1 to deltatime do MoveBall;

          ProjectBall;
          DrawScreen;
          ShowScreen13h;
          if key=#27 then Exit;
        until bricksnb=0;

        if roomnb=maxroomnb then
          begin
            InitOutro;
            mel:='C4 F2 G4 A8 G4 F4 G2 E4 C4 '+
                +'C4 F2 G4 A8 G4 F4 G2 G2 '+
                +'C4 F2 G4 A8 G4 F4 G2 E4 C4 '+
                +'C4 F2 G4 A8 G4 E4 D1';
            mel_:=1;
            music:=true;
            time0:=GetLongintTime;
            repeat
              Move(background^,interiorscreen^,64000);
              DrawUfo;
              for i:=1 to 18 do
                with effect[i] do
                  WriteCharXY23(x,y,ch,40);
              WriteCenteredText(90,'YOU HAVE FINISHED',248);
              WriteCenteredText(115,'THE GAME',248);
              WriteCenteredText(140,'GRAVITOID',128);
              ShowScreen13h;
              time1:=GetLongintTime; if time1<time0 then Inc(time1,24*3600);
            until time1-time0>50;
            ReleaseAll;

            repeat
              Move(background^,interiorscreen^,64000);
              DrawUfo;
              for i:=1 to 18 do
                with effect[i] do
                  WriteCharXY23(x,y,ch,40);
              WriteCenteredText(90,'YOU HAVE FINISHED',248);
              WriteCenteredText(115,'THE GAME',248);
              WriteCenteredText(140,'GRAVITOID',128);
              ShowScreen13h;
            until KeyPressed or mpresent and (mstate<>[]);
            ReleaseAll;

            music:=false; NoSound;
            ReadScoreTable;
            i:=1;
            while (i<=5) and (times[i]<time) do Inc(i);
            if i<=5 then
              begin
                name:='        '; nlen:=0;
                repeat
                  Move(background^,interiorscreen^,64000);
                  DrawUfo;
                  WriteCenteredText(40,'ENTER YOUR NAME:',248);
                  WriteCenteredText(130,name,248);
                  ShowScreen13h;
                  key:=#0;
                  if KeyPressed then key:=ReadKey;
                  if (nlen<8) and (key in ['0'..'9','A'..'Z','a'..'z',' ']) then
                    begin Inc(nlen); name[nlen]:=UpCase(key); end;
                  if key in [#0,#8] then
                    begin
                      if (key=#0) and KeyPressed then key:=ReadKey;
                      if (nlen>0) and (key in [#8,#83,#75]) then
                        begin name[nlen]:=' '; Dec(nlen); end;
                    end;
                until ((key=#13) or (key=#27) or mpresent and (mstate<>[])) and
                      (name<>'        ');
                ReleaseAll;

                for j:=4 downto i do
                  begin names[i+1]:=names[i]; times[i+1]:=times[i]; end;
                names[i]:=name; times[i]:=time;
                WriteScoreTable;
              end
            else
              begin
                repeat
                  Move(background^,interiorscreen^,64000);
                  DrawUfo;
                  WriteCenteredText(40,'YOUR TIME:',248);
                  DrawCenteredTime(80,128,time);
                  ShowScreen13h;
                until KeyPressed or mpresent and (mstate<>[]);
                ReleaseAll;
              end;

            HighScores;
          end;

        Inc(roomnb);
        CreatePassword;

        Str(roomnb,s);
        s:='FOR ROOM '+s+':';

        time0:=GetLongintTime;
        repeat
          Move(background^,interiorscreen^,64000);
          DrawUfo;
          WriteCenteredText(40,'PASSWORD',248);
          WriteCenteredText(70,s,248);
          WriteCenteredText(120,password,176);
          ShowScreen13h;
          time1:=GetLongintTime; if time1<time0 then Inc(time1,24*3600);
        until time1-time0>50;
        ReleaseAll;

        repeat
          Move(background^,interiorscreen^,64000);
          DrawUfo;
          WriteCenteredText(40,'PASSWORD',248);
          WriteCenteredText(70,s,248);
          WriteCenteredText(120,password,176);
          ShowScreen13h;
        until KeyPressed or mpresent and (mstate<>[]);

        if roomnb>allroomsnb then
          begin
            ReleaseAll;
            repeat
              Move(background^,interiorscreen^,64000);
              DrawUfo;
              WriteCenteredText(50,'SORRY',248);
              WriteCenteredText(80,'NO MORE ROOMS!',248);
              WriteCenteredText(110,'DESIGN YOUR OWN',248);
              ShowScreen13h;
            until KeyPressed or mpresent and (mstate<>[]);
            ReleaseAll;
            roomnb:=1;
            Exit;
          end;

        while KeyPressed do if ReadKey=#27 then Exit;
        if mpresent then while mstate<>[] do;
      until false;
    end;


  var timebak:longint;
      roomnbbak:byte;

  procedure EnterPassword;
    {vlozenie hesla}
    var s,s2:string;
        key:char;
        plen,sec,min:integer;
        pok:boolean;
        t:longint;

    function CheckPassword:boolean;
      {zisti, ci je heslo password spravne}
      var i:integer;
      begin
        pswd[0]:=#10;
        pswd[1]:=password[4]; pswd[2]:=password[9]; pswd[3]:=password[7];
        pswd[4]:=password[3]; pswd[5]:=password[6]; pswd[6]:=password[10];
        pswd[7]:=password[1]; pswd[8]:=password[5]; pswd[9]:=password[8];
        pswd[10]:=password[2];

        for i:=1 to 10 do
          if pswd[i]>='C' then Dec(pswd[i],Ord('C'))
          else Dec(pswd[i],Ord('2')-24);

        asm
          xor   ax,ax
          xor   bx,bx
          xor   dl,dl
          mov   si,offset pswd+10
          mov   cx,8

        @Loop2:
          mov   dh,[si]
          shr   dx,1
          shr   dh,1
          rcr   bh,1
          shr   dh,1
          rcr   bl,1
          shr   dh,1
          rcr   ah,1
          shr   dh,1
          rcr   al,1
          dec   si
          loop  @Loop2

          mov   dh,11
          xor   dh,ah
          xor   dh,al
          xor   dh,bh
          xor   dh,bl
          xor   dh,dl
          and   dh,31
          cmp   dh,[offset pswd+1]
          jz    @Test2
          mov   @Result,0
          jmp   @PasswordDecodeExit

        @Test2:
          mov   dh,27
          add   dh,ah
          add   dh,al
          add   dh,bh
          add   dh,bl
          add   dh,dl
          and   dh,31
          cmp   dh,[offset pswd+2]
          jz    @PasswordDecode
          mov   @Result,0
          jmp   @PasswordDecodeExit

        @PasswordDecode:
          mov   word ptr[timebak],ax
          mov   word ptr[timebak+2],bx
          mov   [roomnbbak],dl
          mov   @Result,1
        @PasswordDecodeExit:
        end;
      end;

    begin
      repeat
        password:='..........'; plen:=0;
        repeat
          Move(background^,interiorscreen^,64000);
          DrawUfo;
          WriteCenteredText(40,'ENTER PASSWORD:',248);
          WriteCenteredText(80,password,248);
          ShowScreen13h;
          key:=#0;
          if KeyPressed then key:=ReadKey;
          if (plen<10) and (key in ['0'..'9','A'..'Z','a'..'z']) then
            begin Inc(plen); password[plen]:=UpCase(key); end;
          if key in [#0,#8] then
            begin
              if (key=#0) and KeyPressed then key:=ReadKey;
              if (plen>0) and (key in [#8,#83,#75]) then
                begin password[plen]:='.'; Dec(plen); end;
            end;
          if key=#27 then Exit;
        until key=#13;

        pok:=CheckPassword;

        if pok then
          begin
            time:=timebak;
            roomnb:=roomnbbak;
            Str(roomnb,s);
            WriteCenteredText(130,'ROOM: '+s,248);
            t:=time div 100;
            sec:=t mod 60; t:=t div 60;
            min:=t mod 60; t:=t div 60;
            Str(sec,s); if Length(s)=1 then s:='0'+s;
            Str(min,s2); if Length(s2)=1 then s2:='0'+s2;
            s:=s2+':'+s;
            Str(t,s2);
            s:=s2+':'+s;
            WriteCenteredText(160,'TIME: '+s,248);
          end
        else
          WriteCenteredText(140,'INCORRECT PASSWORD',248);
        ShowScreen13h;
        repeat until KeyPressed or mpresent and (mstate<>[]);
        while KeyPressed do if ReadKey=#27 then Exit;
        if mpresent then while mstate<>[] do;
        until pok;
    end;



  procedure Options;
    var key:char;
        highlighted:byte;
        col:byte;
    begin
      highlighted:=0;
      if mpresent then
        begin
          SetVerticalRange(80,139);
          SetCursorPosition(160,95+30*highlighted);
        end;

      repeat
        Move(background^,interiorscreen^,64000);
        DrawUfo;
        WriteCenteredText(40,'OPTIONS',248);
        if highlighted=0 then col:=highcol else col:=248;
        WriteTextXY(50,90,'MODE:  ',col);
        if mode=1 then WriteTextXY(160,90,'NORMAL',col)
        else WriteTextXY(160,90,'EXTENDED',col);
        if highlighted=1 then col:=highcol else col:=248;
        WriteTextXY(31,120,'SOUND:  ',col);
        if soundswitch then WriteTextXY(160,120,'ON',col)
        else WriteTextXY(160,120,'OFF',col);
        ShowScreen13h;

        if mpresent then highlighted:=(mcur.y-80) div 30;
        key:=#0;
        if KeyPressed then
          begin
            key:=ReadKey;
            if (key='M') or (key='m') then
              begin
                highlighted:=0; key:=#13;
                SetCursorPosition(160,highlighted*30+80);
              end;
            if (key='S') or (key='s') then
              begin
                highlighted:=1; key:=#13;
                SetCursorPosition(160,highlighted*30+80);
              end;
            if key=#0 then
              begin
                key:=ReadKey;
                if key=#72 then
                  begin
                    highlighted:=(highlighted+2-1) mod 2;
                    SetCursorPosition(160,highlighted*30+80);
                  end;
                if key=#80 then
                  begin
                    highlighted:=(highlighted+1) mod 2;
                    SetCursorPosition(160,highlighted*30+80);
                  end;
                key:=#0;
              end;
          end;
        if (key in [#13,#32]) or mpresent and (mstate<>[]) then
          if highlighted=0 then
            if mode=1 then mode:=2
            else mode:=1
          else soundswitch:=not soundswitch;
        if mpresent then while mstate<>[] do;
      until key=#27;
    end;



  procedure ChangeHighColor;
    {zmeni zvyraznovaciu farbu v menu na nahodnu}
    begin
      highcol:=(Random(27)+4)*8;
    end;


  procedure Menu;
    {obsluhuje menu a spusta potrebne podprogramy}
    var key:char;
    begin
      highlighted:=1;
      mel:='C2 D4 E4. C4. D4. D4. H,4. G,4. C4. C4 D8. E4. D8 C4 E4 D2 R4 '+
          +'C2 D4 E4. C4. D4. D4. H,4. G,4. E2 D4 C2 D4 C4 D4 E4 C2 R4 '+
          +'C4 F2 C4 D4 E4 F4. F4. C4 D4. D4. C4 D4 E4 F4 G4 R4 '+
          +'C4 F2 C4 D4 E4 F4. F4. C4 C4 D2 E4 D4 C4 H,4 C4 D4 C2 R1';
      mel_:=1;
      InitIntro;
      repeat
        music:=true;
        if mpresent then
          begin
            SetVerticalRange(35,200);
            SetCursorPosition(160,48+25*highlighted);
          end;

        repeat
          playing:=false;
          DrawMenu;
          if mpresent then highlighted:=(mcur.y-35) div 25;
          key:=#0;
          if KeyPressed then
            begin
              key:=ReadKey;
              if (key='P') or (key='p') then
                begin highlighted:=1; key:=#13; end;
              if (key='E') or (key='e') then
                begin highlighted:=2; key:=#13; end;
              if (key='H') or (key='h') then
                begin highlighted:=3; key:=#13; end;
              if (key='O') or (key='o') then
                begin highlighted:=4; key:=#13; end;
              if (key='Q') or (key='q') then
                begin highlighted:=5; key:=#13; end;
              if key=#0 then
                begin
                  key:=ReadKey;
                  if key=#72 then
                    begin
                      highlighted:=(highlighted+7-1) mod 7;
                      SetCursorPosition(160,highlighted*25+35);
                    end;
                  if key=#80 then
                    begin
                      highlighted:=(highlighted+1) mod 7;
                      SetCursorPosition(160,highlighted*25+35);
                    end;
                  if (key=#77) and (highlighted=0) then
                    if introdx<10 then Inc(introdx);
                  if (key=#75) and (highlighted=0) then
                    if introdx>-10 then Dec(introdx);
                  key:=#0;
                end;
            end;

        until (key in [#13,#32,#27]) or mpresent and (mstate<>[]);

        if mpresent then repeat until mstate=[];
        if key=#27 then
          begin music:=false; NoSound; Exit; end;
        case highlighted of
          1: begin music:=false; NoSound; PlayGame; end;
          2: begin music:=false; NoSound; EnterPassword; end;
          3: begin music:=false; NoSound; HighScores; end;
          4: begin music:=false; NoSound; Options; end;
          6: ChangeHighColor;
        end;
      until highlighted=5;
      music:=false; NoSound;
    end;


{}
{ HLAVNY PROGRAM }
{}

  begin
    InitTest;
    LoadSprites;
    if not InitGraph13h then
      begin
        FreeMemory2;
        WriteLn('Sorry, VGA videocard not found (& required)');
        Exit;
      end;
    SetRGBPalette13h(palette);
    GetMem0(interiorscreen,65535,interscrkey);
    SetActivePage13h(Seg(interiorscreen^));
    HookIntr1Ch;
    InitMouse;

    Randomize;
    CreateBackground;
    _ufo:=0;

    time:=0;
    roomnb:=1;
    mode:=1;
    highcol:=48;
    soundswitch:=true; _music:=0;
    Menu;

    ReleaseIntr1Ch;
    CloseGraph13h;
    FreeMemory;
end.
