
  {$G+}

unit Krysa;

  interface

    type tmtype=(butt2,butt3);           {typ mysi 2/3 tlacitkova}
         button=(left,right,middle);
         tmstate=set of button;          {stav mysi = co je stlacene}
         tintvector2d=record
                       x,y:integer;
                     end;

         ttcurmask=record                {maska pre textovy kurzor}
                     ch:char; attr:byte;
                   end;
         ttcurtype=record
                     case ttype:(soft,hard) of
                       soft:(tscreenmask,tcurmask:ttcurmask);
                       hard:(upline,downline:word);
                   end;

         tgcurmask=array[1..32] of word;   {maska pre graficky kurzor}
         tgcurtype=record                  {klasicky graficky kurzor}
                     gactivepoint:tintvector2d;
                     gcurmask:tgcurmask;
                   end;
         tgcurtype2=record                 {256 farebny graficky kurzor}
                      gactivepoint:tintvector2d;   {kresli sa ako sprite}
                      gcurbitmap:array[0..255] of byte;
                    end;

    var mpresent:boolean;         {mys nainstalovana}
        mtype:tmtype;             {typ mysi}
        mstate:tmstate;           {stav mysi}
        mcur:tintvector2d;        {suradnice kurzora}
        gcurtype2:tgcurtype2;     {graficky kurzor}

    const                         {preddefinovane kurzory}
      ctHardBlock:ttcurtype=                 {textovy hardwareovy, }
        (ttype:hard; upline:0; downline:7);

      ctHardUnder:ttcurtype=                 {textovy hardvareovy, _}
        (ttype:hard; upline:6; downline:7);

      ctSoftStandard:ttcurtype=              {textovy, softwareovy, inverzny}
        (ttype:soft;
         tscreenmask:(ch:#255; attr:255);
         tcurmask:(ch:#0; attr:127));

      cgArrow:tgcurtype=                {graficky, klasicka sipka}
        (gactivepoint:(x:1; y:1);
         gcurmask:($1FFF,$0FFF,$07FF,$03FF,$01FF,$00FF,$007F,$003F,
                   $003F,$003F,$00FF,$00FF,$F07F,$F07F,$F87F,$F87F,
                   $0000,$4000,$6000,$7000,$7800,$7C00,$7E00,$7F00,
                   $7F80,$6C00,$4C00,$0600,$0600,$0300,$0300,$0000));

      cgLeftArrow:tgcurtype=            {graficky, sipka vlavo}
        (gactivepoint:(x:1; y:7);
         gcurmask:($FFFF,$F8FF,$F0FF,$E0FF,$C0FF,$8000,$0000,$0000,
                   $0000,$0000,$8000,$C0FF,$E0FF,$F0FF,$F8FF,$FFFF,
                   $0000,$0000,$0200,$0600,$0E00,$1E00,$3FFE,$7FFE,
                   $7FFE,$3FFE,$1E00,$0E00,$0600,$0200,$0000,$0000));

      cgRightArrow:tgcurtype=           {graficky, sipka vpravo}
        (gactivepoint:(x:14; y:7);
         gcurmask:($FFFF,$FF1F,$FF0F,$FF07,$FF03,$0001,$0000,$0000,
                   $0000,$0000,$0001,$FF03,$FF07,$FF0F,$FF1F,$FFFF,
                   $0000,$0000,$0040,$0060,$0070,$0078,$7FFC,$7FFE,
                   $7FFE,$7FFC,$0078,$0070,$0060,$0040,$0000,$0000));

      cgUpArrow:tgcurtype=              {graficky, sipka hore}
        (gactivepoint:(x:7; y:1);
         gcurmask:($FC3F,$F81F,$F00F,$E007,$C003,$8001,$8001,$8001,
                   $F81F,$F81F,$F81F,$F81F,$F81F,$F81F,$F81F,$F81F,
                   $0000,$0180,$03C0,$07E0,$0FF0,$1FF8,$3FFC,$03C0,
                   $03C0,$03C0,$03C0,$03C0,$03C0,$03C0,$03C0,$0000));

      cgDownArrow:tgcurtype=            {graficky, sipka dole}
        (gactivepoint:(x:7; y:14);
         gcurmask:($F81F,$F81F,$F81F,$F81F,$F81F,$F81F,$F81F,$F81F,
                   $8001,$8001,$8001,$C003,$E007,$F00F,$F81F,$FC3F,
                   $0000,$03C0,$03C0,$03C0,$03C0,$03C0,$03C0,$03C0,
                   $03C0,$3FFC,$1FF8,$0FF0,$07E0,$03C0,$0180,$0000));

      cgArrow2:tgcurtype2=       {graficky, 256 farebny, klasicka sipka}
        (gactivepoint:(x:1; y:1);
         gcurbitmap:(
           $00,$00,$00,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,
           $00,$10,$00,$00,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,
           $00,$10,$10,$00,$00,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,
           $00,$11,$11,$11,$00,$00,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,
           $00,$11,$11,$11,$11,$00,$00,$01,$01,$01,$01,$01,$01,$01,$01,$01,
           $00,$12,$12,$12,$12,$12,$00,$00,$01,$01,$01,$01,$01,$01,$01,$01,
           $00,$12,$12,$12,$12,$12,$12,$00,$00,$01,$01,$01,$01,$01,$01,$01,
           $00,$13,$13,$13,$13,$13,$13,$13,$00,$00,$01,$01,$01,$01,$01,$01,
           $00,$13,$13,$13,$13,$13,$13,$13,$13,$00,$01,$01,$01,$01,$01,$01,
           $00,$14,$14,$00,$14,$14,$00,$00,$00,$00,$01,$01,$01,$01,$01,$01,
           $00,$14,$00,$00,$14,$14,$00,$00,$01,$01,$01,$01,$01,$01,$01,$01,
           $00,$00,$00,$00,$00,$15,$15,$00,$01,$01,$01,$01,$01,$01,$01,$01,
           $01,$01,$01,$01,$00,$15,$15,$00,$00,$01,$01,$01,$01,$01,$01,$01,
           $01,$01,$01,$01,$00,$00,$16,$16,$00,$01,$01,$01,$01,$01,$01,$01,
           $01,$01,$01,$01,$01,$00,$16,$16,$00,$01,$01,$01,$01,$01,$01,$01,
           $01,$01,$01,$01,$01,$00,$00,$00,$00,$01,$01,$01,$01,$01,$01,$01));

      cgLeftArrow2:tgcurtype2=     {graficky, 256 farebny, sipka vlavo}
        (gactivepoint:(x:1; y:7);
         gcurbitmap:(
           $01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,
           $01,$01,$01,$01,$01,$00,$00,$00,$01,$01,$01,$01,$01,$01,$01,$01,
           $01,$01,$01,$01,$00,$00,$12,$00,$01,$01,$01,$01,$01,$01,$01,$01,
           $01,$01,$01,$00,$00,$12,$12,$00,$01,$01,$01,$01,$01,$01,$01,$01,
           $01,$01,$00,$00,$11,$12,$12,$00,$01,$01,$01,$01,$01,$01,$01,$01,
           $01,$00,$00,$11,$11,$12,$12,$00,$00,$00,$00,$00,$00,$00,$00,$00,
           $00,$00,$10,$11,$11,$12,$12,$13,$13,$14,$14,$15,$15,$16,$16,$00,
           $00,$10,$10,$11,$11,$12,$12,$13,$13,$14,$14,$15,$15,$16,$16,$00,
           $00,$10,$10,$11,$11,$12,$12,$13,$13,$14,$14,$15,$15,$16,$16,$00,
           $00,$00,$10,$11,$11,$12,$12,$13,$13,$14,$14,$15,$15,$16,$16,$00,
           $01,$00,$00,$11,$11,$12,$12,$00,$00,$00,$00,$00,$00,$00,$00,$00,
           $01,$01,$00,$00,$11,$12,$12,$00,$01,$01,$01,$01,$01,$01,$01,$01,
           $01,$01,$01,$00,$00,$12,$12,$00,$01,$01,$01,$01,$01,$01,$01,$01,
           $01,$01,$01,$01,$00,$00,$12,$00,$01,$01,$01,$01,$01,$01,$01,$01,
           $01,$01,$01,$01,$01,$00,$00,$00,$01,$01,$01,$01,$01,$01,$01,$01,
           $01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01));

      cgRightArrow2:tgcurtype2=      {graficky, 256 farebny, sipka vpravo}
        (gactivepoint:(x:14; y:7);
         gcurbitmap:(
           $01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,
           $01,$01,$01,$01,$01,$01,$01,$01,$00,$00,$00,$01,$01,$01,$01,$01,
           $01,$01,$01,$01,$01,$01,$01,$01,$00,$12,$00,$00,$01,$01,$01,$01,
           $01,$01,$01,$01,$01,$01,$01,$01,$00,$12,$12,$00,$00,$01,$01,$01,
           $01,$01,$01,$01,$01,$01,$01,$01,$00,$12,$12,$11,$00,$00,$01,$01,
           $00,$00,$00,$00,$00,$00,$00,$00,$00,$12,$12,$11,$11,$00,$00,$01,
           $00,$16,$16,$15,$15,$14,$14,$13,$13,$12,$12,$11,$11,$10,$00,$00,
           $00,$16,$16,$15,$15,$14,$14,$13,$13,$12,$12,$11,$11,$10,$10,$00,
           $00,$16,$16,$15,$15,$14,$14,$13,$13,$12,$12,$11,$11,$10,$10,$00,
           $00,$16,$16,$15,$15,$14,$14,$13,$13,$12,$12,$11,$11,$10,$00,$00,
           $00,$00,$00,$00,$00,$00,$00,$00,$00,$12,$12,$11,$11,$00,$00,$01,
           $01,$01,$01,$01,$01,$01,$01,$01,$00,$12,$12,$11,$00,$00,$01,$01,
           $01,$01,$01,$01,$01,$01,$01,$01,$00,$12,$12,$00,$00,$01,$01,$01,
           $01,$01,$01,$01,$01,$01,$01,$01,$00,$12,$00,$00,$01,$01,$01,$01,
           $01,$01,$01,$01,$01,$01,$01,$01,$00,$00,$00,$01,$01,$01,$01,$01,
           $01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01));

      cgUpArrow2:tgcurtype2=         {graficky, 256 farebny, sipka hore}
        (gactivepoint:(x:7; y:1);
         gcurbitmap:(
           $01,$01,$01,$01,$01,$01,$00,$00,$00,$00,$01,$01,$01,$01,$01,$01,
           $01,$01,$01,$01,$01,$00,$00,$10,$10,$00,$00,$01,$01,$01,$01,$01,
           $01,$01,$01,$01,$00,$00,$10,$10,$10,$10,$00,$00,$01,$01,$01,$01,
           $01,$01,$01,$00,$00,$11,$11,$11,$11,$11,$11,$00,$00,$01,$01,$01,
           $01,$01,$00,$00,$11,$11,$11,$11,$11,$11,$11,$11,$00,$00,$01,$01,
           $01,$00,$00,$12,$12,$12,$12,$12,$12,$12,$12,$12,$12,$00,$00,$01,
           $01,$00,$12,$12,$12,$12,$12,$12,$12,$12,$12,$12,$12,$12,$00,$01,
           $01,$00,$00,$00,$00,$00,$13,$13,$13,$13,$00,$00,$00,$00,$00,$01,
           $01,$01,$01,$01,$01,$00,$13,$13,$13,$13,$00,$01,$01,$01,$01,$01,
           $01,$01,$01,$01,$01,$00,$14,$14,$14,$14,$00,$01,$01,$01,$01,$01,
           $01,$01,$01,$01,$01,$00,$14,$14,$14,$14,$00,$01,$01,$01,$01,$01,
           $01,$01,$01,$01,$01,$00,$15,$15,$15,$15,$00,$01,$01,$01,$01,$01,
           $01,$01,$01,$01,$01,$00,$15,$15,$15,$15,$00,$01,$01,$01,$01,$01,
           $01,$01,$01,$01,$01,$00,$16,$16,$16,$16,$00,$01,$01,$01,$01,$01,
           $01,$01,$01,$01,$01,$00,$16,$16,$16,$16,$00,$01,$01,$01,$01,$01,
           $01,$01,$01,$01,$01,$00,$00,$00,$00,$00,$00,$01,$01,$01,$01,$01));

      cgDownArrow2:tgcurtype2=         {graficky, 256 farebny, sipka dole}
        (gactivepoint:(x:7; y:14);
         gcurbitmap:(
           $01,$01,$01,$01,$01,$00,$00,$00,$00,$00,$00,$01,$01,$01,$01,$01,
           $01,$01,$01,$01,$01,$00,$16,$16,$16,$16,$00,$01,$01,$01,$01,$01,
           $01,$01,$01,$01,$01,$00,$16,$16,$16,$16,$00,$01,$01,$01,$01,$01,
           $01,$01,$01,$01,$01,$00,$15,$15,$15,$15,$00,$01,$01,$01,$01,$01,
           $01,$01,$01,$01,$01,$00,$15,$15,$15,$15,$00,$01,$01,$01,$01,$01,
           $01,$01,$01,$01,$01,$00,$14,$14,$14,$14,$00,$01,$01,$01,$01,$01,
           $01,$01,$01,$01,$01,$00,$14,$14,$14,$14,$00,$01,$01,$01,$01,$01,
           $01,$01,$01,$01,$01,$00,$13,$13,$13,$13,$00,$01,$01,$01,$01,$01,
           $01,$00,$00,$00,$00,$00,$13,$13,$13,$13,$00,$00,$00,$00,$00,$01,
           $01,$00,$12,$12,$12,$12,$12,$12,$12,$12,$12,$12,$12,$12,$00,$01,
           $01,$00,$00,$12,$12,$12,$12,$12,$12,$12,$12,$12,$12,$00,$00,$01,
           $01,$01,$00,$00,$11,$11,$11,$11,$11,$11,$11,$11,$00,$00,$01,$01,
           $01,$01,$01,$00,$00,$11,$11,$11,$11,$11,$11,$00,$00,$01,$01,$01,
           $01,$01,$01,$01,$00,$00,$10,$10,$10,$10,$00,$00,$01,$01,$01,$01,
           $01,$01,$01,$01,$01,$00,$00,$10,$10,$00,$00,$01,$01,$01,$01,$01,
           $01,$01,$01,$01,$01,$01,$00,$00,$00,$00,$01,$01,$01,$01,$01,$01));


    procedure InitMouse;
    procedure ShowMouseCursor;
    procedure HideMouseCursor;
    procedure TestMouseState;
    procedure SetCursorPosition(x,y:integer);
    procedure TestPressedButton(b:button; var state:tmstate;
                                var count:integer; var cur:tintvector2d);
    procedure TestReleasedButton(b:button; var state:tmstate;
                                 var count:integer; var cur:tintvector2d);
    procedure SetHorizontalRange(xmin,xmax:integer);
    procedure SetVerticalRange(ymin,ymax:integer);
    procedure SetGraphCursorType(gcurtype:tgcurtype);
    procedure SetTextCursorType(tcurtype:ttcurtype);
    procedure GetRelativeMove(var deltax,deltay:integer);
{!!}procedure DefUserHandler(eventmask:word; phandler:pointer);  {!!}
    procedure EnableLightPen;
    procedure DisableLightPen;
    procedure SetSensitivity(x,y:integer);
    function GetMouseBufSize:word;
    procedure SaveMouseState(pbuf:pointer);
    procedure RestoreMouseState(pbuf:pointer);

    procedure SetGraphCursorType2(gctype2:tgcurtype2);
    procedure DrawMouseCursor2(vramseg:word);


  implementation

    procedure InitMouse; assembler;
      {zistuje pritomnos a stav mysi}
      asm
        xor   ax,ax
        int   33h                  {sluzba 0 pre mys - test mysi}
        mov   byte ptr[mpresent],0
        and   ax,ax                {ak ax=0 - mys je nenainstalovana}
        jz    @InitMouseExit       {mpresent=false}

        inc   byte ptr[mpresent]   {mpresent:=true}
        mov   byte ptr[mtype],0
        cmp   bx,2                 {ak bx=2 - mys je 2-tlacitkova}
        jz    @InitMouseExit       {mtype=butt2}
        inc   byte ptr[mtype]      {inak 3-tlacitkova (bx by malo byt 3)}
                                   {mtype=butt3}
      @InitMouseExit:
      end;


    procedure ShowMouseCursor; assembler;
      {zobrazi kurzor mysi}
      asm
        mov   ax,1
        int   33h                 {sluzba 1 - zobrazenie kurzora}
      end;


    procedure HideMouseCursor; assembler;
      {zrusi kurzor mysi}
      asm
        mov   ax,2
        int   33h                 {sluzba 2 - zrusenie kurzora}
      end;


    procedure TestMouseState; assembler;
      {zisti poziciu kurzora a stav mysitok}
      asm
        mov   ax,3
        int   33h                 {sluzba 3 - citanie pozicie kurzora, mstk.}
        mov   [mstate],bl         {mysitka: 0.b-left, 1.b-right, 2.b-middle}
        sar   cx,1                {uprav x pre 320x200}
        mov   [mcur.x],cx
        mov   [mcur.y],dx         {suradnice kurzora}
      end;


    procedure SetCursorPosition(x,y:integer); assembler;
      {nastavi novu poziciu kurzora}
      asm
        mov   cx,[ss:x]
        shl   cx,1                {uprav x pre 320x200}
        mov   dx,[ss:y]           {x,y - nove suradnice}
        mov   ax,4
        int   33h                 {sluzba 4 - nastvenie pozicie kurzora}
      end;


    procedure TestPressedButton(b:button; var state:tmstate;
                                var count:integer; var cur:tintvector2d);
              assembler;
      {zisti stlacene mysitka, pocet stlaceni count mysitka b od posledneho
       volania a suradnice kurzora cur pri poslednom stlaceni b}
      asm
        xor   bx,bx
        mov   bl,[ss:b]          {bx=0 - lave, bx=1 - prave, bx=2 - stredne}
        mov   ax,5
        int   33h                {sluzba 5 - stlacenie mysitka}
        mov   si,word ptr[ss:state]
        mov   [si],ax            {stlacene mysitka uloz do state}
        mov   si,word ptr[ss:count]
        mov   [si],bx            {pocet stlaceni, od posledneho volania}
        mov   si,word ptr[ss:cur]
        sar   cx,1               {uprav pre 320x200}
        mov   [si],cx
        mov   [si+2],dx          {suradnice kurzora pri poslednom stlaceni}
      end;


    procedure TestReleasedButton(b:button; var state:tmstate;
                                 var count:integer; var cur:tintvector2d);
              assembler;
      {zisti uvolnene mysitka, pocet uvolneni count mysitka b od posledneho
       volania a suradnice kurzora cur pri poslednom uvolneni b}
      asm
        xor   bx,bx
        mov   bl,[ss:b]          {bx=0 - lave, bx=1 - prave, bx=2 - stredne}
        mov   ax,6
        int   33h                {sluzba 5 - stlacenie mysitka}
        mov   si,word ptr[ss:state]
        mov   [si],ax            {stlacene mysitka uloz do state}
        mov   si,word ptr[ss:count]
        mov   [si],bx            {pocet uvolneni, od posledneho volania}
        mov   si,word ptr[ss:cur]
        sar   cx,1               {uprav pre 320x200}
        mov   [si],cx
        mov   [si+2],dx          {suradnice kurzora pri poslednom uvolneni}
      end;


    procedure SetHorizontalRange(xmin,xmax:integer); assembler;
      {nastavi horizontalny rozsah povoleneho pohybu mysi}
      asm
        mov   cx,[ss:xmin]
        mov   dx,[ss:xmax]        {xmin,xmax - hranicne hodnoty}
        shl   cx,1
        shl   dx,1                {uprav suradnice pre 320x200}
        mov   ax,7
        int   33h                 {sluzba 7 - horizontalny rozsah pohybu mysi}
      end;


    procedure SetVerticalRange(ymin,ymax:integer); assembler;
      {nastavi vertikalny rozsah povoleneho pohybu mysi}
      asm
        mov   cx,[ss:ymin]
        mov   dx,[ss:ymax]        {ymin,ymax - hranicne hodnoty}
        mov   ax,8
        int   33h                 {sluzba 7 - vertikalny rozsah pohybu mysi}
      end;


    procedure SetGraphCursorType(gcurtype:tgcurtype);
      {nastavi tvar grafickeho kurzora}
      begin
        asm
          mov   bx,word ptr[ss:gcurtype] {citaj x aktivneho bodu kurzora}
          mov   cx,word ptr[ss:gcurtype+2] {y aktivneho bodu}
          mov   ax,ss
          mov   es,ax
          lea   dx,[gcurtype+4]  {es:dx je smernik na masky}
          mov   ax,9
          int   33h              {sluzba 9 - nastavenie grafickeho kurzora}
        end;
      end;


    procedure SetTextCursorType(tcurtype:ttcurtype);
      {nastavi typ textoveho kurzora}
      begin
        asm
         mov    bl,byte ptr[ss:tcurtype] {bl=0 - soft, bl=1 - hard}
         mov    cx,word ptr[ss:tcurtype+1] {cx:=maska obrazovky/1.riadok HWk}
         mov    dx,word ptr[ss:tcurtype+3] {dx:=maska kurzora/posl.riadok HWk}
         mov    ax,10
         int    33h                {sluzba 10 - nastavenie textoveho kurzora}
        end;
      end;


    procedure GetRelativeMove(var deltax,deltay:integer); assembler;
      {v dx,dy vrati relativnu zmenu polohy mysi (1,0,-1)}
      asm
        mov    ax,11
        int    33h               {sluzba 11 - citanie relativneho pohybu}
        mov    bx,word ptr[ss:deltax]
        mov    [bx],cx           {do deltax zmena horizontalnych suradnic}
        mov    bx,word ptr[ss:deltay]
        mov    [bx],dx           {do deltay zmena vertikalnych}
      end;


{!!! PO POUZITI DEFUSERHANDLER BUDE PROGRAM ASI PADAT !!!}

    procedure DefUserHandler(eventmask:word; phandler:pointer); assembler;
      {definuje uzivatelsku obsluznu rutinu pri urcitej akcii mysi}
      asm
        mov   cx,[ss:eventmask]  {cx=maska udalosti}
        les   dx,[ss:phandler]   {es:dx=smernik na obsluznu rutinu}
        mov   ax,12
        int   33h                {sluzba 12 - definovanie uzivatelskej rutiny}
      end;


    procedure EnableLightPen; assembler;
      {povoli emulaciu svetelneho pera mysou}
      asm
        mov   ax,13
        int   33h                {sluzba 13 - povolenie emulacie s.p.}
      end;


    procedure DisableLightPen; assembler;
      {zakaze emulaciu svetelneho pera mysou}
      asm
        mov   ax,14
        int   33h                {sluzba 14 - zakazanie emulacie s.p.}
      end;


    procedure SetSensitivity(x,y:integer); assembler;
      {nastavi x,y impulzov mysi na 8 bodov v horizontalnom,vertikalnom smere}
      asm
        mov   cx,[ss:x]
        shl   cx,1               {uprav pre 320x200}
        mov   dx,[ss:y]
        mov   ax,15
        int   33h                {sluzba 15 - nastavenie citlivosti mysi}
      end;


    function GetMouseBufSize:word; assembler;
      {vrati velkost pamate potrebnej na uchovanie stavu mysi}
      asm
        mov    ax,21
        int    33h               {sluzba 21 - zistenie velkosti buffra}
        mov    ax,bx             {funkcna hodnota bude v ax}
      end;


    procedure SaveMouseState(pbuf:pointer); assembler;
      {ulozi aktualny stav mysi na adresu pbuf}
      asm
        les    dx,[ss:pbuf]      {es:dx = adresa buffra}
        mov    ax,22
        int    33h               {sluzba 22 - uchovanie stavu mysi}
      end;


    procedure RestoreMouseState(pbuf:pointer); assembler;
      {obnovi aktualny stav mysi z adresu pbuf}
      asm
        les    dx,[ss:pbuf]      {es:dx = adresa buffra}
        mov    ax,23
        int    33h               {sluzba 23 - uchovanie stavu mysi}
      end;


    procedure SetGraphCursorType2(gctype2:tgcurtype2);
      {nastavi typ grafickeho kurzora pre 256 farebny mod}
      begin
        gcurtype2:=gctype2;
      end;


    procedure DrawMouseCursor2(vramseg:word);
      {nakresli kurzor v 256 farebnom mode (1-transparent) typu gcurtype2
       na poziciu kde je teraz mys (zisti si)}
      begin
        TestMouseState;
        asm
          push   ds
          cld
          mov    bx,16           {predpokladane ddy=16}
          mov    dx,16           {a ddx=16}
          mov    si,offset gcurtype2.gcurbitmap
          mov    ax,Seg(gcurtype2.gcurbitmap)
          mov    ds,ax           {ds:si=adresa bitmapy kurzora}

          mov    di,[mcur.y]     {di=y}
          sub    di,[gcurtype2.gactivepoint.y]
          jns    @DyOK           {ak je y horneho okraja dnu OK}
          add    bx,di           {inak uprav ddy}
          neg    di
          shl    di,4            {a adresu bitmapy}
          add    si,di           {prirataj k nej pocet bytov nad obrazovkou}
          xor    di,di           {a y bude 0}
        @DyOK:
          cmp    di,184
          jb     @DyOK2          {ak je y dolneho okraja dnu OK}
          mov    bx,200
          sub    bx,di           {inak ddy bude 200-y horneho okraja}

        @DyOK2:
          shl    di,6
          mov    ax,di
          shl    di,2
          add    di,ax           {di=320*y offset zaciatku riadku vo VRAM}

          mov    cx,[mcur.x]     {cx=x}
          sub    cx,[gcurtype2.gactivepoint.x]
          jns    @DxOK           {ak je x laveho okraja dnu OK}
          add    dx,cx           {inak uprav ddx}
          sub    si,cx           {a adresu bitmapy+byty nalavo od obrazovky}
          xor    cx,cx           {a x bude 0}
        @DxOK:
          cmp    cx,304
          jb     @DxOK2          {ak x praveho okraja dnu OK}
          mov    dx,320
          sub    dx,cx           {inak ddx bude 320-x laveho okraja}
        @DxOK2:
          add    di,cx           {320*y+x offset laveho horneho rohu bitmapy}

          mov    ax,[ss:vramseg] {segment VRAM}
          mov    es,ax           {es:di=adresa laveho rohu bitmapy na obraz.}

          mov    ax,320          {ax=320-ddx tolko treba priratat k offsetu}
          sub    ax,dx           {pre posun na dalsi riadok v obrazovke}
          push   ax              {bude to na ss:[bp-4]}
          sub    ax,304          {ax=16-ddx tolko treba priratat k adrese}
          push   ax              {v bitmape pre posun na dalsi riadok}
                                 {bude na ss:[bp-6]}

        @DYLoop:
          mov    cx,dx           {cx=ddx}

        @DXLoop:
          lodsb                  {citaj bod bitmapy}
          cmp    al,1            {a zisti ci je transparentny}
          je     @TransparentPixel
          stosb                  {ak nie uloz ho do VRAM}
          loop   @DXLoop         {a cykli cely riadok}
          jmp    @DYLoop2        {ked skoncil posun na dalsi}

        @TransparentPixel:
          inc    di              {ak je bod transparentny posun bez zapisu}
          loop   @DXLoop         {a chod na dalsi bod}

        @DYLoop2:
          add    si,[bp-6]       {posun si na dalsi riadok v bitmape}
          add    di,[bp-4]       {posun di na dalsi riadok, kde}
          dec    bx              {sa zacne vypisovat dalsi riadok bitmapy}
          jnz    @DYLoop         {a cykli ddy-krat}

          pop    ax
          pop    ax              {obnov stav zasobnika}
          pop    ds              {a segment premennych}
        end;
      end;

begin
end.
