program Sprite_Editor;

  uses Dos, Crt, Graph13h;

  const windx=50;
        windy=50;

  type sprmap=array[0..65520] of byte;

  var palette:trgbpalette;
      fin,fout:file of byte;
      sprite:^sprmap;
      s:string;
      i,j,sprdx,sprdy,code,curx,cury,winx,winy:word;
      b1,b2,bgc,col:byte;
      key:char;
      edit:boolean;

      palpath,sprpath:pathstr;
      paldir,sprdir:dirstr;
      palname,sprname:namestr;
      palext,sprext:extstr;

  procedure ErrorExit(s:string);
    begin
      WriteLn(s); Halt;
    end;


  procedure DrawEditWindow;
    var i,j,maxx,maxy:word;
    begin
      Bar13h(0,0,windx*4,windy*4,0);
      maxx:=windx-1;
      if winx+maxx>sprdx then maxx:=sprdx-winx-1;
      maxy:=windy-1;
      if winy+maxy>sprdy then maxy:=sprdy-winy-1;
      for i:=0 to maxy do
        for j:=0 to maxx do
          Bar13h(j*4,i*4,j*4+2,i*4+2,sprite^[(i+winy)*sprdx+(winx+j)]);
    end;


  procedure DrawPalette;
    var i,j:integer;
    begin
      for i:=0 to 15 do
        for j:=0 to 15 do
          Bar13h(j*4+256,i*4,j*4+256+2,i*4+2,i shl 4+j);
    end;


  procedure DrawSprite;
    var i,j,maxx,maxy:word;
    begin
      Bar13h(240,120,289,169,0);
      maxx:=windx-1;
      if winx+maxx>sprdx then maxx:=sprdx-winx-1;
      maxy:=windy-1;
      if winy+maxy>sprdy then maxy:=sprdy-winy-1;
      for i:=0 to maxy do
        for j:=0 to maxx do
          PutPixel13h(j+240,i+120,sprite^[(winy+i)*sprdx+(winx+j)]);
    end;


  procedure BlickCur;
    var cx,cy:integer;
    begin
      if edit then
        begin
          cx:=(curx-winx)*4; cy:=(cury-winy)*4;
          Bar13h(cx,cy,cx+2,cy+2,0);
          Delay(2);
          Bar13h(cx,cy,cx+2,cy+2,sprite^[cury*sprdx+curx]);
          Delay(2);
        end
      else
        begin
          cy:=col shr 4*4; cx:=256+col and 15*4;
          Line13h(cx-1,cy-1,cx+3,cy-1,255);
          Line13h(cx-1,cy+3,cx+3,cy+3,255);
          Line13h(cx-1,cy,cx-1,cy+2,255);
          Line13h(cx+3,cy,cx+3,cy+2,255);
          Delay(2);
          Line13h(cx-1,cy-1,cx+3,cy-1,0);
          Line13h(cx-1,cy+3,cx+3,cy+3,0);
          Line13h(cx-1,cy,cx-1,cy+2,0);
          Line13h(cx+3,cy,cx+3,cy+2,0);
          Delay(2);
        end;
    end;


  begin
    sprpath:=''; palpath:='';
    if ParamCount>=1 then
      begin
        sprpath:=ParamStr(1);
        FSplit(sprpath,sprdir,sprname,sprext);
        if sprext='' then sprext:='.spr';
        if sprext<>'.spr' then ErrorExit('Incorrect sprite file');
        sprpath:=sprdir+sprname+sprext;
        Assign(fin,sprpath); Reset(fin);
        Read(fin,b1,b2); sprdx:=b2*256+b1;
        Read(fin,b1,b2); sprdy:=b2*256+b1;
        GetMem(sprite,sprdx*sprdy);
        for i:=0 to sprdy-1 do
          for j:=0 to sprdx-1 do
            Read(fin,sprite^[i*sprdx+j]);
        Close(fin);
        bgc:=1;
      end
    else
      begin
        WriteLn('Enter [path\]name[.spr] of new sprite');
        ReadLn(sprpath);
        FSplit(sprpath,sprdir,sprname,sprext);
        if sprext='' then sprext:='.spr';
        if sprext<>'.spr' then ErrorExit('Incorrect filename for sprite');
        sprpath:=sprdir+sprname+sprext;
        Assign(fout,sprpath); Rewrite(fout); Close(fout);
        WriteLn('Enter dx, dy and background color of new sprite');
        ReadLn(s);
        Val(s,sprdx,code); if code<>0 then ErrorExit('Invalid dx size');
        ReadLn(s);
        Val(s,sprdy,code); if code<>0 then ErrorExit('Invalid dy size');
        ReadLn(s);
        Val(s,bgc,code); if code<>0 then ErrorExit('Invalid background color');
        GetMem(sprite,sprdx*sprdy);
        FillChar(sprite^,sprdx*sprdy,bgc);
      end;

    InitGraph13h;

    if ParamCount>=2 then
      begin
        palpath:=ParamStr(2);
        FSplit(palpath,paldir,palname,palext);
        if palext='' then palext:='.pal';
        if palext<>'.pal' then ErrorExit('Incorrect palette file');
        palpath:=paldir+palname+palext;
        Assign(fin,palpath); Reset(fin);
        for i:=0 to 255 do
          Read(fin,palette[i].r,palette[i].g,palette[i].b);
        Close(fin);
        SetRGBpalette13h(palette);
      end;

    ClearScreen13h(0);

    curx:=0; cury:=0; winx:=0; winy:=0; col:=255; edit:=true;
    DrawEditWindow;
    DrawPalette;
    DrawSprite;

    repeat
      BlickCur; key:=#0;
      if KeyPressed then key:=ReadKey;
    case key of

      #75: if edit then                          {left}
             begin
               if curx>0 then Dec(curx);
               if curx<winx then
                 begin Dec(winx); DrawEditWindow; DrawSprite; end;
             end
           else if col and 15>0 then Dec(col);

      #77: if edit then                          {right}
             begin
               if curx<sprdx-1 then Inc(curx);
               if curx>winx+windx-1 then
                 begin Inc(winx); DrawEditWindow; DrawSprite; end;
             end
           else if col and 15<15 then Inc(col);

      #72: if edit then                          {up}
             begin
               if cury>0 then Dec(cury);
               if cury<winy then
                 begin Dec(winy); DrawEditWindow; DrawSprite; end;
             end
           else if col>15 then Dec(col,16);

      #80: if edit then                          {down}
             begin
               if cury<sprdy-1 then Inc(cury);
               if cury>winy+windy-1 then
                 begin Inc(winy); DrawEditWindow; DrawSprite; end;
             end
           else if col<240 then Inc(col,16);

      #9:  edit:=not edit;                       {tab}

      #32: begin                                 {space}
             if edit then sprite^[cury*sprdx+curx]:=col;
             Bar13h((curx-winx)*4,(cury-winy)*4,(curx-winx)*4+2,
                    (cury-winy)*4+2,col);
             PutPixel13h(240+curx-winx,120+cury-winy,col);
           end;

      #83: begin                                 {del}
             if edit then sprite^[cury*sprdx+curx]:=bgc;
             Bar13h((curx-winx)*4,(cury-winy)*4,(curx-winx)*4+2,
                    (cury-winy)*4+2,bgc);
             PutPixel13h(240+curx-winx,120+cury-winy,bgc);
           end;

      #82: if edit then col:=sprite^[cury*sprdx+curx];

      #13: begin                                 {enter}
             Assign(fout,sprpath); Rewrite(fout);
             b1:=sprdx mod 256; b2:=sprdx div 256; Write(fout,b1,b2);
             b1:=sprdy mod 256; b2:=sprdy div 256; Write(fout,b1,b2);
             for i:=0 to sprdy-1 do
               for j:=0 to sprdx-1 do
                 Write(fout,sprite^[i*sprdx+j]);
             Close(fout);
             Sound(1760); Delay(10); NoSound;
           end;

    end;
    until key=#27;

    CloseGraph13h;
    FreeMem(sprite,sprdx*sprdy);
end.
