
    procedure DrawSpriteAsm(x,y:word; sprite:pspritemaps; ddx,ddy:word);
              far; assembler;
      {vykresli sprite na adrese sprite^, s rozmermi ddx,dy na poziciu x,y}
      asm
        push   ds
        cld

        mov    di,[ss:y]         {di=y}
        shl    di,6
        mov    ax,di
        shl    di,2
        add    di,ax             {di=320*y offset zaciatku riadku vo VRAM}
        add    di,[ss:x]         {320*y+x offset laveho horneho rohu spritu}

        mov    bx,[ss:ddy]       {bx=ddy}
        mov    dx,[ss:ddx]       {dx=ddx}
        mov    ax,[vramseg]      {segment VRAM}
        mov    es,ax             {es:di=adresa laveho rohu spritu na obraz.}

        mov    ax,320            {ax=320-ddx tolko treba priratat k offsetu}
        sub    ax,dx             {pre posun na dalsi riadok spritu}
        push   ax                {bude to na ss:[bp-4]}

        lds    si,[ss:sprite]    {ds:si=adresa sprite}

      @DYLoop:
        mov    cx,dx             {cx=dx}

      @DXLoop:
        lodsb                    {citaj bod spritu}
        cmp    al,transparentcolor {a zisti ci je transparentny}
        je     @TransparentPixel
        stosb                    {ak nie uloz ho do VRAM}
        loop   @DXLoop           {a cykli cely riadok}
        jmp    @DYLoop2          {ked skoncil posun na dalsi}

      @TransparentPixel:
        inc    di                {ak je bod transparentny posun bez zapisu}
        loop   @DXLoop           {a chod na dalsi bod}

      @DYLoop2:
        add    di,[bp-4]         {posun di na dalsi riadok, kde}
        dec    bx                {sa zacne vypisovat dalsi riadok spritu}
        jnz    @DYLoop           {a cykli dy-krat}

        pop    ax                {obnov stav zasobnika}
        pop    ds                {a segment premennych}
      end;


    procedure DrawSpriteAsm2(x,y:word; sprite:pspritemaps; ddx,ddy:word;
                             relcolor:byte); far; assembler;
      {vykresli sprite na adrese sprite^, s rozmermi dx,dy na poziciu x,y a
       ku kazdemu pixelu prirata farbu relcolor}
      asm
        push   ds
        cld

        mov    di,[ss:y]         {di=y}
        shl    di,6
        mov    ax,di
        shl    di,2
        add    di,ax             {di=320*y offset zaciatku riadku vo VRAM}
        add    di,[ss:x]         {320*y+x offset laveho horneho rohu spritu}

        mov    bx,[ss:ddy]       {bx=ddy}
        mov    dx,[ss:ddx]       {dx=ddx}
        mov    ax,[vramseg]      {segment VRAM}
        mov    es,ax             {es:di=adresa laveho rohu spritu na obraz.}

        mov    ax,320            {ax=320-ddx tolko treba priratat k offsetu}
        sub    ax,dx             {pre posun na dalsi riadok spritu}
        push   ax                {bude to na ss:[bp-4]}

        lds    si,[ss:sprite]    {ds:si=adresa sprite}

      @DYLoop:
        mov    cx,dx             {cx=dx}

      @DXLoop:
        lodsb                    {citaj bod spritu}
        cmp    al,transparentcolor {a zisti ci je transparentny}
        je     @TransparentPixel
        and    al,al
        jz     @BlackPixel
        add    al,[ss:relcolor]  {pripocitaj relativnu farbu}
      @BlackPixel:
        stosb                    {ak nie uloz ho do VRAM}
        loop   @DXLoop           {a cykli cely riadok}
        jmp    @DYLoop2          {ked skoncil posun na dalsi}

      @TransparentPixel:
        inc    di                {ak je bod transparentny posun bez zapisu}
        loop   @DXLoop           {a chod na dalsi bod}

      @DYLoop2:
        add    di,[bp-4]         {posun di na dalsi riadok, kde}
        dec    bx                {sa zacne vypisovat dalsi riadok spritu}
        jnz    @DYLoop           {a cykli dy-krat}

        pop    ax                {obnov stav zasobnika}
        pop    ds                {a segment premennych}
      end;


    procedure DrawSpriteAsm3(x,y:integer; sprite:pointer; ddx,ddy:word);
              far; assembler;
      {vykresli spritena adrese sprite^, s rozmermi ddx,dy na poziciu x,y}
      {orezava na obrazovku}
        asm
          push   ds
          cld
          mov    ax,[vramseg]    {segment VRAM}
          mov    es,ax           {es:di=adresa laveho rohu spritu na obraz.}
          mov    bx,[ss:ddy]     {predpokladane ddy}
          mov    dx,[ss:ddx]     {a ddx}
          lds    si,[ss:sprite]  {ds:si=adresa sprite}

          mov    di,[ss:y]       {di=y}
          test   di,di
          jns    @DyOK           {ak sprite trci nad obrazovku}
          add    bx,di           {uprav ddy}
          js     @DrawSpriteAsm3Exit {ak je prilis vysoko, nic sa nekresli}
          jz     @DrawSpriteAsm3Exit
          mov    ax,di
          neg    ax              {inak uprav adresu spritu:}
          mul    dl              {ax=pocet bytov nad obrazovkou}
          add    si,ax           {prirataj k zaciatocnej adrese}
          xor    di,di           {a y bude 0}
        @DyOK:
          cmp    di,200
          jae    @DrawSpriteAsm3Exit {ak je cely sprite pod obr. - koniec}
          lea    ax,[bx+di]      {ax=y+ddy}
          cmp    ax,200          {ak sprite trci pod obrazovku}
          jbe    @DyOK2
          mov    bx,200
          sub    bx,di           {tak ddy bude 200-y}

        @DyOK2:
          shl    di,6
          mov    ax,di
          shl    di,2
          add    di,ax           {di=320*y offset zaciatku riadku vo VRAM}

          mov    cx,[ss:x]       {ax=x}
          test   cx,cx           {ak sprite trci dolava}
          jns    @DxOK
          add    dx,cx           {inak uprav ddx}
          js     @DrawSpriteAsm3Exit {ak je prilis nalavo, koniec}
          jz     @DrawSpriteAsm3Exit
          sub    si,cx           {a k si prirataj |cx|}
          xor    cx,cx           {a x bude 0}
        @DxOK:
          cmp    cx,320
          jae    @DrawSpriteAsm3Exit {ak je cely sprite napravo - koniec}
          mov    ax,cx
          add    ax,dx           {ax=x+ddx}
          cmp    ax,320          {ak sprite trci doprava}
          jbe    @DxOK2
          mov    dx,320
          sub    dx,cx           {tak ddx bude 320-x}
        @DxOK2:
          add    di,cx           {320*y+x offset laveho horneho rohu spritu}

          mov    ax,320          {ax=320-ddx tolko treba priratat k offsetu}
          sub    ax,dx           {pre posun na dalsi riadok v obrazovke}
          push   ax              {bude to na ss:[bp-4]}
          mov    ax,[ss:ddx]     {ax=ddx-ddx' tolko treba priratat k adrese}
          sub    ax,dx           {v sprite pre posun na dalsi riadok}
          push   ax              {bude na ss:[bp-6]}

        @DYLoop:
          mov    cx,dx           {cx=ddx}

        @DXLoop:
          lodsb                  {citaj bod spritu}
          cmp    al,transparentcolor {a zisti ci je transparentny}
          je     @TransparentPixel
          stosb                  {ak nie uloz ho do VRAM}
          loop   @DXLoop         {a cykli cely riadok}
          jmp    @DYLoop2        {ked skoncil posun na dalsi}

        @TransparentPixel:
          inc    di              {ak je bod transparentny posun bez zapisu}
          loop   @DXLoop         {a chod na dalsi bod}

        @DYLoop2:
          add    si,[bp-6]       {posun si na dalsi riadok v sprite}
          add    di,[bp-4]       {posun di na dalsi riadok, kde}
          dec    bx              {sa zacne vypisovat dalsi riadok spritu}
          jnz    @DYLoop         {a cykli ddy-krat}

          pop    ax              {obnov stav zasobnika}
          pop    ax
        @DrawSpriteAsm3Exit:
          pop    ds              {a segment premennych}
        end;



    procedure DrawSpriteAsm23(x,y:integer; sprite:pointer; ddx,ddy:word;
                              relcolor:byte); far; assembler;
      {vykresli spritena adrese sprite^, s rozmermi ddx,dy na poziciu x,y}
      {orezava na obrazovku}
        asm
          push   ds
          cld
          mov    ax,[vramseg]    {segment VRAM}
          mov    es,ax           {es:di=adresa laveho rohu spritu na obraz.}
          mov    bx,[ss:ddy]     {predpokladane ddy}
          mov    dx,[ss:ddx]     {a ddx}
          lds    si,[ss:sprite]  {ds:si=adresa sprite}

          mov    di,[ss:y]       {di=y}
          test   di,di
          jns    @DyOK           {ak sprite trci nad obrazovku}
          add    bx,di           {uprav ddy}
          js     @DrawSpriteAsm3Exit {ak je prilis vysoko, nic sa nekresli}
          jz     @DrawSpriteAsm3Exit
          mov    ax,di
          neg    ax              {inak uprav adresu spritu:}
          mul    dl              {ax=pocet bytov nad obrazovkou}
          add    si,ax           {prirataj k zaciatocnej adrese}
          xor    di,di           {a y bude 0}
        @DyOK:
          cmp    di,200
          jae    @DrawSpriteAsm3Exit {ak je cely sprite pod obr. - koniec}
          lea    ax,[bx+di]      {ax=y+ddy}
          cmp    ax,200          {ak sprite trci pod obrazovku}
          jbe    @DyOK2
          mov    bx,200
          sub    bx,di           {tak ddy bude 200-y}

        @DyOK2:
          shl    di,6
          mov    ax,di
          shl    di,2
          add    di,ax           {di=320*y offset zaciatku riadku vo VRAM}

          mov    cx,[ss:x]       {ax=x}
          test   cx,cx           {ak sprite trci dolava}
          jns    @DxOK
          add    dx,cx           {inak uprav ddx}
          js     @DrawSpriteAsm3Exit {ak je prilis nalavo, koniec}
          jz     @DrawSpriteAsm3Exit
          sub    si,cx           {a k si prirataj |cx|}
          xor    cx,cx           {a x bude 0}
        @DxOK:
          cmp    cx,320
          jae    @DrawSpriteAsm3Exit {ak je cely sprite napravo - koniec}
          mov    ax,cx
          add    ax,dx           {ax=x+ddx}
          cmp    ax,320          {ak sprite trci doprava}
          jbe    @DxOK2
          mov    dx,320
          sub    dx,cx           {tak ddx bude 320-x}
        @DxOK2:
          add    di,cx           {320*y+x offset laveho horneho rohu spritu}

          mov    ax,320          {ax=320-ddx tolko treba priratat k offsetu}
          sub    ax,dx           {pre posun na dalsi riadok v obrazovke}
          push   ax              {bude to na ss:[bp-4]}
          mov    ax,[ss:ddx]     {ax=ddx-ddx' tolko treba priratat k adrese}
          sub    ax,dx           {v sprite pre posun na dalsi riadok}
          push   ax              {bude na ss:[bp-6]}

        @DYLoop:
          mov    cx,dx           {cx=ddx}

        @DXLoop:
          lodsb                  {citaj bod spritu}
          cmp    al,transparentcolor {a zisti ci je transparentny}
          je     @TransparentPixel
          and    al,al
          jz     @BlackPixel
          add    al,[ss:relcolor] {pripocitaj relativnu farbu}
        @BlackPixel:
          stosb                  {ak nie uloz ho do VRAM}
          loop   @DXLoop         {a cykli cely riadok}
          jmp    @DYLoop2        {ked skoncil posun na dalsi}

        @TransparentPixel:
          inc    di              {ak je bod transparentny posun bez zapisu}
          loop   @DXLoop         {a chod na dalsi bod}

        @DYLoop2:
          add    si,[bp-6]       {posun si na dalsi riadok v sprite}
          add    di,[bp-4]       {posun di na dalsi riadok, kde}
          dec    bx              {sa zacne vypisovat dalsi riadok spritu}
          jnz    @DYLoop         {a cykli ddy-krat}

          pop    ax              {obnov stav zasobnika}
          pop    ax
        @DrawSpriteAsm3Exit:
          pop    ds              {a segment premennych}
        end;



  function DispAddr(pvar:pspritemaps; disp:word):pspritemaps;
    begin
      DispAddr:=Ptr(Seg(pvar^),Ofs(pvar^)+disp);
    end;


  procedure DrawBallSprite;
    var dx,dy,d:word;
    begin
      d:=Round(2*transfballradius);
      if d<1 then d:=1;
      Move(DispAddr(ballsprites,ballsprpos[d])^,dx,2);
      Move(DispAddr(ballsprites,ballsprpos[d]+2)^,dy,2);
      DrawSpriteAsm3(projball.x-dx div 2,projball.y-dy div 2,
                    DispAddr(ballsprites,ballsprpos[d]+4),dx,dy);
    end;


  procedure DrawBonus(col:byte);
    var dx,dy,d:word;
    begin
      d:=Round(2*transfbonusradius);
      if d<1 then d:=1;
      Move(DispAddr(bonussprites,bonussprpos[d])^,dx,2);
      Move(DispAddr(bonussprites,bonussprpos[d]+2)^,dy,2);
      DrawSpriteAsm2(projbrickcenter.x-dx div 2,projbrickcenter.y-dy div 2,
                     DispAddr(bonussprites,bonussprpos[d]+4),dx,dy,col-248);

    end;


  procedure DrawMiscSprite(x,y,n:integer);
    var dx,dy:word;
    begin
      Move(DispAddr(miscsprites,miscsprpos[n])^,dx,2);
      Move(DispAddr(miscsprites,miscsprpos[n]+2)^,dy,2);
      DrawSpriteAsm(x,y,DispAddr(miscsprites,miscsprpos[n]+4),dx,dy);
    end;


  procedure DrawMiscSprite2(x,y,n:integer; col:byte);
    var dx,dy:word;
    begin
      Move(DispAddr(miscsprites,miscsprpos[n])^,dx,2);
      Move(DispAddr(miscsprites,miscsprpos[n]+2)^,dy,2);
      DrawSpriteAsm2(x,y,DispAddr(miscsprites,miscsprpos[n]+4),dx,dy,col);
    end;


  procedure DrawMiscSprite3(x,y,n:integer);
    var dx,dy:word;
    begin
      Move(DispAddr(miscsprites,miscsprpos[n])^,dx,2);
      Move(DispAddr(miscsprites,miscsprpos[n]+2)^,dy,2);
      DrawSpriteAsm3(x,y,DispAddr(miscsprites,miscsprpos[n]+4),dx,dy);
    end;


  function WriteCharXY(x,y:integer; ch:char; col:byte):integer;
    var dx,dy:word;
    begin
      if ch<>' ' then
        begin
          Move(DispAddr(fontsprites,fontsprpos[ch])^,dx,2);
          Move(DispAddr(fontsprites,fontsprpos[ch]+2)^,dy,2);
          DrawSpriteAsm2(x,y,
            DispAddr(fontsprites,fontsprpos[ch]+4),dx,dy,col-248);
          WriteCharXY:=dx;
        end
      else WriteCharXY:=8;
    end;


  function WriteCharXY3(x,y:integer; ch:char; col:byte):integer;
    var dx,dy:word;
    begin
      if ch<>' ' then
        begin
          Move(DispAddr(fontsprites,fontsprpos[ch])^,dx,2);
          Move(DispAddr(fontsprites,fontsprpos[ch]+2)^,dy,2);
          DrawSpriteAsm3(x,y,
            DispAddr(fontsprites,fontsprpos[ch]+4),dx,dy);
          WriteCharXY3:=dx;
        end
      else WriteCharXY3:=8;
    end;


  function WriteCharXY23(x,y:integer; ch:char; col:byte):integer;
    var dx,dy:word;
    begin
      if ch<>' ' then
        begin
          Move(DispAddr(fontsprites,fontsprpos[ch])^,dx,2);
          Move(DispAddr(fontsprites,fontsprpos[ch]+2)^,dy,2);
          DrawSpriteAsm23(x,y,
            DispAddr(fontsprites,fontsprpos[ch]+4),dx,dy,col-248);
          WriteCharXY23:=dx;
        end
      else WriteCharXY23:=8;
    end;


  procedure WriteTextXY(x,y:integer; s:string; col:byte);
    var xx,i:integer;

    begin
      xx:=x;
      for i:=1 to Length(s) do
        begin
          Inc(xx,WriteCharXY(xx,y,s[i],col)); Inc(xx,3);
        end;
    end;


  function TextWidth(s:string):word;
    var dx,txtdx,x:word;
        i:integer;
    begin
      txtdx:=0;
      for i:=1 to Length(s) do
        begin
          if s[i]<>' ' then
            Move(DispAddr(fontsprites,fontsprpos[s[i]])^,dx,2)
          else dx:=8;
          Inc(txtdx,dx); Inc(txtdx,3);
        end;
      TextWidth:=txtdx;
    end;


  procedure WriteCenteredText(y:integer; s:string; col:byte);
    var txtdx,x:word;
    begin
        txtdx:=TextWidth(s);
        if txtdx<=323 then x:=(320-(txtdx-3)) div 2
        else x:=0;
        WriteTextXY(x,y,s,col);
    end;


  procedure RLECompress(csprite,sprite:pspritemaps; var csize:word;
                              size:word;var status:word); far; assembler;
    {skompresi sprite v premennej sprite^ a dlzkou size do premennej csprite^
     a dlzky csize metodou Run Length Encoding, do 0. bitu statusu da vysledok
     0/1 ne/skompresene. Vystup sa sklada z postupnosti bytov:
     n,k   ak n in 1..127, koduje postupnost k,k,...,k (n-krat), alebo
     n,k1,k2,...,km   ak n in 128..255, m=n-128 koduje postupnost k1,k2,...,km
    }
    asm
      push   ds
      lds    si,[bp+16]          {ds:si adresa vstupu - sprite}
      les    di,[bp+20]          {es:di adresa vystupu - csprite}
      cld                        {si, di MUSIA byt 0}

      mov    ax,[bp+10]          {dlzka vstupu}
      and    ax,ax
      jz     @RLECExit           {ak dlzka vstupu 0, koniec bez zmeny statusu}



    @RLEC1:
      mov    al,[si]             {citaj 1. byte z predpokladaneho bloku}
                                 {rovnakych bytov}
      mov    cx,[bp+10]          {vezmi dlzku vstupu a odrataj aktualnu}
      sub    cx,si               {poziciu, mas zostavjucu dlzku vstupu}
      cmp    cx,128              {ak je dlhsia ako 127}
      jb     @Scan
      mov    cx,127              {orez ju na 127}

    @Scan:
      mov    bx,cx

    @ScanB:
      cmp    al,[si]             {zisti pocet rovnakych bytov}
      jne    @ScanC              {ako 1. na vstupe (al)}
      inc    si
      loop   @ScanB

    @ScanC:
      sub    bx,cx               {to je bx-cx}

      cmp    bx,1                {ak je to len 1}
      ja     @StoreSameBytes

      dec    si                  {blok od predchadzajuceho bytu}
      jmp    @RLEC2              {sa ulozi ako blok roznych bytov}

    @StoreSameBytes:
      mov    es:[di],bl          {inac zapis na vystup pocet rovnakych bytov}
      inc    di                  {7. bit je 0 - blok rovnakych bytov}
      stosb                      {a hodnotu opakovaneho bytu}

      cmp    di,[bp+10]          {ak je uz dlzka vystupu  ako vstupu}
      jae    @RLECExitN          {skonci so statusom nekompresene}

      cmp    si,[bp+10]          {ak si na konci vstupu}
      je     @RLECExitC          {sprite je skompreseny - skonci}



    @RLEC2:
      push   si                  {uloz zaciatok predpokladaneho bloku roznych}
                                 {bytov}
      mov    cx,[bp+10]          {vezmi dlzku vstupu a odrataj aktualnu}
      sub    cx,si               {poziciu, mas zostavjucu dlzku vstupu}
      cmp    cx,128              {ak je dlhsia ako 127}
      jb     @Scan2
      mov    cx,127              {orez ju na 127}

    @Scan2:
      mov    ah,[si]             {ah bude urcite rozne od}
      dec    ah                  {1. bytu v bloku}

    @Scan2B:
      lodsb                      {citaj byte bloku}
      cmp    al,ah               {porovnaj ho s predchadzajucim, a}
      mov    ah,al               {zapamataj ho ako predchazdajuci pre dalsi}
      loopnz @Scan2B             {kym sa nenajdu 2 rovnake za sebou}
                                 {(alebo sa vycerpa cx)}
      jne    @RLEC2B
      sub    si,2                {ak boli 2 rovnake za sebou}
                                 {nastav koniec bloku na prvy z nich}

    @RLEC2B:
      mov    cx,si               {odrataj od konca bloku}
      pop    si                  {jeho zaciatok}
      sub    cx,si               {a mas dlzku bloku roznych bytov}
      jz     @RLEC1              {ak je 0 skompres odtial ako blok rovnakych}

      or     cl,80h              {7. bit - 0/1 blok rovnakych/roznych}
      mov    es:[di],cl          {uloz pocet nasledujucich roznych bytov}
      inc    di                  {s nastavenym 7. bitom na vystup}
      and    cl,7Fh              {obnov pocet roznych bytov}
      rep    movsb               {a prekopiruj ich tam}

      cmp    di,[bp+10]          {ak je uz dlzka vystupu  ako vstupu}
      jae    @RLECExitN          {skonci so statusom nekompresene}

      cmp    si,[bp+10]          {inac ak nie si na konci vstupu}
      jb     @RLEC1              {skompres zase blok rovnakych bytov}



    @RLECExitC:                  {ak sa vstup skompresil}
      lds    bx,[bp+12]          {zapis dlzku vystupu (v di)}
      mov    [bx],di             {do premennej csize}
      lds    bx,[bp+6]
      or     word ptr[bx],1      {nastav 0. bit statusu na 1}
      jmp    @RLECExit           {a koniec}

    @RLECExitN:
      lds    bx,[bp+6]
      and    word ptr[bx],0FFFEh {ak sa neskompresil}
                                 {nastav 0. bit statusu na 0}
    @RLECExit:
      pop    ds                  {obnov ds a koniec}
    end;



  procedure RLEDecompress(sprite,csprite:pspritemaps; csize:word); far;
              assembler;
    {dekompresi csprite^ s dlzkou csize do sprite^ metodou RLE}
    asm
      push   ds
      lds    si,[bp+8]          {ds:si adresa vstupu - csprite}
      les    di,[bp+12]         {es:di adresa vystupu - sprite}
      cld

      xor    cx,cx
      mov    dx,[bp+6]          {v dx je zostavajuca dlzka vstupu}
      and    dx,dx
      jz     @RLEDExit          {ak dlzka vstupu 0, koniec bez zmeny statusu}


    @RLED:
      mov    cl,[si]            {nacitaj pocet + selektor v 7. bite}
      inc    si
      and    cl,cl              {zisti ci nasleduje blok rovnakych}
      js     @StoreDiffBytes    {alebo roznych bytov}

    @StoreSameBytes:
      lodsb                     {nacitaj opakovany byte}
      rep    stosb              {a uloz ho kolkokrat treba}

      sub    dx,2               {zniz zostavajucu dlzku vstupu o 2 nacitane}
      jnz    @RLED              {byty, a kym nie je koniec dekompres}
      jmp    @RLEDExit          {inac konci}

    @StoreDiffBytes:
      and    cl,7Fh             {odstran selektor, zostane len pocet roznych}
      sub    dx,cx              {zniz o neho zostavajucu dlzku vstupu}
      rep    movsb              {a prekopiruj blok roznych bytov}

      dec    dx                 {zniz zostavajucu dlzku vstupu o 1B - pocet}
      jnz    @RLED              {byty, a kum nie je koniec dekompres}

    @RLEDExit:
      pop    ds
    end;


   var lzwtablesize,
       maptablesize,
       wsize,
       codew,
       nextcode,
       maxnextcode,
       codelength,
       nboffreebits:word;

   const w=8192;

   const cmasktable:array[0..15] of word=(
     $FFFF,$7FFF,$3FFF,$1FFF,$FFF,$7FF,$3FF,$1FF,$FF,$7F,$3F,$1F,$F,$7,$3,$1
                                         );
         cinvmasktable:array[0..15] of word=(
     $0,$8000,$C000,$E000,$F000,$F800,$FC00,$FE00,$FF00,$FF80,$FFC0,$FFE0,
     $FFF0,$FFF8,$FFFC,$FFFE
                                            );


   procedure OutputCodeW; assembler;
     {zapise kod <w> (v premennej codew) na vystup (do csprite), ak vystup
      prekrocil dlzku vstupu, vrati ncf}
     asm
       les    di,[bp+28]         {es:di=adresa konca vystupu}
       mov    ax,[CodeW]
       mov    cx,[NbOfFreeBits]
       sub    cx,[CodeLength]    {zisti kolkokrat treba posunut kod<w> dolava}
       mov    [NbOfFreeBits],cx  {a zapis zostavajuce miesto v tomto worde}
       jc     @CCodeIn2Words     {ak je to zaporne kod sa zapise do 2 wordov}

       shl    ax,cl              {posun kod}
       or     es:[di],ah
       or     es:[di+1],al       {a tesne ho prilep k doterajsiemu vystupu}
       jmp    @CheckOutputSize   {nastav flag na cf}

     @CCodeIn2Words:
       add    word ptr[NbOfFreeBits],16 {pocet volnych bitov v dalsom worde}
       neg    cx                 {kod treba v dworde posut cx-krat doprava}
       mov    si,cx
       shl    si,1               {zisti offset pre cx v maskovacich tabulkach}
       ror    ax,cl

       mov    cx,[si+offset CMaskTable] {maska pre 1. word}
       and    cx,ax              {zisti co patri do 1. wordu}
       or     es:[di],ch
       or     es:[di+1],cl       {a prilep k vystupu}
       add    word ptr[bp+28],2  {posun koniec vystupu}

       mov    cx,[si+offset CInvMaskTable] {maska pre nasledujuci word}
       and    ax,cx
       mov    es:[di+2],ah
       mov    es:[di+3],al       {zapis co patri do nasledujuceho wordu}

     @CheckOutputSize:
       cmp    di,[bp+10]         {zisti ci uz vystup nie je dlhsi ako vstup}
     end;                        {porovnaj so size}



  procedure SearchTable; assembler;
    {zisti, ci sa <w>k nachadza v tabulke, ak ano vrati zf a na es:[di]
     jeho kod, ak nie nzf a bx ukazuje do MapTable, pred ktoru polozku treba
     <w>k vlozit}
     asm
       mov    cx,[WSize]
       push   cx                 {dlzku <w>k na zasobnik}
       mov    dx,[MapTableSize]
       sub    dx,2               {do dx offset poslednej polozky v MapTable}
       mov    ax,[bp+18]
       mov    ds,ax              {ds=segment MapTable a <w>k (buf2)}
       mov    ax,[bp+22]
       mov    es,ax              {es=segment LZWTable (buf1)}
       xor    ax,ax              {do ax offset 1. polozky v MapTable}

     @BinSearch:
       cmp    dx,ax              {ak je offset poslednej polozky mensi ako}
       jl     @SearchTableExit   {1. polozky, <w>k nie je v tabulke - koniec}
                                 {(jl lebo dx moze byt aj -2)}
       mov    si,W               {ds:si=adresa <w>k}
       mov    bx,ax
       add    bx,dx
       rcr    bx,1               {bx=(ax+dx) div 2}
       and    bx,0FFFEh          {uprav offset na zaciatok polozky}

       mov    di,[bx]            {es:di je adresa retazca v LZWTable}
       mov    cx,es:[di]         {vyber dlzku retazca}
       add    di,2               {posun na zaciatok retazca}
       cmp    cx,[bp-6]          {a porovnaj ju s dlzkou <w>k}

       je     @LengthsEqual
       ja     @LengthLZWAboveWK

     @LengthLZWBellowWK:
       repz   cmpsb              {ak |LZW$|<|<w>k| porovnaj retazce}
       jb     @DownerHalfRange   {ak je <w>k < LZW$ chod na dolny podinterval}
       jmp    @UpperHalfRange    {ak  tak na horny}

     @LengthLZWAboveWK:
       mov    cx,[bp-6]          {ak |LZW$|>|<w>k|,porovnaj len spolocnu cast}
       repz   cmpsb              {porovnaj retazce}
       ja     @UpperHalfRange    {ak <w>k > LZW$, chod na horny podinterval}
       jmp    @DownerHalfRange   {ak  tak na dolny}

     @LengthsEqual:
       repz   cmpsb              {ak su dlzky rovnake}
       jz     @SearchTableExit   {a retazce sa zhoduju, nasiel sa - zf}
       ja     @UpperHalfRange    {ak <w>k > LZW$ horny podinterval
                                 {ak < dolny}
     @DownerHalfRange:
       lea    dx,[bx-2]          {posun hornu hranicu pod tento retazec}
       jmp    @BinSearch         {a hladaj v novom intervale}

     @UpperHalfRange:
       lea    ax,[bx+2]          {posun dolnu hranicu nad tento retazec}
       jmp    @BinSearch         {a hladaj v novom intervale}

     @SearchTableExit:
       mov    bx,ax              {pred tuto polozku treba vlozit <w>k}
       pop    cx                 {obnov stav zasobnika}
     end;



  procedure LZWCompress(csprite,sprite,buf1,buf2:pspritemaps; var csize:word;
                        size:word; var status:word); far; assembler;
    {skompresi sprite do csprite (ak sa da), 1.bit statusu 0/1 -
     - ne/skompresene, ak je 1, v csize je dlzka csprite, buf1,buf2 su
     pomocne (64KB) buffre pre LZWTable, MapTable a <w>}
     asm
       push   ds                 {uloz segment premennych}
       cld
       les    di,[bp+28]         {es:di= adresa vystupu (csprite)}
       mov    word ptr es:[di],0 {na vystup daj 0 (kvoli ORovaniu)}
       mov    word ptr[NbOfFreeBits],16 {a nastav 16 volnych bitov vo worde}

       mov    ax,[bp+10]
       test   ax,ax              {ak ma vstup dlzku 0}
       jz     @LZWCExit          {koniec (s nezmenenym statusom}


     @CInitTable:
       pop    ds
       push   ds                 {ds=segment premennych}
       mov    word ptr[LZWTableSize],0 {vyprazdni LZWTable}
       mov    word ptr[MapTableSize],0 {MapTable}
       mov    word ptr[WSize],0  {a <w>:=''}
       mov    word ptr[NextCode],257 {najnizsi kod je 257}
       mov    word ptr[MaxNextCode],512 {po dosiahnuti kodu 512 sa dlzka kodu}
       mov    word ptr[CodeLength],9 {zvysi na 10; dlzka kodu je 9}


       les    si,[bp+24]         {es:si= adresa vstupu}
       mov    al,es:[si]
       xor    ah,ah              {do ax kod 1.znaku}
       inc    word ptr[bp+24]    {a posun citac vstupu}
       mov    dx,[bp+18]
       mov    es,dx              {es=segment <w> (buf2)}
       mov    di,W               {es:di=adresa <w>}
       stosb                     {zapis 1.znak do <w>}
       mov    word ptr[WSize],1  {nastav dlzku <w> na 1}
       mov    [CodeW],ax         {a kod <w> nastav na kod 1.znaku}


     @LZWC1:
       mov    si,[bp+24]         {si=offset vstupu (sprite)}
       cmp    si,[bp+10]         {ak nie je koniec vstupu (size(}
       jb     @CReadInput        {citaj dalsi znak}

       call   OutputCodeW        {inac zapis kod <w>}
       mov    [CodeW],256
       call   OutPutCodeW        {a kod EoF}
       jmp    @LZWCompressed     {a konci}

     @CReadInput:
       les    si,[bp+24]         {es:si=adresa vstupu (sprite)}
       mov    al,es:[si]
       inc    word ptr[bp+24]    {a posun citac vstupu}
       mov    dx,[bp+18]
       mov    es,dx              {es=segment <w> (buf2)}
       mov    di,W
       add    di,[WSize]         {es:di=adresa konca <w>}
       stosb                     {nacitaj znak do k}
       inc    word ptr[WSize]    {zvys dlzku <w> (teraz je to vlastne |<w>k|}


       call   SearchTable        {zisti ci je <w>k v tabulke}
       pop    ds
       push   ds                 {a obnov segment premennych}
       jnz    @WKNotInTable


       mov    ax,es:[di]         {ak ano pridaj k na koniec <w>}
       mov    [CodeW],ax         {tzn. ako kod <W> nastav kod <w>k}
       jmp    @LZWC1             {a dalej citaj vstup}


     @WKNotInTable:
       call   OutputCodeW        {zapis kod <w>}
       jnc    @LZWCExitN

       mov    ax,[WSize]         {ak uz <w>k}
       add    ax,4               {spolu s dlzkou a kodom}
       add    ax,[LZWTableSize]  {nevojde do LZWTable (64KB limit)}
       jnc    @CheckCode         {znova ju inicializuj}


     @CTableFull:
       dec    word ptr[bp+24]    {vrat vstup o 1}
       jmp    @CInitTable        {a odznova inicializuj tabulku}


     @CheckCode:
       mov    ax,[NextCode]      {ak je buduci kod <w> rovnaky ako}
       cmp    ax,4096            {maximalny mozny kod}
       je     @CTableFull        {znova inicializuj tabulku}

       cmp    ax,[MaxNextCode]   {porovnaj s max. kodom pre tuto dlzku kodu}
       jb     @AddWKToTable      {ak je mensi, OK}

       inc    word ptr[CodeLength] {inac zvys dlzku kodu}
       shl    word ptr[MaxNextCode],1 {a nastav maximalny kod pre tuto dlzku}


     @AddWKToTable:
       mov    di,[MapTableSize]  {di ukazuje na koniec MapTable}
       lea    si,[di-2]          {si=offset poslednej polozky}
       mov    cx,[MapTableSize]
       sub    cx,bx              {cx=pocet presuvanych bytov}
       shr    cx,1               {del 2, to je pocet presuvanych wordov}
       mov    ax,[bp+18]
       mov    ds,ax
       mov    es,ax              {ds,es=segment MapTable (buf2)}
       std
       rep    movsw              {posun kazdu polozku od [bx] o 2 byty dalej}
       cld

       pop    ds
       push   ds                 {ds=segment premennych}
       add    word ptr[MapTableSize],2 {zvacsi dlzku MapTable}
       mov    ax,[LZWTableSize]
       mov    es:[bx],ax         {uloz na spravne miesto smernik na pridany}
                                 {retazec}
       mov    ax,[bp+22]
       mov    es,ax              {es=segment LZWTable (buf1)}
       mov    di,[LZWTableSize]  {es:di=adresa konca LZWTable}
       mov    ax,[WSize]
       stosw                     {uloz do LZWTable dlzku retazca}

       mov    si,W               {si=offset <w>}
       mov    cx,[WSize]         {cx=dlzka <w>}
       mov    ax,[bp+18]
       mov    ds,ax              {ds:si=adresa <w>}
       rep    movsb              {zapis <w> hned za jeho dlzku}

       pop    ds
       push   ds                 {ds=segment premennych}
       mov    ax,[NextCode]
       stosw                     {za retazec pridaj jeho kod}
       mov    [LZWTableSize],di  {aktualizuj velkost LZWTable}


       inc    word ptr[NextCode] {zvys nasledujuci kod}

       mov    ax,[bp+18]
       mov    ds,ax              {ds=segment <w> (buf2)}
       mov    ax,[si-1]          {vloz k do <w>}
       xor    ah,ah              {v ax je sucasne kod k}
       mov    [W],al             {tzn. posledny znak <w> presun na zaciatok}
       pop    ds
       push   ds                 {ds=segment premennych}
       mov    word ptr[WSize],1  {a nastav dlzku <w> na 1}
       mov    [CodeW],ax         {kod <w> je kod k}
       jmp    @LZWC1             {a dalej citaj vstup}


     @LZWCompressed:
       mov    ax,[bp+28]         {ax=posledny word vystupu}
       add    ax,2               {ak je z tohoto wordu volnych aspon 8 bitov}
       shr    [NbOfFreeBits],4   {prirataj k dlzke vstupu 1}
       sbb    ax,0               {ak menej prirataj 2}

       cmp    ax,[bp+10]         {ak je dlzka vystupu vacsiarovna ako (size)}
       jae    @LZWCExitN         {dlzka vstupu, neskompresene}

     @LZWCExitC:
       les    bx,[bp+12]         {inac es:bx=adresa csize}
       mov    es:[bx],ax         {zapis dlzku vystupu}
       les    bx,[bp+6]          {es:bx=adresa statusu}
       or     word ptr es:[bx],2 {nastav 1.bit statusu}
       jmp    @LZWCExit          {a koniec}

     @LZWCExitN:
       les    bx,[bp+6]          {ak je neskompresene es:bx=adresa statusu}
       and    word ptr es:[bx],253 {nuluj 1.bit statusu}

     @LZWCExit:
       pop    ds                 {obnov ds}
     end;



  {
   Pri dekompresii tabulka MapTable obsahuje na adrese 2*n smernik do tabulky
   LZWTable na retazec s kodom n. To plati len pre kody retazcov (n257), teda
   prvych 514 bytov tabuly MapTable je nevyuzitych. Retazec s kodom n<256 je
   char(n). Kod 256 je EoF. Tabulka LZWTable obsahuje dvojice tvaru: dlzka
   retazca (word) a samotny retazec.
  }

  {
   var lzwtablesize,
       maptablesize,
       nextcode,
       maxnextcode,
       codelength,
       nboffreebits:word;
  }
   var incode,
       oldcode:word;
  {
   const w=8192;
  }
  const dmasktable:array[0..15] of word=(
    $0,$1,$3,$7,$F,$1F,$3F,$7F,$FF,$1FF,$3FF,$7FF,$FFF,$1FFF,$3FFF,$7FFF
                                         );

  procedure InputInCode; assembler;
    {nacita kod zo vstupu do incode, ak je koniec vstupu, vrati zf}
    asm
      les    si,[bp+14]          {es:di je adresa vstupu (csprite)}
      mov    ah,es:[si]
      mov    al,es:[si+1]        {citaj word zo vstupu do ahal}

      mov    cx,[NbOfFreeBits]   {zisti kolkokrat treba}
      sub    cx,[CodeLength]     {posunut kod doprava}
      mov    [NbOfFreeBits],cx   {a zapis zostavajuci pocet volnych bitov}
      jc     @DCodeIn2Words      {ak je zaporny, kod lezi v 2 wordoch}

      shr    ax,cl               {inac v jedom worde, posun kod}
      mov    si,[CodeLength]
      shl    si,1                {a nechaj len tolko jeho spodnych bitov}
      and    ax,[si+offset DMaskTable] {kolko je aktualna dlzka kodu}
      jmp    @InputExit          {koniec}

    @DCodeIn2Words:
      add    word ptr[bp+14],2   {posun citac vstupu (csprite)}
      add    word ptr[NbOfFreeBits],16 {oprav volne bitov v dalsom worde}

      neg    cx                  {kod treba posunut cx krat dolava}
      shl    ax,cl               {posun a dole pridaj nuly}
      mov    dh,es:[si+2]        {citaj dalsi word zo vstupu}
      mov    dl,es:[si+3]        {do dhdl}
      rol    dx,cl               {bity tohoto kodu presun do najnizsich bitov}

      mov    si,cx
      shl    si,1
      and    dx,[si+offset DMaskTable] {a maskuj, v dx zostanu len bity kodu}
      or     ax,dx               {pridaj k hornym bitom kodu}

      mov    si,[CodeLength]     {a maskuj podla dlzky kodu}
      shl    si,1                {cim sa odstrania horne bity ax}
      and    ax,[si+offset DmaskTable] {nepatriace kodu}

    @InputExit:
      cmp    ax,256              {zisti, ci nenacital kod EoF}
    end;


  procedure OutputOldCodeString; assembler;
    {zapise na vystup retazec prisluchajuci oldcode}
    asm
      les    di,[bp+18]          {es:di = adresa vystupu (sprite)}
      mov    bx,[OldCode]
      cmp    bx,256              {ak je oldcode kodom retazca}
      jae    @String             {prekopiruj na vystup retazec z LZWTable}

    @Char:
      mov    es:[di],bl          {inac zapis znak, ktoreho kodom ke oldcode}
      inc    word ptr[bp+18]     {posun citac vystupu}
      jmp    @OutputOldCodeStringExit {a koniec}

    @String:
      shl    bx,1                {zisti offset smernika retazca v MapTable}
      mov    ax,[bp+8]
      mov    ds,ax               {ds = Seg(MapTable) (buf2)}
      mov    si,[bx]             {vyber offset retazca v LZWTable}
      mov    ax,[bp+12]
      mov    ds,ax               {ds:si = adresa retazca v LZWTable}
      mov    cx,[si]             {vyber dlzku retazca}
      add    si,2
      rep    movsb               {a prekopiruj ho}

      mov    [bp+18],di          {posun citac vystupu}

    @OutputOldCodeStringExit:    {koniec}
    end;


  function LZWDecompress(sprite,csprite,buf1,buf2:pspritemaps):word;
            far; assembler;
    {dekompresi csprite do sprite, v csize je dlzka csprite, buf1,buf2 su
     pomocne (64KB) buffre pre LZWTable a MapTable}
    asm
      push   ds                  {uloz segment premennych}
      cld
      mov    word ptr[NbOfFreeBits],16 {a nastav 16 volnych bitov na vstupe}

    @DInitTable:
      pop    ds
      push   ds                  {ds=segment premennych}
      mov    word ptr[LZWTableSize],0 {vyprazdni LZWTable}
      mov    word ptr[MapTableSize],257*2 {a v MapTable nechaj len znaky}
      mov    word ptr[NextCode],257 {najmensi kod retazca je 257}
      mov    word ptr[MaxNextCode],512 {pri tomto kode sa zvysi jeho dlzka}
      mov    word ptr[CodeLength],9 {najkratsi kod ma dlzku 9}

      call   InputInCode         {citaj prvy vstupny kod}
      jz     @LZWDecompressed     {ak je to EoF, koniec}
      mov    [OldCode],ax        {inac ho uloz do oldcode}


    @LZWD1:
      call   OutputOldCodeString {zapis retazec k oldcode na vystup}


      pop    ds
      push   ds                  {ds=segment premennych}
      mov    ax,[NextCode]       {ak este je miesto v tabulke}
      cmp    ax,4096             {tzn. kod, ktory sa teraz zaradi je mensi}
      jb     @CheckCodeLength    {ako maximalny mozny kod, citaj vstup}

    @DTableFull:
      jmp    @DInitTable         {a odznova inicializuj tabulku}

    @CheckCodeLength:
      cmp    ax,[MaxNextCode]    {ak je kod mensirovny ako maximalny kod pre}
      jb     @ReadInput          {tuto dlzku kodu, OK}

      inc    word ptr[CodeLength] {inac zvacsi dlzku kodu}
      shl    word ptr[MaxNextCode],1 {a zdvojnasob jej maximalny kod}


    @ReadInput:
      call   InputInCode         {citaj vstupny kod}
      jz     @LZWDecompressed    {ak je koniec vstupu, dekompresene}
      mov    [InCode],ax         {inac vloz vstupny kod do incode}


      mov    di,[LZWTableSize]   {vezmi koniec LZWTable, to bude}
      mov    bx,[MapTableSize]   {pozicia pridaneho retazca v LZWTable}
      mov    ax,[bp+8]
      mov    es,ax               {es:bx=adresa smernika na pridavany retazec}
      mov    es:[bx],di          {zapis poziciu do MapTable}

      mov    bx,[OldCode]

      mov    dx,[InCode]         {ak je incode v tabulke}
      cmp    dx,[NextCode]       {tzn. incode<najmensi volny kod}
      jae    @InCodeNotInTable


    @InCodeInTable:
      cmp    bx,256              {zisti, ci je v oldcode}
      jae    @IStringOldCode     {kod retazca alebo znaku}

    @ICharOldCode:
      add    word ptr[LZWTableSize],4 {ak znaku, zisti ci do LZWTable vojdu}
      jc     @DTableFull         {2 byty dlzky+2 znaky, ak nie vyprazdni ju}

      mov    ax,[bp+12]
      mov    es,ax               {es:di=adresa konca LZWTable (buf1)}
      mov    word ptr es:[di],2  {uloz dlzku pridaneho retazca}
      add    di,2
      mov    es:[di],bl          {uloz znak k oldcode}
      inc    di
      jmp    @AddInCode1stChar   {a uloz 1.znak k incode}

    @IStringOldCode:
      shl    bx,1                {ak je v oldcode kod retazca}
      mov    si,es:[bx]          {vezmi jeho smernik do LZWTable}
      mov    bx,[bp+12]
      mov    es,bx               {es=segment LZWTable (buf1)}
      mov    cx,es:[si]          {vezmi dlzku retazca k oldcode}
      add    si,2

      mov    ax,cx
      add    ax,3                {2 byty dlzky + 1.znak incode}
      add    [LZWTableSize],ax   {+dlzka retazca}
      jc     @DTableFull         {nevojdu do LZWTable, vyprazdni ju}

      inc    cx
      mov    es:[di],cx          {inac uloz dlzku pridaneho retazca}
      add    di,2
      dec    cx
      mov    ds,bx               {ds=segment LZWTable (buf1)}
      rep    movsb               {a prekopiruj sem retazec k oldcode}

    @AddInCode1stChar:
      cmp    dx,256              {ak je retazec k incode znak}
      jae    @StringInCode

    @CharInCode:
      mov    es:[di],dl          {uloz ho na koniec pridavaneho retazca}
      jmp    @IncreaseTableSize  {a zvacsi dlzku tabulky MapTable}

    @StringInCode:
      mov    ax,[bp+8]           {inac}
      mov    ds,ax               {ds=segment MapTable (buf2)}
      mov    bx,dx
      shl    bx,1
      mov    si,[bx]             {es:si=adresa retazca k incode v LZWTable}
      mov    al,es:[si+2]        {vyber jeho 1.znak}
      stosb                      {pridaj na koniec pridaneho retazca}
      jmp    @IncreaseTableSize  {a zvacsi dlzku tabulky MapTable}


    @InCodeNotInTable:
      cmp    bx,256              {zisti ci je oldcode}
      jae    @NStringOldCode     {kodom znaku alebo retazca}

    @NCharOldCode:
      add    word ptr[LZWTableSize],4 {ak znaku, zisti ci do LZWTable vojdu}
      jc     @DTableFull         {2 byty dlzky+2 znaky, ak nie vyprazdni ju}

      mov    ax,[bp+12]
      mov    es,ax               {es:di=adresa konca LZWTable (buf1)}
      mov    word ptr es:[di],2  {uloz dlzku pridaneho retazca}
      add    di,2
      mov    es:[di],bl          {uloz znak k oldcode}
      mov    es:[di+1],bl        {+jeho prvy znak}
      jmp    @IncreaseTableSize  {a zvacsi dlzku MapTable}

    @NStringOldCode:
      shl    bx,1                {ak je v oldcode kod retazca}
      mov    si,es:[bx]          {vezmi jeho smernik do LZWTable}
      mov    bx,[bp+12]
      mov    es,bx               {ds,es=segment LZWTable (buf1)}
      mov    cx,es:[si]          {vezmi dlzku retazca k oldcode}
      add    si,2

      mov    ax,cx
      add    ax,3                {2 byty dlzky + 1.znak incode}
      add    [LZWTableSize],ax   {+dlzka retazca}
      jc     @DTableFull         {nevojdu do LZWTable, vyprazdni ju}

      inc    cx
      mov    es:[di],cx          {inac uloz dlzku pridaneho retzaca}
      add    di,2
      dec    cx
      mov    ds,bx               {ds=segment LZWTable (buf1)}
      mov    al,[si]             {vezmi prvy znak retazca k oldcode}
      rep    movsb               {a prekopiruj sem retazec k oldcode}
      stosb                      {a pridaj jeho prvy znak}


    @IncreaseTableSize:
      pop    ds
      push   ds                  {ds=segment premennych}
      add    word ptr[MapTableSize],2 {zvacsi dlzku MapTable}
      inc    word ptr[NextCode]  {a zvys nasledujuci kod}


      mov    ax,[InCode]
      mov    [OldCode],ax        {do oldcode vloz incode}
      jmp    @LZWD1              {a dalej citaj vstup}


    @LZWDecompressed:
      pop    ds                  {obnov segment premennych a koniec}
      mov    ax,word ptr[ss:sprite]
    end;


  procedure GetMem0(var pvar:pointer; size:word; var key:pbyte);
    begin
      key:=nil; GetMem(pvar,size);
      while Ofs(pvar^)<>0 do
        begin FreeMem(pvar,size); New(key); GetMem(pvar,size); end;
    end;


  procedure FreeMem0(pvar:pointer; size:word; key:pbyte);
    begin
      if key<>nil then Dispose(key);
      FreeMem(pvar,size);
    end;


  procedure DecompressSprites(sprite,csprite:pspritemaps;
                              status,size,csize:word);
    {dekompresi sprite na csprite^ do sprite^, so status-om a dlzkou csize}
    var buf1,buf2,buf3:pspritemaps;
        p1,p2,p3:pbyte;
        lcsize:word;
    begin
      if status<>0 then
        begin
          case status and 3 of
            3: begin
                 GetMem0(pointer(buf3),size,p3);
                 GetMem0(pointer(buf1),65520,p1);
                 GetMem0(pointer(buf2),65520,p2);
                 lcsize:=LZWDecompress(buf3,csprite,buf1,buf2);
                 FreeMem0(buf2,65520,p2); FreeMem0(buf1,65520,p1);
                 RLEDecompress(sprite,buf3,lcsize);
                 FreeMem0(pointer(buf3),size,p3);
               end;

            2: begin
                 GetMem0(pointer(buf1),65520,p1);
                 GetMem0(pointer(buf2),65520,p2);
                 LZWDecompress(sprite,csprite,buf1,buf2);
                 FreeMem0(buf2,65520,p2); FreeMem0(buf1,65520,p1);
               end;
            1: RLEDecompress(sprite,csprite,csize);
          end;
        end
      else Move(csprite,sprite,csize);
    end;


  procedure LoadBlock(var fin:file; sprite:pspritemaps);
    {nacita blok spritov z aktualnej pozicie vo fin(.csp) archive na sprite^
     a dekompresi ich}
     var size,csize,status,w:word;
         csprite:pspritemaps;
         p:pbyte;
    begin
      BlockRead(fin,size,2); BlockRead(fin,w,2);
      BlockRead(fin,csize,2); BlockRead(fin,w,2);
      BlockRead(fin,status,2);
      if status=0 then BlockRead(fin,sprite^,size)
      else
        begin
          GetMem0(pointer(csprite),csize,p);
          BlockRead(fin,csprite^,csize);
          DecompressSprites(sprite,csprite,status,size,csize);
          FreeMem0(csprite,csize,p);
        end;
    end;


  procedure LoadSprites;
    {nacita sprity zo suboru s menom spritefilename(.csp) na sprites^ (aj
     dekompresi)}
    var fin:file;
    begin
      Assign(fin,spritesfilename); Reset(fin,1);
      Seek(fin,61);
      GetMem0(pointer(ballsprites),13442,ballsprkey);
      LoadBlock(fin,ballsprites);
      GetMem0(pointer(miscsprites),16514,miscsprkey);
      LoadBlock(fin,miscsprites);
      GetMem0(pointer(bonussprites),1766,bonussprkey);
      LoadBlock(fin,bonussprites);
      GetMem0(pointer(fontsprites),10834,fontsprkey);
      LoadBlock(fin,fontsprites);
      Close(fin);
    end;
