program Sprite_grabber_and_ball_sprites_renderer;

  uses Crt,Graph13h;

  type tvector=record
                 x,y,z:real;
               end;

  const lightvector:tvector=(x:-4; y:2; z:2);

  {$I palette.inc}


  procedure VRMul(var u,v:tvector; r:real);
    {vynasobi vektor v realnym cislom r a vysledok ulozi do u}
    begin
      u.x:=r*v.x;
      u.y:=r*v.y;
      u.z:=r*v.z;
    end;


  function VLength(var u:tvector):real;
    {vypocita dlzku vektora}
    begin
      VLength:=Sqrt(Sqr(u.x)+Sqr(u.y)+Sqr(u.z));
    end;


  function VDotProduct(var u,v:tvector):real;
    {vypocita skalarny sucin vektorov u,v}
    begin
      VDotProduct:=u.x*v.x+u.y*v.y+u.z*v.z;
    end;


    function VCosAngle(var u,v:tvector):real;
    {vypocita kosinus uhla medzi vektormi u,v}
    begin
      VCosAngle:=VDotProduct(u,v)/(VLength(u)*VLength(v));
    end;


  function PointShade(x,y,d:real):real;
    {urci odtien bodu na suradniciach x,y}
    var normal:tvector;
        shade:real;
    begin
      normal.x:=2*x; normal.y:=2*y;
      normal.z:=-(Sqrt(Sqr(d)-Sqr(x)-Sqr(y)));
      VRMul(normal,normal,-1);
      shade:=VCosAngle(normal,lightvector);
      if shade>0 then PointShade:=shade*11.99999
      else PointShade:=0;
    end;


  procedure DrawBall(sx,sy,d:integer);
    var a,b,x,y:real;
        i,j:integer;
    begin
      a:=1.2*d/2; b:=d/2;
      for i:=0 to 100 do
        begin
          x:=a*Cos(i/100*2*Pi);
          for j:=-Trunc(x) to Trunc(x) do
            begin
              y:=b*Sin(i/100*2*Pi);
              PutPixel13h(j+sx,Trunc(y)+sy,244+Trunc(PointShade(j,y,d)));
            end;
        end;
    end;


  procedure DrawFrame(x,y,dx,dy:integer);
    var i,c:integer;
    begin
      for i:=x to x+dx-1 do
        begin
          XorPixel13h(i,y,151);
          if dy>1 then
            XorPixel13h(i,y+dy-1,151);
        end;
      for i:=y+1 to y+dy-2 do
        begin
          XorPixel13h(x,i,151);
          XorPixel13h(x+dx-1,i,151);
        end;
    end;


  var i,j,x,y,dx,dy,count:integer;
      s:string;
      fout:file of byte;
      key:char;
      b1,b2,c:byte;

  begin
    InitGraph13h; SetActivePage13h($A000); SetRGBPalette13h(palette);
    ClearScreen13h(1);
    for i:=1 to 32 do
      DrawBall((i-1) mod 7*46+20,(i-1) div 7*40+10,i);
    dx:=16; dy:=16; x:=160; y:=100; count:=1;
    DrawFrame(x,y,dx,dy);
    repeat
      key:=ReadKey;
      DrawFrame(x,y,dx,dy);
      case key of
        'q':if y>0 then Dec(y);
        'a':if y+dy-1<199 then Inc(y);
        'o':if x>0 then Dec(x);
        'p':if x+dx-1<319 then Inc(x);
        'Q':if dy>1 then
              begin
                Dec(dy);
                Sound(1760); Delay(5); NoSound;
              end;
        'A':if y+dy-1<199 then
              begin
                Inc(dy);
                Sound(1760); Delay(5); NoSound;
              end;
        'O':if dx>1 then
              begin
                Dec(dx);
                Sound(1760); Delay(5); NoSound;
              end;
        'P':if x+dx-1<319 then
              begin
                Inc(dx);
                Sound(1760); Delay(5); NoSound;
              end;
        #13:begin
              Str(count,s); s:='ball'+s+'.spr';
              Assign(fout,s); Rewrite(fout);
              b1:=dx mod 256; b2:=dx div 256; Write(fout,b1,b2);
              b1:=dy mod 256; b2:=dy div 256; Write(fout,b1,b2);
              for i:=y to y+dy-1 do
                for j:=x to x+dx-1 do
                  begin c:=GetPixel13h(j,i); Write(fout,c); end;
              Close(fout);
              Sound(880); Delay(20); NoSound;
              Inc(count);
            end;
        #83:begin
              if count>1 then Dec(count);
              Sound(440); Delay(20); NoSound;
            end;

      end;
      DrawFrame(x,y,dx,dy);
    until key=#27;
    CloseGraph13h;
  end.
